<?php

namespace App\Http\Controllers\Api\v1;

use App\Http\Controllers\Controller;
use App\Models\Cart;
use App\Models\CouponCategory;
use App\Models\CouponHistory;
use App\Models\Coupons;
use App\Models\OrderModel;
use App\Models\OrderProductsModel;
use App\Models\ProductModel;
use App\Models\SettingsModel;
use App\Models\User;
use App\Models\UserAdress;
use Illuminate\Http\Request;
use Kreait\Firebase\Contract\Database;
use App\Rules\ValidateCouponCode;
use Validator;
use App\Classes\MCart;

class CartController extends Controller
{
    public function __construct(Database $database)
    {
        $this->database = $database;
    }
    private function getUserId($access_token){
        $user_id = 0;
        $user = User::where(['user_access_token' => $access_token])->where('user_access_token','!=','')->get();
        if($user->count()>0){
            $user_id = $user->first()->id;
        }
        return $user_id;
    }
    private function validateAccesToken($access_token)
    {

        $user = User::where(['user_access_token' => $access_token])->get();

        if ($user->count() == 0) {
            http_response_code(401);
            echo json_encode([
                'status' => "0",
                'message' => 'Invalid login',
                'oData' => (object)[],
                'errors' => (object) [],
            ]);
            exit;

        } else {
            $user = $user->first();
            if ($user !=null) {//$user->active == 1
                return $user->id;
            } else {
                http_response_code(401);
                echo json_encode([
                    'status' => "0",
                    'message' => 'Invalid login',
                    'oData' => (object)[],
                    'errors' => (object) [],
                ]);
                exit;
                return response()->json([
                    'status' => "0",
                    'message' => 'Invalid login',
                    'oData' => [],
                    'errors' => (object) [],
                ], 401);
                exit;
            }
        }
    }
    public function add_to_cart(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'product_id' => 'required|numeric|min:0|not_in:0',
            'product_variant_id' => 'required|numeric|min:0|not_in:0',
            'store_id' => 'required|numeric|min:0|not_in:0',
            'device_cart_id'=>'required',
            'quantity' => 'required'
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->getUserId($request->access_token);
            $product_id = $request->product_id;
            $store_id = $request->store_id;
            $product_variant_id = $request->product_variant_id;
            $cart_cehck = Cart::where('store_id','!=',$store_id);
            if($user_id > 0){
                $cart_cehck = $cart_cehck->where(['user_id'=>$user_id]);
            }else{
                $cart_cehck = $cart_cehck->where(['device_cart_id'=>$request->device_cart_id]);
            }
            $cart_cehck = $cart_cehck->get();

            if($cart_cehck->count() > 0){
                $status = "4";
                $message = "Your cart contains product of another shop. Please clear your cart and continue";
            }else{
                list($product_status, $product_data, $message) = ProductModel::getProductVariant($product_id, $product_variant_id);
                $quantity = $request->quantity??1;
                $update_quantity = $request->update_quantity??1;
                

                if ($product_status && !empty($product_data)) {

                    $cart_key = '';

                    $i_data['user_id'] = $user_id;
                    $i_data['product_id'] = $product_id;
                    $i_data['product_attribute_id'] = (int) $product_variant_id;
                    $i_data['quantity'] = $quantity;
                    $i_data['store_id'] = $store_id;
                    $i_data['device_cart_id'] = $request->device_cart_id;
                    $i_data['created_at'] = gmdate("Y-m-d H:i:s");
                    

                    $in_stock = $product_data->stock_quantity;

                    $cart_condition = [];
                    $cart_condition = [
                        "product_id" => $i_data['product_id'],
                        "product_attribute_id" => $i_data['product_attribute_id'],
                        
                    ];
                    if($user_id){
                        $cart_condition['user_id'] = $user_id;
                    }else{
                        $cart_condition['user_id'] = 0;
                        $cart_condition['device_cart_id'] = $request->device_cart_id;
                    }
                    $product_cart_data = Cart::get_user_cart($cart_condition);
                    
                    if (count($product_cart_data)) {
                        $status = "";

                        if (count($product_cart_data) == 1) {
                            $product_cart_data = $product_cart_data[0];
                            if($update_quantity == 1){
                                $quantity = $quantity + $product_cart_data->quantity;
                            }
                            if (($quantity <= $in_stock) || ($product_data->allow_back_order == 1)) {
                                
                                $up['quantity'] = $quantity;
                            

                                Cart::update_cart($up, ["id" => $product_cart_data->id]);

                                $status = "1";
                                $message = "Product added to your cart";

                            } else {
                                $status = "3";
                                $message = "Unable to increase the product quantity beacuse you reached maximum level of stock";
                            }
                        } else {
                            $status = "3";
                            $message = 'This item has multiple customizations added. Increase the correct item from the cart';
                        }

                    } else {
                        if (($quantity <= $in_stock) || ($product_data->allow_back_order == 1)) {
                            Cart::create_cart($i_data);
                            $status = "1";
                            $message = "Product added to your cart";
                        } else {
                            $status = "3";
                            $message = "Unable to add product to cart due to limited stock";
                        }
                    }

                    $cartObj = new MCart();
                    $cartObj->device_cart_id = $request->device_cart_id;
                    $cartObj->user_id = $user_id;

                    $o_data['cart_items'] = convert_all_elements_to_string($cartObj->get_cart());
                    $o_data['cart_total'] = (string) $cartObj->item_total;
                    $o_data['cart_count'] = (string) count($o_data['cart_items']);
                    $o_data['delivery_charge'] = '0';
                    $o_data['grand_total'] = (string)$cartObj->grand_total;
                    $o_data['currency_code'] = config('global.default_currency_code');
                    $status = $status ?? "1";

                } else {
                    $status = "3";
                    $message = 'No product exists';
                }
            }

        }
        return response()->json(['status' => $status, 'errors' =>(object) $errors, 'message' => $message, 'oData' => (object)$o_data], 200);
    }
    public function reduce_cart(Request $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'product_id' => 'required|numeric|min:0|not_in:0',
            'product_variant_id' => 'required|numeric|min:0|not_in:0',
            'store_id' => 'required|numeric|min:0|not_in:0',
            'device_cart_id'=>'required',
            'quantity' => 'required'
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->getUserId($request->access_token);
            $product_id = $request->product_id;
            $store_id = $request->store_id;
            $product_variant_id = $request->product_variant_id;
            $cart_cehck = Cart::where('store_id','!=',$store_id);
            if($user_id > 0){
                $cart_cehck = $cart_cehck->where(['user_id'=>$user_id]);
            }else{
                $cart_cehck = $cart_cehck->where(['device_cart_id'=>$request->device_cart_id]);
            }
            $cart_cehck = $cart_cehck->get();
            if($cart_cehck->count() > 0){
                $status = "4";
                $message = "Your cart contains product of another shop. Please clear your cart and continue";
            }else{
                list($product_status, $product_data, $message) = ProductModel::getProductVariant($product_id, $product_variant_id);
                $quantity = $request->quantity??1;
                $update_quantity = $request->update_quantity??1;
                

                if ($product_status && !empty($product_data)) {

                    $cart_key = '';

                    $in_stock = $product_data->stock_quantity;

                    $cart_condition = [];
                    $cart_condition = [
                        "product_id" => $request->product_id,
                        "product_attribute_id" => $request->product_variant_id,
                        
                    ];
                    if($user_id){
                        $cart_condition['user_id'] = $user_id;
                    }else{
                        $cart_condition['user_id'] = 0;
                        $cart_condition['device_cart_id'] = $request->device_cart_id;
                    }
                    $product_cart_data = Cart::get_user_cart($cart_condition);
                    
                    if (count($product_cart_data)) {
                        $status = "";

                            $product_cart_data = $product_cart_data[0];
                            $quantity =  $product_cart_data->quantity - $quantity;
                            if($quantity < 1){
                                Cart::where(["id" => $product_cart_data->id])->delete();
                                $status = "1";
                                $message = "product removed from cart";
                            }else{
                                if (($quantity <= $in_stock) || ($product_data->allow_back_order == 1)) {
                                    $up['quantity'] = $quantity;
                                }else{
                                    $up['quantity'] = $in_stock;
                                }
                                Cart::update_cart($up, ["id" => $product_cart_data->id]);
                                $status = "1";
                                $message = "cart updated successfully";
                            }

                    } else {
                        $message = "Invalid request";
                    }

                    

                } else {
                    $status = "3";
                    $message = 'No product exists';
                }
            }
            $cartObj = new MCart();
            $cartObj->device_cart_id = $request->device_cart_id;
            $cartObj->user_id = $user_id;

            $o_data['cart_items'] = convert_all_elements_to_string($cartObj->get_cart());
            $o_data['cart_total'] = (string) $cartObj->item_total;
            $o_data['cart_count'] = (string) count($o_data['cart_items']);
            $o_data['delivery_charge'] = '0';
            $o_data['grand_total'] = (string)$cartObj->grand_total;
            $o_data['currency_code'] = config('global.default_currency_code');
        }
        return response()->json(['status' => $status, 'errors' =>(object) $errors, 'message' => $message, 'oData' => (object)$o_data], 200);
    }
    public function get_cart(Request $request)
    {
        $status = "1";
        $message = "";
        $o_data = [];
        $errors = [];
        $validator = Validator::make($request->all(), [
            'device_cart_id' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->getUserId($request->access_token);
            $device_cart_id = $request->device_cart_id;
            $cartObj = new MCart();
            $cartObj->device_cart_id = $device_cart_id;
            $cartObj->user_id = $user_id;

            $o_data['cart_items'] = convert_all_elements_to_string($cartObj->get_cart());
            $o_data['cart_total'] = (string) $cartObj->item_total;
            $o_data['cart_count'] = (string) count($o_data['cart_items']);
            $o_data['delivery_charge'] = '0';
            $o_data['grand_total'] = (string)$cartObj->grand_total;
            $o_data['currency_code'] = config('global.default_currency_code');
        }

        return response()->json(['status' => (string)$status, 'message' => $message, 'errors' => (object)$errors, 'oData' => (object)$o_data]);
    }
    public function checkout_old(Request $request)
    {
        $status = "1";
        $message = "";
        $o_data = [];
        $errors = [];
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $o_data = $this->process_cart($user_id);
            $o_data['default_address'] = UserAdress::get_user_default_address($user_id);
            $o_data['address_list'] = UserAdress::get_address_list($user_id);
        }

        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data]);
    }
    public function checkout(Request $request)
    {
        $status = "1";
        $message = "";
        $o_data = [];
        $errors = [];
        $user_id = $this->validateAccesToken($request->access_token);
        $cartObj = new MCart();
        $cartObj->user_id = $user_id;
        $cartObj->device_cart_id = $request->device_cart_id;
        $cartObj->combine_cart($user_id,$request->device_cart_id);
        $items = $cartObj->get_cart();

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'coupon_code'  => [$couponData = new ValidateCouponCode($user_id,$cartObj->item_total)]
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
            $cartObj = new MCart();
            $cartObj->user_id = $user_id;

            $o_data['items'] = convert_all_elements_to_string($cartObj->get_cart());
            $o_data['cart_total'] = (string) $cartObj->item_total;
            $o_data['delivery_charge'] = (string) $cartObj->delivery_charge;
            $o_data['tax'] = (string) $cartObj->tax;
            $o_data['tax_percentage'] = (string) $cartObj->tax_percentage;
            $o_data['grand_total'] = (string) $cartObj->grand_total;
            $o_data['coupon_applied_status'] = (string) $cartObj->coupon_applied_status;
            $o_data['total_coupon_discount'] = (string) $cartObj->total_coupon_discount;
            $o_data['applied_coupon_id'] = (string) $cartObj->applied_coupon_id;
            $o_data['cart_count'] = (string) count($o_data['items']);

        } else {

            /****Upload Prescription if Any*****/
            $image_error = 0;
            $order_prescription_link = "";
            if ($request->file("order_prescription")) {
                $response = image_upload($request, 'order_prescription', 'order_prescription');
                if ($response['status']) {
                    $order_prescription_link = $response['link'];
                } else{
                    $image_error = 1;
                }
            }
            if ( $order_prescription_link != "" ) {
                Cart::where('user_id', $user_id)->update(['order_prescription' => $order_prescription_link]);
            }
            /****ClosePrescription****/

            $cartObj = new MCart();
            $cartObj->user_id = $user_id;
            $cartObj->coupon_data = $couponData->coupon_data;

            $o_data['items'] = convert_all_elements_to_string($cartObj->get_cart());
            $o_data['cart_total'] = (string) $cartObj->item_total;
            $o_data['delivery_charge'] = (string) $cartObj->delivery_charge;
            $o_data['tax'] = (string) $cartObj->tax;
            $o_data['tax_percentage'] = (string) $cartObj->tax_percentage;
            $o_data['grand_total'] = (string) $cartObj->grand_total;
            $o_data['coupon_applied_status'] = (string) $cartObj->coupon_applied_status;
            $o_data['total_coupon_discount'] = (string) $cartObj->total_coupon_discount;
            $o_data['applied_coupon_id'] = (string) $cartObj->applied_coupon_id;
            $o_data['cart_count'] = (string) count($o_data['items']);
            $status          = $cartObj->cart_status;
            $message         = $cartObj->cart_message;

        }
        $default_address =  UserAdress::get_user_default_address($user_id);
        $o_data['default_address'] = (object)[];
        if($default_address != null){
            $o_data['default_address'] = $default_address->toArray();
        }
        $o_data['address_list'] = UserAdress::get_address_list($user_id);

        $o_data = convert_all_elements_to_string($o_data);
        return response()->json(['status' => $status, 'message' => $message, 'errors' => (object)$errors, 'oData' => (object)$o_data]);
    }
    public function update_cart(Request $request)
    {
        $status = "1";
        $message = "";
        $o_data = [];
        $errors = [];
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'cart_id' => 'required',
            'type' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);

            $cart_condition = [
                "id" => $request->cart_id,
                "user_id" => $user_id,
            ];
            if ($request->type == "add") {
                if (Cart::where($cart_condition)->increment('quantity', 1)) {
                    $message = "Cart updated";
                } else {
                    $message = "Invalid data passed";
                }
            } else {
                if (Cart::where($cart_condition)->decrement('quantity', 1)) {
                    $message = "Cart updated";
                } else {
                    $message = "Invalid data passed";
                }
            }

            $o_data = $this->process_cart($user_id);
        }

        return response()->json(['status' => (string)$status, 'message' => $message, 'errors' => (object)$errors, 'oData' => (object)$o_data]);
    }

    
    public function process_cart($user_id=0,$device_cart_id='')
    {
        if($user_id > 0){
            $where['cart.user_id'] = $user_id;
        }else{
            $where['cart.device_cart_id'] = $device_cart_id;
        }
        
        $where['product.deleted'] = 0;
        $where['product.product_status'] = 1;
        

        $cart = Cart::select('cart.*')->where($where)->join('product', 'product.id', 'cart.product_id')->orderby('cart.created_at','desc')->get();
        $product = [];

        $cart_total = 0;
        foreach ($cart as $key => $val) {
            list($status, $product, $message) = ProductModel::getProductVariant($val->product_id, $val->product_attribute_id);
            if ($status && !empty($product)) {
                $product = process_product_data_api($product);
                $amt = $product['regular_price'];
                if ($product['sale_price']) {
                    $amt = $product['sale_price'];
                }
                $product_total_amount = $amt * $val->quantity;
                $product['total_amount'] = $product_total_amount;
                $cart_total += $product_total_amount;
            }
            $cart[$key]->product_details = $product;
        }
        $settings = SettingsModel::first();
        $tax_percentage = 0;
        // if (isset($settings->tax_percentage)) {
        //     $tax_percentage = $settings->tax_percentage;
        // }
        $tax_amount = 0; //($cart_total * $tax_percentage) / 100;
        $grand_total = $tax_amount + $cart_total;
        $cart_count = count($cart);
        $cart_items = $cart;
        return ['cart_total' => round($cart_total, 2), 'tax_amount' => round($tax_amount, 2), 'discount' => 0, 'grand_total' => round($grand_total, 2), 'cart_count' => $cart_count, 'cart_items' => $cart_items];
    }
    public function apply_coupon(Request $request)
    {
        $status = "1";
        $message = "";
        $o_data = [];
        $errors = [];
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'coupon_code' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $coupon = Coupons::where(['coupon_code' => $request->coupon_code, 'coupon_status' => 1])->where('start_date', '<=', date('Y-m-d'))->where('coupon_end_date', '>=', date('Y-m-d'))->first();
            if ($coupon) {
                $o_data = $this->process_cart($user_id);
                if ($o_data['cart_count'] == 0) {
                    $status = "0";
                    $message = "No items in cart";
                    $errors = $validator->messages();
                    $o_data = [];
                } else if ($o_data['grand_total'] < $coupon->minimum_amount) {
                    $status = "0";
                    $message = "Minimum order amount should be " . $coupon->minimum_amount;
                    $errors = $validator->messages();
                    $o_data = [];
                } else {
                    $applied_to = $coupon->applied_to;
                    $amount_type = $coupon->amount_type;
                    $amount = $coupon->coupon_amount;
                    $categories = CouponCategory::where('coupon_id', $coupon->coupon_id)->get()->toArray();
                    $categories = array_column($categories, 'category_id');
                    $discount = 0;
                    foreach ($o_data['cart_items'] as $key => $val) {
                        $det = $val['product_details'];
                        if ($applied_to == 1) {
                            if (in_array($val->product_details['category_id'], $categories)) {
                                $dis = $amount;
                                if ($amount_type == 1) {
                                    $dis = ($val->product_details['total_amount'] * $amount) / 100;
                                }
                                $det['coupon_discount'] = $dis;
                                $det['grand_total'] = $val->product_details['total_amount'] - $dis;
                                $discount += $dis;
                            } else {
                                $det['coupon_discount'] = 0;
                                $det['grand_total'] = $val->product_details['total_amount'];
                            }
                        } else {
                            $dis = $amount;
                            if ($amount_type == 1) {
                                $dis = ($val->product_details['total_amount'] * $amount) / 100;
                            }
                            $det['coupon_discount'] = 0;
                            $det['grand_total'] = $val->product_details['total_amount'];
                            $discount = $dis;
                        }
                        $o_data['cart_items'][$key]['product_details'] = $det;
                    }
                    $o_data['discount'] = $discount;
                    $o_data['grand_total'] = $o_data['grand_total'] - $discount;
                }
            } else {
                $o_data = null;
                $status = "0";
                $message = "Invalid Coupon";
                $errors = $validator->messages();
            }

        }
        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data]);
    }
    public function delete_cart(Request $request)
    {
        $status = "1";
        $message = "";
        $o_data = [];
        $errors = [];
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'cart_id' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $cart_condition = [
                "id" => $request->cart_id,
                "user_id" => $user_id,
            ];
            if (Cart::where($cart_condition)->delete()) {
                $message = "Cart item removed";
            }

            $o_data = $this->process_cart($user_id);
        }

        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data]);
    }
    public function clear_cart(Request $request)
    {
        $status = "1";
        $message = "";
        $o_data = [];
        $errors = [];
        $validator = Validator::make($request->all(), [
            'device_cart_id' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->getUserId($request->access_token);
            $device_cart_id = $request->device_cart_id;
            if($user_id > 0){
                $cart_condition = [
                    "user_id" => $user_id,
                ];
            }else{
                $cart_condition = [
                    "device_cart_id" => $device_cart_id,
                    'user_id'        => 0
                ];
            }
            if (Cart::where($cart_condition)->delete()) {
                $message = "Cart cleared";
            }
        }

        return response()->json(['status' => (string)$status, 'message' => $message, 'errors' => (object)$errors, 'oData' => (object)$o_data]);
    }
    public function payment_init(Request $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];
        $user_id = $this->validateAccesToken($request->access_token);
        $cartObj = new MCart();
        $cartObj->user_id = $user_id;
        $cartObj->device_cart_id = $request->device_cart_id;
        $items = $cartObj->get_cart();
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'payment_type' => 'required|integer|min:1',
            'address_id' => 'required|integer|min:1',
            'coupon_code'  => [$couponData = new ValidateCouponCode($user_id,$cartObj->item_total)]
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            
            $cartObj = new MCart();
            $cartObj->user_id = $user_id;
            $cartObj->coupon_data = $couponData->coupon_data;
            $cart_details = $cartObj->get_cart();

            $discount = 0;


            $amount_to_pay = $cartObj->grand_total;

            if ((int) $amount_to_pay == 0) {
                $message = "Your cart is empty";
            } else {
                $check = \App\Models\TempOrderModel::where(['user_id' => $user_id])->first();
                if ($check) {
                    \App\Models\TempOrderModel::where(['user_id' => $user_id])->delete();
                    \App\Models\TempOrderProductsModel::where(['order_id' => $check->id])->delete();
                }
                $temp_id = $user_id . uniqid() . time();

                $order_prescription_pdf = '';
                $order_prescription = $cartObj->order_prescription;
                if ( isset ( $order_prescription ) && $order_prescription != "" ) {
                    $order_prescription = explode('order_prescription/', $order_prescription);
                    if ( isset ( $order_prescription[1] ) && $order_prescription[1] != ""){
                        $order_prescription_pdf = $order_prescription[1];
                    }
                }

                $temp_order = new \App\Models\TempOrderModel();
                $temp_order->user_id = $user_id;
                $temp_order->address_id = $request->address_id;
                $temp_order->total = $cartObj->item_total;
                $temp_order->vat = $cartObj->tax;
                $temp_order->discount = $cartObj->total_coupon_discount;
                $temp_order->grand_total = $cartObj->grand_total;
                $temp_order->payment_mode = $request->payment_type;
                $temp_order->temp_id = $temp_id;
                $temp_order->request_deligate = $request->request_deligate ?? 0;
                $temp_order->coupon_code = $request->coupon_code;
                $temp_order->coupon_id = $cartObj->applied_coupon_id;
                $temp_order->shipping_charge = $cartObj->delivery_charge;
                $temp_order->store_id = $cartObj->store_id;
                $temp_order->order_prescription = $order_prescription_pdf ?? '';
                $temp_order->save();

                $temp_order_id = $temp_order->id;

                foreach ($cart_details as $val) {
                    $temp_order_prds = new \App\Models\TempOrderProductsModel();
                    $temp_order_prds->order_id = $temp_order_id;

                    $temp_order_prds->product_id = $val['product_id'];
                    $temp_order_prds->product_attribute_id = $val['product_attribute_id'];
                    $temp_order_prds->product_type = $val['product_type']??1;
                    $temp_order_prds->quantity = $val['quantity'];
                    $temp_order_prds->price = $val['sale_price'];
                    $temp_order_prds->discount = isset($val['coupon_discounted_amount']) ? $val['coupon_discounted_amount'] : 0;
                    $temp_order_prds->total = $val['sub_total'];
                    $temp_order_prds->vendor_id = $val['store_id'];
                    $temp_order_prds->admin_commission = 0;
                    $temp_order_prds->vendor_commission = 0;
                    $temp_order_prds->shipping_charge = 0;
                    $temp_order_prds->save();
                }
                $wallet_amount_used = 0;
                if ($request->payment_type == 2 || $request->payment_type == 3) {
                    $o_data = $this->payment_init_stripe($payment_token = $temp_id, $invoice_id = $temp_id, $amount_to_pay, $wallet_amount_used, $user_id, $request->address_id, $cartObj->tax);
                    $status = "1";
                    $message = "";
                } elseif($request->payment_type == 4){

                    $wallet_amount_used = $amount_to_pay;
                    $paymentreport = [
                        'transaction_id' => $temp_id,
                        'payment_status' => 'P',
                        'user_id' => $user_id,
                        'ref_id' => $temp_id,
                        'amount' => $amount_to_pay,
                        'created_at' => gmdate('Y-m-d H:i:s'),
                        'wallet_amount_used' => $wallet_amount_used,
                    ];
                    $subTotal = $amount_to_pay;
                    $paymentreport['vat'] = $cartObj->tax;
                    \App\Models\PaymentReport::insert($paymentreport);

                    $res_status = $this->payment_success($temp_id);
                    if ($res_status === 1) {
                        $status = "1";
                        $message = "Order Placed Successfully";
                    } else {
                        $status = "0";
                        $message = "Soemthing went wrong";
                    }
                } else {
                    $user = User::where(['id' => $user_id])->get()->first();
                    if ($user->wallet_amount < $amount_to_pay) {
                        $status = "0";
                        $message = "Insufficient wallet balance";
                    } else {
                        $wallet_amount_used = $amount_to_pay;
                        $paymentreport = [
                            'transaction_id' => $temp_id,
                            'payment_status' => 'P',
                            'user_id' => $user->id,
                            'ref_id' => $temp_id,
                            'amount' => $amount_to_pay,
                            'created_at' => gmdate('Y-m-d H:i:s'),
                            'wallet_amount_used' => $wallet_amount_used,
                        ];
                        $subTotal = $amount_to_pay;
                        $paymentreport['vat'] = $cartObj->tax;
                        \App\Models\PaymentReport::insert($paymentreport);

                        $res_status = $this->payment_success($temp_id);
                        if ($res_status === 1) {
                            $status = "1";
                            $message = "Order Placed Successfully";
                        } else {
                            $status = "0";
                            $message = "Soemthing went wrong";
                        }
                    }
                }
            }

        }
        return response()->json(['status' => $status, 'message' => $message, 'errors' => (object) $errors, 'oData' => (object) $o_data]);
    }
    public function payment_init_stripe($payment_token, $invoice_id, $amount_to_pay, $payment_by_wallet, $user_id, $address_id, $tax_amount = 0)
    {
        $user = User::where(['id' => $user_id])->get()->first();
        $response = array();
        $data['client_reference_id'] = $invoice_id;
        $data['product'] = "Live Market";
        $data['description'] = "Product Purchase";
        $data['quantity'] = 1;
        $data['image'] = asset('/web_assets/images/logo-talents.png');
        $data['success_url'] = url('/') . '/payment_response/?sessio_id={CHECKOUT_SESSION_ID}&token=' . $payment_token;
        $data['cancel_url'] = url('/') . '/payment_cancel?sessio_id={CHECKOUT_SESSION_ID}&token={$payment_token}';
        $data['amount'] = $amount_to_pay * 100;
        $data['email'] = $user->email ?? 'livemarketuser@gmail.com';
        $address = UserAdress::get_address_details($address_id);

        \Stripe\Stripe::setApiKey(env('STRIPE_SECRET'));
        $checkout_session = \Stripe\PaymentIntent::create([
            'amount' => $amount_to_pay * 100,
            'currency' => 'SAR',
            'description' => "product purchase",
            'shipping' => [
                'name' => $user->name ?? $user->first_name . ' ' . $user->last_name,
                'address' => [
                    'line1' => $address->address,
                    'city' => $address->city_name,
                    'state' => $address->state_name,
                    'country' => $address->country_name,
                ],
            ],
        ]);

        $data['session_id'] = $checkout_session->id;
        $ref = $checkout_session->id;
        $paymentreport = [
            'transaction_id' => $invoice_id,
            'payment_status' => 'P',
            'user_id' => $user->id,
            'ref_id' => $ref,
            'amount' => $amount_to_pay,
            'created_at' => gmdate('Y-m-d H:i:s'),
            'wallet_amount_used' => $payment_by_wallet,
        ];
        $subTotal = $amount_to_pay;
        $paymentreport['vat'] = $tax_amount;
        \App\Models\PaymentReport::insert($paymentreport);

        $payment_ref = $checkout_session->client_secret;

        return compact('invoice_id', 'payment_ref');
    }
    public function payment_response()
    {

    }
    public function payment_cancel()
    {

    }
    public function place_order(Request $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'payment_type' => 'invoice_id',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);

            $res_status = $this->payment_success($request->invoice_id);

            if ($res_status === 1) {
                $status = "1";
                $message = "Order Placed Successfully";
            } else {
                $status = "0";
                $message = "Soemthing went wrong";
            }
        }
        return response()->json(['status' => $status, 'message' => $message, 'errors' => (object) $errors, 'oData' => (object) $o_data]);
    }
    private function payment_success($invoice_id)
    {
        try {

            $data = \App\Models\TempOrderModel::where(['temp_id' => $invoice_id])->first();
            if ($data) {

                $order = new OrderModel();
                $order->invoice_id = $invoice_id;
                $order->user_id = $data->user_id;
                $order->address_id = $data->address_id;
                $order->total = $data->total;
                $order->vat = $data->vat;
                $order->discount = $data->discount;
                $order->grand_total = $data->grand_total;
                $order->payment_mode = $data->payment_mode;
                $order->status = config('global.order_status_pending');
                $order->booking_date = gmdate('Y-m-d H:i:s');
                $order->request_deligate = $data->request_deligate??'';
                $order->admin_commission = $data->admin_commission;
                $order->vendor_commission = $data->vendor_commission;
                $order->shipping_charge = $data->shipping_charge;
                $order->created_at = gmdate('Y-m-d H:i:s');
                $order->user_id = $data->user_id;
                $order->coupon_code = $data->coupon_code;
                $order->coupon_id = $data->coupon_id;
                $order->store_id  = $data->store_id;
                $order->order_prescription = $data->order_prescription ?? '';

                $order->save();
                // dd('q');
                $order_id = $order->order_id;

                if ($data->coupon_code) {
                    $chist = new CouponHistory();
                    $chist->order_id = $order_id;
                    $chist->coupon_id = $data->coupon_id;
                    $chist->user_id = $data->user_id;
                    $chist->coupon_code = $data->coupon_code;
                    $chist->discount = $data->discount;
                    $chist->save();
                }

                // dd($order_id);
                $order_prds_data = \App\Models\TempOrderProductsModel::where('order_id', $data->id)->get();
                $total_qty = 0;
                $total_items_qty = 0;
                $influnecers = [];
                foreach ($order_prds_data as $key=>$val) {
                    $total_qty += 1;
                    $total_items_qty += $val->quantity;
                    $order_prds = new OrderProductsModel();
                    $order_prds->order_id = $order_id;
                    $order_prds->product_id = $val->product_id;
                    $order_prds->product_attribute_id = $val->product_attribute_id;
                    $order_prds->product_type = $val->product_type;
                    $order_prds->quantity = $val->quantity;
                    $order_prds->price = $val->price;
                    $order_prds->discount = $val->discount;
                    $order_prds->total = $val->total;
                    $order_prds->vendor_id = $val->vendor_id;
                    $order_prds->order_status = config('global.order_status_pending');;
                    $order_prds->admin_commission = $val->admin_commission;
                    $order_prds->vendor_commission = $val->vendor_commission;
                    $order_prds->shipping_charge = $val->shipping_charge;
                    $order_prds->influencer_id = $val->influencer_id;
                    $order_prds->influencer_qty = $val->influencer_qty;
                    if($val->influencer_id){
                        $influnecers[$key]['inf_id']=$val->influencer_id;
                        $influnecers[$key]['product_id']=$val->product_id;
                        $influnecers[$key]['product_attribute_id']=$val->product_attribute_id;
                    }
                    $order_prds->save();
                }
                $order->total_qty = $total_qty;
                $order->total_items_qty = $total_items_qty;
                $order->save();

                \App\Models\TempOrderModel::where(['temp_id' => $invoice_id])->delete();
                \App\Models\TempOrderProductsModel::where(['id' => $data->id])->delete();

                $payObj = \App\Models\PaymentReport::where('transaction_id', $invoice_id)->get()->first();
                $payObj->payment_status = 'I';
                $payObj->save();
                $users = User::find($payObj->user_id);
                $wallet_amount_used = $payObj->wallet_amount_used;
                if ($wallet_amount_used > 0) {
                    $users = User::find($payObj->user_id);
                    if ($users) {
                        $w_data = [
                            'user_id' => $users->id,
                            'wallet_amount' => $wallet_amount_used,
                            'pay_type' => 'debited',
                            'description' => 'Used for cart checkout',
                        ];
                        if (wallet_history($w_data)) {
                            $users->wallet_amount = $users->wallet_amount - $wallet_amount_used;
                            $users->save();
                        }
                    }
                }
                Cart::where(['user_id' => $users->id])->delete();
                Cart::where(['user_id' => $users->id])->delete();

                $title = 'Order Placed Successfully';
                $description = 'Your order has been placed successfully';
                $notification_id = time();
                $ntype = 'order_placed';
                if (!empty($users->firebase_user_key)) {
                    $notification_data["Nottifications/" . $users->firebase_user_key . "/" . $notification_id] = [
                        "title" => $title,
                        "description" => $description,
                        "notificationType" => $ntype,
                        'createdDate'     => $order->created_at,
                        "orderId" => (string) $order_id,
                        "url" => "",
                        "imageURL" => '',
                        "read" => "0",
                        "seen" => "0",
                    ];
                    $this->database->getReference()->update($notification_data);
                }

                if (!empty($users->user_device_token)) {
                    send_single_notification($users->user_device_token, [
                        "title" => $title,
                        "body" => $description,
                        "icon" => 'myicon',
                        "sound" => 'default',
                        "click_action" => "EcomNotification"],
                        ["type" => $ntype,
                            "notificationID" => $notification_id,
                            "orderId" => (string) $order_id,
                            "imageURL" => "",
                        ]);
                }

                

                $name = $users->name ?? $users->first_name . ' ' . $users->last_name;
                exec("php " . base_path() . "/artisan send:send_order_email --uri=" . urlencode($users->email) . " --uri2=" . $order_id . " --uri3=" . urlencode($name) . " --uri4=" . $users->id . " > /dev/null 2>&1 & ");

            }
            return 1;
        } catch (\Exception $e) {
            // printr($e->getMessage());
            return 0;
        }
    }
}
