<?php

namespace App\Http\Controllers\api\v1;

use App\Http\Controllers\Controller;
use App\Models\BannerModel;
use App\Models\Categories;
use App\Models\Brands;
use App\Models\ProductModel;
use App\Models\VendorModel;
use App\Models\StoreLikes;
use Illuminate\Http\Request;
use DB;
class HomeController extends Controller
{
    public function Home(Request $request){
        $user = GetUser($request->access_token);

        $user_id = 0;

        if( $user )
            $user_id = $user->id;


        $o_data = [];
        $o_data['AppBanner'] = BannerModel::where('active',1)->where('banner_type',1)->get();
        $o_data['AppSlider'] = BannerModel::where('active',1)->where('banner_type',2)->get();


        $categories = Categories::where(['deleted' => 0, 'parent_id' => 0])->orderBy('sort_order', 'asc')->get();
        foreach ($categories as $key => $val) {
            $child = Categories::where(['deleted' => 0,'parent_id' => $val->id])->orderBy('created_at', 'desc')->get();
            $categories[$key]->child = $child;
        }
        $o_data['Categories'] = $categories;

        $o_data['TopBrands'] = Brands::select('brand.*','brand.name as name','industry_types.name as industry')
            ->where(['brand.deleted' => 0])
            ->leftjoin('industry_types','industry_types.id','=','brand.industry_type')
            ->get();

        $params['search_key'] = $_GET['search_key'] ?? '';
        $filter = ['product.featured_product'=>1, 'product.deleted'=>0];
        $sortby = "product.id";
        $sort_order = "desc";

        $o_data['FeaturedProduct'] = ProductModel::get_products_list($filter, $params,$sortby,$sort_order, $user_id)->paginate(10);

        $o_data['NearestStores'] = VendorModel::select('*','users.id as rating_avg','users.name as name','users.created_at as u_created_at','industry_types.name as industry','users.active as active','users.id as id')
            ->where(['role'=>'3','users.deleted'=>'0'])
            ->withCount('user_prescribe')
            ->withCount('total_rating')
            ->withCount(['is_favourite' => function ($query) use($user_id){
                if ( $user_id > 0 ){
                    return $query->where('user_id', $user_id);
                }
            }])
            ->leftjoin('vendor_details','vendor_details.user_id','=','users.id')
            ->leftjoin('industry_types','industry_types.id','=','vendor_details.industry_type')
            ->orderBy('users.id','desc')->get();

        return response()->json(['status' => "1", 'message' => "Home data", 'errors' => (object) [], 'oData' => (object) $o_data]);
    }
}
