<?php

namespace App\Http\Controllers\Api\v1;

use App\Http\Controllers\Controller;
use App\Models\AccountType;
use App\Models\ActivityType;
use Illuminate\Http\Request;

class ListController extends BaseController
{
    function getAccountTypes(){
        $accountType = AccountType::select('id','name')->whereDeleted(0)->get();
        return $this->successResponse($accountType);
    }

    function getActivityTypes($id){
        $activityType = ActivityType::select('id','name')
            ->where('account_id',$id)
            ->whereDeleted(0)->get();
        return $this->successResponse($activityType);
    }

    function getBusinessTypes(){
        $businessType = [
            ['id'=>1,'name'=> 'Company Registration'],
            ['id'=>2,'name'=> 'Individual Registration'],
        ];
        return $this->successResponse($businessType);
    }
    function getVehicleTypes(){
        $vehicleType = [
            ['id'=>1,'name'=> 'Motorcycle'],
            ['id'=>2,'name'=> 'Pick up'],
            ['id'=>3,'name'=> 'Normal'],
            ['id'=>4,'name'=> 'Big Truck'],
            ['id'=>5,'name'=> 'Medium Truck'],
        ];
        $odata = convert_all_elements_to_string($vehicleType);
        return $this->successResponse($odata);
    }

}
