<?php

namespace App\Http\Controllers\api\v1;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\User;
use App\Models\PrescribeMedicines;

class PrescriptionController extends Controller
{
    public function my_prescription(Request $request){

        $access_token = $request->access_token;

        $user = User::where('user_access_token', $access_token)->where(['user_type_id' => '0', 'users.deleted' => '0'])->first();

        if ( ! $user ) {
            return response()->json(['status' => "0",'code' => '400','message' => 'session expire please login.','data' => []], 200);
        }

        $role = $user->role ?? 0;

        $page = $request->page ?? 1;

        $data_main = PrescribeMedicines::with(['doctor', 'user'])
            ->where(function ($query) use($role, $user, $request){

                if (isset ( $role ) && $role == 4){
                    $query->where('doctor_id', $user->id);
                }
                if (isset ( $role ) && $role == 2){
                    $query->where('user_id', $user->id);
                }
                if ( $request->prescription_id ) {
                    $query->where('id', $request->prescription_id);
                }
            })->orderBy('id', 'desc')->paginate($page);

        return response()->json(['status' => "1",'code' => '200','message' => 'Prescription list.','data' => $data_main], 200);
    }
}
