<?php

namespace App\Http\Controllers\Api\v1;

use App\Http\Controllers\Controller;
use App\Models\ModaSubCategories;
use App\Models\ProductLikes;
use App\Models\ProductModel;
use App\Models\Stores;
use App\Models\User;
use App\Models\Categories;
use App\Models\Brands;
use App\Models\VendorModel;
use DB;
use Illuminate\Http\Request;
use Validator;

class ProductController extends Controller
{
    private function validateAccesToken($access_token)
    {

        $user = User::where(['user_access_token' => $access_token])->get();

        if ($user->count() == 0) {
            http_response_code(401);
            echo json_encode([
                'status' => "0",
                'message' => 'Invalid login',
                'oData' => [],
                'errors' => (object) [],
            ]);
            exit;

        } else {
            $user = $user->first();
            if ($user->active == 1) {
                return $user->id;
            } else {
                http_response_code(401);
                echo json_encode([
                    'status' => "0",
                    'message' => 'Invalid login',
                    'oData' => [],
                    'errors' => (object) [],
                ]);
                exit;
                return response()->json([
                    'status' => "0",
                    'message' => 'Invalid login',
                    'oData' => [],
                    'errors' => (object) [],
                ], 401);
                exit;
            }
        }
    }
    function list(Request $request) {
        $status = "1";
        $message = "";
        $o_data = [];
        $errors = [];
        // $validator = Validator::make($request->all(), [

        // ]);

        // if ($validator->fails()) {
        //     $message = "Validation error occured";
        //     $errors = $validator->messages();
        //     return response()->json([
        //         'status' => "0",
        //         'message' => $message,
        //         'errors' => (object) $errors,
        //     ], 200);
        // }

        $access_token = $request->access_token;
        $limit = isset($request->limit) ? $request->limit : 10;
        $offset = isset($request->page) ? ($request->page - 1) * $request->limit : 0;

        $where['deleted'] = 0;
        $where['product_status'] = 1;

        $filter['search_text'] = $request->search_text;
        $filter['store_id'] = $request->store_id;
        $filter['parent_category_id'] = $request->category_id;
        $filter['sub_category'] = $request->sub_category_ids;

        $list = ProductModel::products_list($where, $filter, $limit, $offset)->get();
        $user = User::where('user_access_token', $access_token)->first();
        $products = $this->product_inv($list, $user);
        $o_data['list'] = $products;
        $o_data['currency_code'] =  config('global.default_currency_code');
        $o_data = convert_all_elements_to_string($o_data);
        return response()->json(['status' => $status, 'message' => $message, 'errors' => (object) $errors, 'oData' => $o_data], 200);
    }

    function fav_list(Request $request) {
        $status = "1";
        $message = "";
        $o_data = [];
        $errors = [];
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
        ]);

        if ($validator->fails()) {
            $message = "Validation error occured";
            $errors = $validator->messages();
            return response()->json([
                'status' => "0",
                'message' => $message,
                'errors' => (object) $errors,
            ], 200);
        }

        $user_id = $this->validateAccesToken($request->access_token);
        $limit = isset($request->limit) ? $request->limit : 10;
        $offset = isset($request->page) ? ($request->page - 1) * $request->limit : 0;

        $where['deleted'] = 0;
        $where['product_status'] = 1;
        $where['product_likes.user_id'] = $user_id;

        $list = ProductModel::products_fav_list($where, $limit, $offset)->get();
        $user = User::find($user_id);
        $products = $this->product_inv($list, $user);
        $o_data['list'] = $products;
        return response()->json(['status' => $status, 'message' => $message, 'errors' => (object) $errors, 'oData' => $o_data], 200);
    }

    public function product_inv($products, $user,$from='')
    {
        foreach ($products as $key => $val) {
            if($from=='moda'){
                $products[$key]->product_variant_id="0";
                $products[$key]->is_fav=0;
                list($st, $variant, $msg) = ProductModel::getProductVariant($val->id,0);
                if($variant){
                    if (isset($variant['product_attribute_id'])) {
                        $products[$key]->product_variant_id = (string) $variant['product_attribute_id'];
                   
                    }
                }
                if(\App\Models\FavouriteModaItems::where(['user_id' => $user->id, 'product_id' => $val->id,'moda_sub_category'=>$val->moda_sub_category])->count()){
                    $products[$key]->is_fav=1;
                }

            }
            
            $products[$key]->is_liked = 0;
            if ($user) {
                $is_liked = ProductLikes::where(['product_id' => $val->id, 'user_id' => $user->id])->count();
                if ($is_liked) {
                    $products[$key]->is_liked = 1;
                }
            }
            $det = [];
            if ($val->default_attribute_id) {
                $det = DB::table('product_selected_attribute_list')->select('product_attribute_id', 'stock_quantity', 'sale_price', 'regular_price', 'image','size_chart')->where('product_id', $val->id)->where('product_attribute_id', $val->default_attribute_id)->first();
                if ($det) {
                    if($det->size_chart){
                        $det->size_chart = asset($det->size_chart);
                    }
                    $images = $det->image;
                    if ($images) {
                        $images = explode(',', $images);
                        $images = array_values(array_filter($images));
                        $i = 0;
                        $prd_img = [];
                        foreach ($images as $img) {
                            if ($img) {
                                $prd_img[$i] = url(config('global.upload_path') . '/' . config('global.product_image_upload_dir') . str_replace(' ', '%20', $img));
                                $i++;
                            }
                        }
                        $det->image = $prd_img;
                    } else {
                        $det->image = [];
                    }
                }

            } else {
                $det = DB::table('product_selected_attribute_list')->select('product_attribute_id', 'stock_quantity', 'sale_price', 'regular_price', 'image','size_chart')->where('product_id', $val->id)->orderBy('product_attribute_id', 'DESC')->limit(1)->first();

                if ($det) {
                    if($det->size_chart){
                        $det->size_chart = asset($det->size_chart);
                    }
                    $images = $det->image;
                    if ($images) {
                        $images = explode(',', $images);
                        $images = array_values(array_filter($images));
                        $i = 0;
                        $prd_img = [];

                        foreach ($images as $img) {
                            if ($img) {
                                $prd_img[$i] = url(config('global.upload_path') . '/' . config('global.product_image_upload_dir') . str_replace(' ', '%20', $img));
                                $i++;
                            }
                        }
                        $det->image = $prd_img;
                    } else {
                        $det->image = [];
                    }
                }
            }
            $products[$key]->inventory = $det;
        }
       
            return $products;
        
    }
    public function product_like_dislike(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'product_id' => 'required|numeric',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $product_id = $request->product_id;
            $check_exist = ProductLikes::where(['product_id' => $product_id, 'user_id' => $user_id])->get();
            if ($check_exist->count() > 0) {
                ProductLikes::where(['product_id' => $product_id, 'user_id' => $user_id])->delete();
                $status = "1";
                $message = "disliked";
            } else {
                $like = new ProductLikes();
                $like->product_id = $product_id;
                $like->user_id = $user_id;
                $like->created_at = gmdate('Y-m-d H:i:s');
                $like->save();
                if ($like->id > 0) {
                    $status = "1";
                    $message = "liked";
                } else {
                    $message = "faild to like";
                }
            }
        }
        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' => $o_data], 200);
    }

    public function details(Request $request)
    {

        $status = "1";
        $message = "";
        $o_data = [];
        $errors = [];
        $product = [];
        $validator = Validator::make($request->all(), [
            'product_id' => 'required|numeric|min:0|not_in:0',
        ]);

        if ($validator->fails()) {
            $message = "Validation error occured";
            $errors = $validator->messages();
            return response()->json([
                'status' => "0",
                'message' => $message,
                'errors' => (object) $errors,
            ], 200);
        }

        $access_token = $request->access_token;
        $user = User::where('user_access_token', $access_token)->first();
        $product_id = $request->product_id;
        $product_variant_id = $request->product_variant_id;

        $sattr = $request->sattr;
        $sattr = json_decode($request->sattr, true);
        $return_status = true;

        if (!$product_variant_id) {
            list($return_status, $product_attribute_id, $message) = ProductModel::get_product_attribute_id_from_attributes($sattr, $product_id);
            $product_variant_id = $product_attribute_id;
        }

        if (!$return_status) {
            $status = "0";
            $message = "Invalid data passed";
            return response()->json([
                'status' => "0",
                'message' => $message,
                'errors' => (object) $errors,
            ], 200);
        }

        list($status, $product, $message) = ProductModel::getProductVariant($product_id, $product_variant_id);

        if ($status && !empty($product)) {
            $product = process_product_data_api($product);
            $product['is_liked'] = 0;
            if ($user) {
                $is_liked = ProductLikes::where(['product_id' => $product['product_id'], 'user_id' => $user->id])->count();
                if ($is_liked) {
                    $product['is_liked'] = 1;
                }
            }
            $store_details = VendorModel::with('user_location')->where(['id'=>$product['store_id']])->select('id','user_image','name','email','phone','dial_code','about_me','rating','rated_users')->get()->first()->toArray();

            $product['share_link'] = url("share/product/" . $product_id . "/" . $product['product_variant_id']);
            $product['store_details'] = $store_details;

            $product['specifications'] = ProductModel::get_product_specs($product_id);

            $product_selected_attributes = ProductModel::getProductVariantAttributes($product['product_variant_id']);

            $product_variations = [];



            $product_attributes = ProductModel::getProductAttributeVals([$product['product_id']]);
            foreach ($product_attributes as $attr_row) {
                if (array_key_exists($attr_row->attribute_id, $product_variations) === false) {
                    $product_variations[$attr_row->attribute_id] = [
                        'product_attribute_id' => $attr_row->product_attribute_id,
                        'attribute_id' => $attr_row->attribute_id,
                        'attribute_type' => $attr_row->attribute_type,
                        'attribute_name' => $attr_row->attribute_name,
                        'attribute_values' => [],
                    ];
                    if ($attr_row->attribute_type === 'radio_button_group') {
                        $product_variations[$attr_row->attribute_id]['help_text_start'] = $attr_row->attribute_value_label;
                    }
                }
                if ($attr_row->attribute_type === 'radio_button_group') {
                    $product_variations[$attr_row->attribute_id]['help_text_end'] = $attr_row->attribute_value_label;
                }
                if (array_key_exists($attr_row->attribute_values_id, $product_variations[$attr_row->attribute_id]['attribute_values']) === false) {
                    $is_selected = 0;
                    if (array_key_exists($attr_row->attribute_id, $product_selected_attributes) && ($product_selected_attributes[$attr_row->attribute_id] == $attr_row->attribute_values_id)) {
                        $is_selected = 1;
                    }
                    $product_variations[$attr_row->attribute_id]['attribute_values'][$attr_row->attribute_values_id] = [
                        'attribute_value_id' => $attr_row->attribute_values_id,
                        'attribute_value_name' => $attr_row->attribute_values,
                        'is_selected' => $is_selected,
                    ];
                    if ($attr_row->attribute_value_in == 2) {
                        $product_variations[$attr_row->attribute_id]['attribute_values'][$attr_row->attribute_values_id]['attribute_value_color'] = $attr_row->attribute_color;
                    }
                    if ($attr_row->attribute_type === 'radio_image') {
                        $t_image = $attr_row->attribute_value_image;

                        $product_variations[$attr_row->attribute_id]['attribute_values'][$attr_row->attribute_values_id]['attribute_value_image'] = $t_image;
                    }
                }
            }

            $product['product_variations'] = [];


            if (!empty($product_variations)) {
                $t_variations = array_values($product_variations);
                foreach ($t_variations as $k => $v) {
                    $t_variations[$k]['attribute_values'] = array_values($t_variations[$k]['attribute_values']);
                }
                $product["product_variations"] = $t_variations;
            }

            $shop_products = ProductModel::select('product.id', 'product.product_name', 'product.product_type', 'default_attribute_id')->where('product.product_status', 1)->where('product.deleted', 0)->where('store_id', $product['store_id'])->orderBy('created_at', 'desc')->where('product.id', '!=', $product_id)->limit(4)->get();

            $product['shop_products'] = $this->product_inv($shop_products, $user);

            // // Product Reviews
            // $product_reviews = [];
            // $condition = [
            //     "product_id"            => $product['product_id'],
            //     "product_attribute_id"  => $product['product_variant_id'],
            // ];
            // $sort_order = ["date", "desc"];
            // $ratings_data = $this->model_product->get_product_ratings($condition, $sort_order, 3);
            // if (! empty($ratings_data) ) {
            //     foreach ( $ratings_data as $row ) {
            //         $user_name  = (string) $row->user_first_name ." ". (string) $row->user_last_name;

            //         $user_image = '';
            //         if ( $row->image ) {
            //             $user_image = $this->config->item('upload_path') . $this->config->item('user_profile_image_upload_dir') . $row->image;
            //         }
            //         if ( !empty($user_image) && file_exists(FCPATH . $user_image) !== FALSE ) {
            //             $user_image = base_url() . $user_image;
            //         } else {
            //             $user_image = base_url() . "images/user_dummy.png";
            //         }

            //         $product_reviews[] = [
            //             "rating_id"     => (string) $row->rating_id,
            //             "rating"        => (string) $row->rating,
            //             "title"         => (string) $row->title,
            //             "feedback"      => (string) $row->feedback,
            //             "rated_date"    => (string) get_date_in_timezone($this->userTimezone, $row->rated_date, "Y-m-d H:i:s"),
            //             "user_name"     => (string) $user_name,
            //             "user_image"    => (string) $user_image,
            //         ];
            //     }
            // }
            // $product['reviews'] = $product_reviews;

            // $category_id = $product['category_id'];
            // $skip_product_id = $product['product_id'];
            // $filter_gender = $product['product_gender'];
            // $search_params = compact('user_id', 'category_id', 'skip_product_id', 'filter_gender');

            // $similar_product_data = $this->model_product->searchProducts($search_params, [], 4);
            // $product_ids = [];
            // foreach($similar_product_data as $row) {
            //     $product_ids[] = $row->product_id;
            // }

            // $similar_product_variations = [];
            // if (! empty($product_ids) ) {
            //     $product_attributes = $this->model_product->getProductAttributeVals($product_ids);
            //     foreach ($product_attributes as $attr_row) {
            //         if ( array_key_exists($attr_row->product_id, $similar_product_variations) === FALSE ) {
            //             $similar_product_variations[$attr_row->product_id] = [];
            //         }
            //         if ( array_key_exists($attr_row->attribute_id, $similar_product_variations[$attr_row->product_id]) === FALSE ) {
            //             $similar_product_variations[$attr_row->product_id][$attr_row->attribute_id] = [
            //                 'attribute_id' => $attr_row->attribute_id,
            //                 'attribute_type' => $attr_row->attribute_type,
            //                 'attribute_name' => $attr_row->attribute_name,
            //                 'attribute_values' => []
            //             ];
            //         }
            //         if ( array_key_exists($attr_row->attribute_values_id, $similar_product_variations[$attr_row->product_id][$attr_row->attribute_id]['attribute_values']) === FALSE ) {
            //             $similar_product_variations[$attr_row->product_id][$attr_row->attribute_id]['attribute_values'][$attr_row->attribute_values_id] = [
            //                 'attribute_value_id' => $attr_row->attribute_values_id,
            //                 'attribute_value_name' => $attr_row->attribute_values,
            //             ];
            //         }
            //     }
            // }

            // foreach ($similar_product_data as $row) {
            //     $p_row = process_product_data($row, $this->lang_code, $commission);
            //     $p_row["product_variations"] = [];
            //     if ( array_key_exists($row->product_id, $similar_product_variations) !== FALSE ) {
            //         $t_variations = array_values($similar_product_variations[$row->product_id]);
            //         foreach ($t_variations as $k => $v) {
            //             $t_variations[$k]['attribute_values'] = array_values($t_variations[$k]['attribute_values']);
            //         }
            //         $p_row["product_variations"] = $t_variations;
            //     }
            //     $similar_products[] = $p_row;
            // }

        } else {
            $status = "0";
            $product = [];
            $message = "No details found.";
        }

        $o_data['product_details'] = $product;
        return response()->json(['status' => $status, 'message' => $message, 'errors' => (object) $errors, 'oData' => $product], 200);

        // $where['product.deleted'] = 0;
        // $where['product.product_status'] = 1;
        // $where['product.id'] = $request->product_id;

        // $list = ProductModel::product_details($where);
        // $user = User::where('user_access_token', $access_token)->first();
        // // $products =  $this->product_inv($list,$user);
        // $o_data['details'] = $list;
        // return response()->json(['status' => $status, 'message' => $message, 'errors' => (object) $errors, 'oData' => $o_data], 200);
    }

    public function list_moda_products(Request $request)
    {
        $status = "1";
        $message = "";
        $o_data = [];
        $errors = [];
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'moda_sub_category' => 'required|numeric',
            'store_id' => 'numeric',
            'category_id' => 'numeric',
        ]);

        if ($validator->fails()) {
            $message = "Validation error occured";
            $errors = $validator->messages();
            return response()->json([
                'status' => "0",
                'message' => $message,
                'errors' => (object) $errors,
            ], 200);
        }

        $user_id = $this->validateAccesToken($request->access_token);
        $user = User::where('id', $user_id)->first();
        $limit = isset($request->limit) ? $request->limit : 10;
        $offset = isset($request->page) ? ($request->page - 1) * $request->limit : 0;

        $where['product.deleted'] = 0;
        $where['product.product_status'] = 1;
        $where['product.moda_sub_category'] = $request->moda_sub_category;
        $where['moda_sub_categories.gender'] = $user->gender;
        if(isset($request->store_id) && $request->store_id){
            $where['product.store_id'] = $request->store_id;
        }

        $filter['search_text'] = $request->search_text;
        $filter['store_id'] = $request->store_id;
        $filter['sort_by_price'] = $request->sort_by_price;
        $filter['sort_by_newest'] = $request->sort_by_newest;
        $filter['category_id'] = $request->category_id;

        $list = ProductModel::moda_products_list($where, $filter, $limit, $offset)->get();

        $products = $this->product_inv($list, $user,'moda');
        $moda_sub_category = ModaSubCategories::select('id', 'name')->where('id', $request->moda_sub_category)->first();
        $o_data['moda_sub_category'] = $moda_sub_category;
        $o_data['list'] = $products;

        return response()->json(['status' => $status, 'message' => $message, 'errors' => (object) $errors, 'oData' => $o_data], 200);
    }

    public function categorylist(Request $request)
    {
        $parent_id = 0;
        if(isset($request->category_id) && $request->category_id){
            $parent_id = $request->category_id;
        }
        $categories = Categories::select('id','name')->orderBy('sort_order','asc')->where(['deleted'=>0,'active'=>1,'parent_id'=>$parent_id])->get();
        return response()->json([
            'status' => "1",
            'message' => 'Data fetched successfully',
            'errors' => [],
            'oData' => $categories,
        ], 200);
    }

    public function brandslist(Request $request)
    {

        $brands = Brands::select('brand.*','brand.name as name','industry_types.name as industry')
            ->where(['brand.deleted' => 0])
            ->leftjoin('industry_types','industry_types.id','=','brand.industry_type')
            ->get();

        return response()->json([
            'status' => "1",
            'message' => 'Data fetched successfully',
            'errors' => [],
            'oData' => $brands,
        ], 200);
    }
}
