<?php

namespace App\Http\Controllers\Api\v1;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\VendorModel;
use App\Models\User;
use App\Models\StoreLikes;
use App\Models\Categories;
use App\Models\DeligateModel;
use DB,Validator;

class StoreController extends Controller
{
    //
    private function getUserId($access_token){
        $user_id = 0;
        $user = User::where(['user_access_token' => $access_token])->where('user_access_token','!=','')->get();
        if($user->count()>0){
            $user_id = $user->first()->id;
        }
        return $user_id;
    }
    private function validateAccesToken($access_token){
        $user = User::where(['user_access_token'=>$access_token])->get();
          
        if($user->count() == 0){ 
           http_response_code(401);
                echo json_encode([
                      'status' => "0",
                      'message' => 'Invalid login',
                      'oData' => (object)[],
                      'errors' => (object)[]
                  ]);
                  exit;
  
        }else{
            $user=$user->first();
            if($user != null){ //$user->active == 1
              return $user->id;
            }else{
                http_response_code(401);
                echo json_encode([
                      'status' => "0",
                      'message' => 'Invalid login',
                      'oData' => (object)[],
                      'errors' => (object)[]
                  ]);
                  exit;
                return response()->json([
                      'status' => "0",
                      'message' => 'Invalid login',
                      'oData' => (object)[],
                      'errors' => (object)[]
                  ], 401);
                  exit;
            }
        }
      }
      public function store_details(REQUEST $request){
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];
        /*$validator = Validator::make($request->all(), [
            
            'seller_user_id'=>'required'
        ]);*/
  
        /*if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        }else{*/
            $this->getUserId($request->access_token);
            $seller_id = $request->seller_user_id;
            $seller = VendorModel::with('user_location')->where(function($query) use ($seller_id){
                if ( isset ( $seller_id ) ){
                    $query->where('id', $seller_id);
                }

            })->select('id','user_image','name','email','phone','dial_code','about_me','rating','rated_users')->get();
            if($seller->count() > 0){
                $seller = $seller->first();
                $categories = Categories::where(['deleted'=>0,'active'=>1,'parent_id'=>0])->get()->toArray();
                $o_data['seller_data'] = $seller->toArray();
                $o_data['seller_data']['about_me'] = (string)$o_data['seller_data']['about_me'];
                $o_data['categories']  = $categories;
                $status = "1";
            }else{
                $message = "Invalid seller";
            }
            
        //}

        $o_data = convert_all_elements_to_string($o_data);

        return response()->json(['status'=>(string)$status,'message'=>$message,'oData'=>(object)$o_data,'errors'=>(object)$errors]);
    }
    public function get_deligates(REQUEST $request){
        $status = "0";
        $message = "";
        $o_data  =[];
        $errors  = [];
        $list = DeligateModel::where(['deligate_status'=>1])->get();
        if($list->count() > 0){
            $status = "1";
            $message = "data fetched successfully";
            $o_data['list']  = $list->toArray();
        }else{
            $message = "No data to list";
        }
        $o_data = convert_all_elements_to_string($o_data);

        return response()->json(['status'=>(string)$status,'message'=>$message,'oData'=>(object)$o_data,'errors'=>(object)$errors]);
    }
    public function get_vehicle_type(REQUEST $request){
        $status = "0";
        $message = "";
        $o_data  =[];
        $errors  = [];
        $list = DeligateModel::where(['deligate_status'=>1])->whereNotIn('id',[OWN_DELIGATE_ID])->get();
        if($list->count() > 0){
            $status = "1";
            $message = "data fetched successfully";
            $o_data['list']  = $list->toArray();
        }else{
            $message = "No data to list";
        }
        $o_data = convert_all_elements_to_string($o_data);

        return response()->json(['status'=>(string)$status,'message'=>$message,'oData'=>(object)$o_data,'errors'=>(object)$errors]);
    }
    public function like_dislike(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'store_id' => 'required|numeric',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $store_id = $request->store_id;
            $check_exist = StoreLikes::where(['store_id' => $store_id, 'user_id' => $user_id])->get();
            if ($check_exist->count() > 0) {
                StoreLikes::where(['store_id' => $store_id, 'user_id' => $user_id])->delete();
                $status = "1";
                $message = "disliked";
            } else {
                $like = new StoreLikes();
                $like->store_id = $store_id;
                $like->user_id = $user_id;
                $like->created_at = gmdate('Y-m-d H:i:s');
                $like->save();
                if ($like->id > 0) {
                    $status = "1";
                    $message = "liked";
                } else {
                    $message = "faild to like";
                }
            }
        }
        return response()->json(['status' => $status, 'error' => (object)$errors, 'message' => $message, 'oData' => (object)$o_data], 200);
    }
    public function product_like_dislike(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'product_id' => 'required|numeric',
            'product_attribute_id' => 'required|numeric',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $product_id = $request->product_id;
            $check_exist = ProductLikes::where(['product_id' => $product_id, 'user_id' => $user_id,'product_attribute_id'=>$request->product_attribute_id])->get();
            if ($check_exist->count() > 0) {
                ProductLikes::where(['product_id' => $product_id, 'user_id' => $user_id,'product_attribute_id'=>$request->product_attribute_id])->delete();
                $status = "1";
                $message = "disliked";
            } else {
                $like = new ProductLikes();
                $like->product_id = $product_id;
                $like->user_id = $user_id;
                $like->product_attribute_id = $request->product_attribute_id;
                $like->created_at = gmdate('Y-m-d H:i:s');
                $like->save();
                if ($like->id > 0) {
                    $status = "1";
                    $message = "liked";
                } else {
                    $message = "faild to like";
                }
            }
        }
        return response()->json(['status' => $status, 'error' => (object)$errors, 'message' => $message, 'oData' => (object)$o_data], 200);
    }
}
