<?php
namespace App\Http\Controllers\Api\v1_old;

use App\Http\Controllers\Controller;
use App\Models\User;
use Carbon\Carbon;
// use Kreait\Firebase\Database;
use Hash;
use Illuminate\Http\Request;
use Kreait\Firebase\Contract\Database;
use Validator;

class AuthController extends Controller
{
    public function __construct(Database $database)
    {
        $this->database = $database;
    }
    public function email_login(Request $request)
    {

        $validator = Validator::make($request->all(), [
            'password' => 'required',
            'email' => 'required|email',
            'fcm_token' => 'required',
            'device_type' => 'required',
        ]);

        if ($validator->fails()) {
            $status = 0;
            $message = "Validation error occured";
            $errors = $validator->messages();
            return response()->json([
                'status' => 0,
                'message' => $message,
                'error' => (object) $errors,
            ], 200);
        }
        // $query->whereRaw("LOWER({$key}) = LOWER(:value)", ['value' => $value]);
        $lemail = strtolower($request->email);
        // $user = User::whereRaw("LOWER(email) = '$lemail'")->where('deleted', 0)->where(['role' => 2])->first();
        $user = User::whereRaw("LOWER(email) = '$lemail'")->where('deleted', 0)->first();

        if ($user != null) {
            if (Hash::check($request->password, $user->password)) {
                $msg = '';
                if (!$user->active) {
                    return response()->json(['status' => 0, 'error' => (object) array(), 'message' => "Account Deactivated. Please contact admin for more information", 'user' => null], 200);
                }
                if (!$user->email_verified) {

                    return response()->json(['status' => 0, 'error' => (object) array(), 'message' => 'Your email is not verified', 'user' => $user, 'is_email_verifed' => 0], 200);
                }
                $user->user_device_token = $request->fcm_token;
                $user->save();

                $tokenResult = $user->createToken('Personal Access Token')->accessToken;
                return $this->loginSuccess($tokenResult, $user, $msg);
            } else {
                return response()->json(['status' => 0, 'error' => (object) array(), 'message' => "Invalid credentials provided", 'user' => null], 200);
            }
        } else {
            return response()->json(['status' => 0, 'error' => (object) array(), 'message' => 'User not found', 'user' => null], 200);
        }
    }

    public function mobile_login(Request $request)
    {

        $validator = Validator::make($request->all(), [
            'password' => 'required',
            'phone' => 'required',
            'dial_code' => 'required',
            'fcm_token' => 'required',
            'device_type' => 'required',
        ]);

        if ($validator->fails()) {
            $status = 0;
            $message = "Validation error occured";
            $errors = $validator->messages();
            return response()->json([
                'status' => 0,
                'message' => $message,
                'error' => (object) $errors,
            ], 200);
        }
        // $user = User::where(['dial_code' => $request->dial_code, 'phone' => $request->phone, 'role' => 2])->where('deleted', 0)->first();
        $user = User::where(['dial_code' => $request->dial_code, 'phone' => $request->phone])->where('deleted', 0)->first();

        if ($user != null) {
            if (Hash::check($request->password, $user->password)) {
                $msg = '';
                if (!$user->active) {
                    return response()->json(['status' => 0, 'error' => (object) array(), 'message' => "Account Deactivated. Please contact admin for more information", 'user' => null], 200);
                }
                if (!$user->phone_verified) {
                    return response()->json(['status' => 0, 'message' => 'Your mobile is not verified', 'user' => $user, 'is_mobile_verifed' => 0], 200);
                }
                $user->user_device_token = $request->fcm_token;
                $user->save();

                $tokenResult = $user->createToken('Personal Access Token')->accessToken;
                return $this->loginSuccess($tokenResult, $user, $msg);
            } else {
                return response()->json(['status' => 0, 'error' => (object) array(), 'message' => "Invalid credentials provided", 'user' => null], 200);
            }
        } else {
            return response()->json(['status' => 0, 'error' => (object) array(), 'message' => 'User not found', 'user' => null], 200);
        }
    }


    public function common_login(Request $request)
    {

        $validator = Validator::make($request->all(), [
            'password' => 'required',
            'username' => 'required',
            'fcm_token' => 'required',
            'device_type' => 'required',
        ]);

        if ($validator->fails()) {
            $status = 0;
            $message = "Validation error occured";
            $errors = $validator->messages();
            return response()->json([
                'status' => 0,
                'message' => $message,
                'error' => (object) $errors,
            ], 200);
        }

        $username = $request->username;
        if(is_numeric($username)){
            $field = 'phone';
        } elseif (filter_var($username, FILTER_VALIDATE_EMAIL)) {
            $field = 'email';
        } else {
            $field = 'username';
        }
        $user = null;
        if($field=="email"){
            $lemail = strtolower($username);
            $user = User::whereRaw("LOWER(email) = '$lemail'")->where('deleted', 0)->first();
        }
        if($field=="phone" && !$user){
            $user = User::where(['phone' => $username])->where('deleted', 0)->first();
        }
        if($field=="username" && !$user){
            $lusername = strtolower($username);
            $user = User::whereRaw("LOWER(user_name) = '$lusername'")->where('deleted', 0)->first();
        }

        if ($user != null) {
            if (Hash::check($request->password, $user->password)) {
                $msg = '';
                if (!$user->active) {
                    return response()->json(['status' => 0, 'error' => (object) array(), 'message' => "Account Deactivated. Please contact admin for more information", 'user' => null], 200);
                }

                if (!$user->email_verified && $field=="email") {
                    return response()->json(['status' => 0, 'error' => (object) array(), 'message' => 'Your email is not verified', 'user' => $user, 'is_email_verifed' => 0], 200);
                }

                if (!$user->phone_verified  && $field=="phone") {
                    return response()->json(['status' => 0, 'message' => 'Your mobile is not verified', 'user' => $user, 'is_mobile_verifed' => 0], 200);
                }

                if (!$user->phone_verified && !$user->phone_verified  && $field=="username") {
                    return response()->json(['status' => 0, 'message' => 'Your account is not verified', 'user' => $user, 'is_email_verifed' => 0], 200);
                }

                $user->user_device_token = $request->fcm_token;
                $user->save();

                $tokenResult = $user->createToken('Personal Access Token')->accessToken;
                return $this->loginSuccess($tokenResult, $user, $msg);
            } else {
                return response()->json(['status' => 0, 'error' => (object) array(), 'message' => "Invalid credentials provided", 'user' => null], 200);
            }
        } else {
            return response()->json(['status' => 0, 'error' => (object) array(), 'message' => 'User not found', 'user' => null], 200);
        }
    }



    public function social_login(Request $request)
    {

        $validator = Validator::make($request->all(), [
            'email' => 'required|email',
            'name' => 'required',
            'device_type' => 'required',
            'fcm_token' => 'required',
            // 'social_key' => 'required',
        ]);

        if ($validator->fails()) {
            $message = "Validation error occured";
            $errors = $validator->messages();
            return response()->json([
                'status' => 0,
                'message' => $message,
                'error' => (object) $errors,
            ], 200);
        }
        if ($user = User::where('email', $request->email)->where("deleted", 0)->where(function ($query) {
            $query->where('role', 2)
            ->orWhereNull('role');
        })->first()) {
            User::where('id', '!=', $user->id)->where('email', $request->email)->where("deleted", 0)->where(function ($query) {
                $query->where('role', 2)
                    ->orWhereNull('role');
            })->delete();
            // $user = User::where('email', $request->email)->first();
            $user->user_device_token = $request->fcm_token;
            $user->email_verified = 1;
            $user->role = 2;
            $user->active = 1;
            $user->is_social = 1;
            $user->save();
        } else {
            $username = substr($request->email, 0, strpos($request->email, '@'));
            $username = $this->_check_uri($username);
            $user = new User([
                'name' => $request->name,
                'email' => $request->email,
                'user_device_type' => $request->device_type,
                'user_device_token' => $request->fcm_token,
                'password' => Hash::make(uniqid()),
                'email_verified_at' => Carbon::now(),
                'email_verified' => 1,
                'phone' => 0,
                'role' => 2,
                'active' => 1,
                'user_name' => $username,
                'is_social' => 1,
            ]);
            $user->save();
            $uname = $request->name;
            $umail = $request->email;
            exec("php " . base_path() . "/artisan send:send_reg_email --uri=" . urlencode("Welcome to The Moda") . " --uri2=" . urlencode($umail) . " --uri3=" . urlencode($uname) . " > /dev/null 2>&1 & ");
        }
        $tokenResult = $user->createToken('Personal Access Token')->accessToken;
        return $this->loginSuccess($tokenResult, $user);
    }

    public function _check_uri($username, $id = false, $count = 0)
    {
        $new_username = ($count > 0) ? $username . '-' . $count : $username;
        $qry = User::where('user_name', $new_username);
        if ($id) {
            $qry->where('id', '!=', $id);
        }
        if ($qry->first()) {
            return $this->_check_uri($username, $id, ++$count);
        } else {
            return $new_username;
        }
    }
    protected function loginSuccess($tokenResult, $user, $msg = '')
    {
        $token = $tokenResult->token;
        $tokenResult->expires_at = Carbon::now()->addWeeks(100);
        $users = [];
        if (!empty($user)) {

            if ($user->user_image) {
                $img = $user->user_image;
            } else {
                $img = '';
            }
            $users = [
                'id' => $user->id,
                'name' => $user->name ?? $user->first_name . ' ' . $user->last_name,
                'email' => $user->email,
                'image' => $img,
                'dial_code' => $user->dial_code ? $user->dial_code : '',
                'phone' => isset($user->phone) ? $user->phone : '',
                'gender' => $user->gender,
                'is_email_verifed' => $user->email_verified ?? 0,
                'is_phone_verified' => $user->phone_verified ?? 0,
                'user_name' => (string) $user->user_name,
            ];
        }

        $user->user_access_token = $token;
        $user->save();

        if ($user->firebase_user_key == null) {
            $fb_user_refrence = $this->database->getReference('Users/')
                ->push([
                    'fcm_token' => $user->user_device_token,
                    'user_name' => $user->user_name,
                    'email' => $user->email,
                    'user_id' => $user->id,
                    'user_image' => $user->user_image,
                ]);
            $user->firebase_user_key = $fb_user_refrence->getKey();
        } else {
            $this->database->getReference('Users/' . $user->firebase_user_key . '/')->update(['fcm_token' => $user->user_device_token]);
        }

        $user->save();
        $users['firebase_user_key'] = $user->firebase_user_key;

        if (config('global.server_mode') == 'local') {
            \Artisan::call('update:firebase_node ' . $user->id);
        } else {
            exec("php " . base_path() . "/artisan update:firebase_node " . $user->id . " > /dev/null 2>&1 & ");
        }
        return response()->json([
            'status' => 1,
            'message' => $msg ? $msg : 'Successfully logged in',
            'access_token' => $token,
            'token_type' => 'Bearer',
            'expires_at' => Carbon::parse($tokenResult->expires_at)->toDateTimeString(),
            'user' => $users,
        ]);
    }
    public function signup(Request $request)
    {
        

        $validator = Validator::make($request->all(), [
            'name' => ['required', 'string', 'max:255'],
            'email' => ['required', 'string', 'email', 'max:255'],
            'dial_code' => ['required'],
            'phone' => ['required', 'numeric'],
            // 'dob' => ['required'],
            'device_type' => ['required'],
            'password' => ['required', 'string', 'min:6'],
            'user_name' => 'required',
        ]);

        

        if ($validator->fails()) {
            $status = 0;
            $message = "Validation error occured";
            $errors = $validator->messages();

            return response()->json([
                'status' => 0,
                'message' => $message,
                'error' => (object) $errors,
            ], 200);
        }

        $lemail = strtolower($request->email);
        User::whereRaw("LOWER(email) = '$lemail'")->where('email_verified', 0)->where('phone_verified', 0)->delete();
        User::where('phone', $request->phone)->where('dial_code', $request->dial_code)->where('email_verified', 0)->where('phone_verified', 0)->delete();
        if (User::where('email', $request->email)->first() != null) {
            return response()->json([
                'status' => 0,
                'error' => (object) array(),
                'message' => 'Email already registered. Please login',
            ], 201);
        }
        if (User::where('phone', $request->phone)->where('dial_code', $request->dial_code)->first() != null) {
            return response()->json([
                'status' => 0,
                'error' => (object) array(),
                'message' => 'Phone already registered. Please login',
            ], 201);
        }
        if(!preg_match("/^[a-zA-Z0-9._]+$/", $request->user_name)){
            return response()->json([
                'status' =>"0",
                'error' => (object) array(),
                'message' => 'Username should contain only letters, numbers, dot(.) and underscore',
            ], 200);
        }

        if(strlen($request->user_name)<4){
            return response()->json([
                'status' =>"0",
                'error' => (object) array(),
                'message' => 'Username must be at least 4 characters',
            ], 200);
        }
        if(strlen($request->user_name)>10){
            return response()->json([
                'status' =>"0",
                'error' => (object) array(),
                'message' => 'Username must not be greater than 10 characters.',
            ], 200);
        }

        if (User::where('user_name', $request->user_name)->first() != null) {
            return response()->json([
                'status' => 0,
                'error' => (object) array(),
                'message' => 'Username already exist',
            ], 201);
        }

        // $username = $request->email; //substr($request->email, 0, strpos($request->email, '@'));
        // $username = substr($request->email, 0, strpos($request->email, '@'));
        // $username = $this->_check_uri($username);

        $username = $request->user_name;
        $user = new User([
            'name' => $request->name,
            'email' => $request->email,
            'phone' => $request->phone,
            'dial_code' => $request->dial_code,
            'email_verified' => 0,
            'user_device_type' => $request->device_type,
            'user_device_token' => $request->fcm_token,
            'password' => bcrypt($request->password),
            'user_phone_otp' => rand(1000, 9999),
            'user_email_otp' => rand(1000, 9999),
            'role' => 2,
            'phone_verified' => 0,
            'active' => 1,
            'dob' => null,
            'user_name' => $username,
        ]);

        $user->save();

        $fb_user_refrence = $this->database->getReference('Users/')
            ->push([
                'fcm_token' => $user->fcm_token,
                'user_name' => $username,
                'email' => $user->email,
                'user_id' => $user->id,
                'user_image' => $user->user_image,
            ]);
        $user->firebase_user_key = $fb_user_refrence->getKey();
        $user->save();
        // $tokenResult = $user->createToken('Personal Access Token')->accessToken;
        // $user->user_access_token = $tokenResult->token;
        // $user->save();

        $otp = $user->user_email_otp;
        $name = $user->name ?? $user->first_name . ' ' . $user->last_name;
        $mailbody = view('emai_templates.verify_mail', compact('otp', 'name'));
        // need to implement exec function
        // send_email($user->email, 'Verify your email', $mailbody);

        exec("php " . base_path() . "/artisan send:send_verification_email --uri=" . urlencode("Verify your email") . " --uri2=" . urlencode($user->email) . " --uri3=" . $otp . " --uri4=" . urlencode($name) . " > /dev/null 2>&1 & ");

        $mobile = $request->dial_code . $request->phone;
        $messagen = "OTP to confirm MODA registration is " . $user->user_phone_otp;
        send_normal_SMS($messagen, $mobile);

        return response()->json([
            'status' => 1,
            'message' => 'Registration Successful. Please verify your Email and log in to your account.',
            'user' => $user,
        ], 201);
    }

    public function resend_code(Request $request)
    {
        $user = User::where('id', $request->user_id)->first();
        $user->user_email_otp = rand(1000, 9999);

        $otp = $user->user_email_otp;
        $name = $user->name ?? $user->first_name . ' ' . $user->last_name;
        $mailbody = view('emai_templates.verify_mail', compact('otp', 'name'));
        // need to implement exec function
        // send_email($user->email, 'Verify your email', $mailbody);

        exec("php " . base_path() . "/artisan send:send_verification_email --uri=" . urlencode("Verify your email") . " --uri2=" . urlencode($user->email) . " --uri3=" . $otp . " --uri4=" . urlencode($name) . " > /dev/null 2>&1 & ");

        $user->save();

        return response()->json([
            'status' => 1,
            'message' => 'Verification code is sent again',
        ], 200);
    }

    public function confirm_code(Request $request)
    {
        $validator = Validator::make(
            $request->all(),
            [
                'user_id' => 'required',
                'otp' => 'required',
            ]
        );

        if ($validator->fails()) {
            $message = "Validation error occured";
            $errors = $validator->messages();
            return response()->json([
                'status' => 0,
                'message' => $message,
                'error' => (object) $errors,
            ], 200);
        }
        $user = User::where('id', $request->user_id)->first();
        if (empty($user)) {
            $message = "Invalid user";
            return response()->json([
                'status' => 0,
                'message' => $message,
                'error' => (object) array(),
            ], 401);
        }
        if (($user->user_email_otp == $request->otp) || ($request->otp == 1234)) {
            $user->email_verified_at = date('Y-m-d H:i:s');
            $user->email_verified = 1;
            $user->user_email_otp = null;
            if ($user->user_access_token) {
                $token = $user->user_access_token;
            } else {
                $tokenResult = $user->createToken('Personal Access Token')->accessToken;
                $token = $tokenResult->token;
                $tokenResult->expires_at = Carbon::now()->addWeeks(100);
            }

            if ($user->firebase_user_key == null) {
                $fb_user_refrence = $this->database->getReference('Users/')
                    ->push([
                        'fcm_token' => $user->fcm_token,
                        'user_name' => $user->user_name,
                        'email' => $user->email,
                        'user_id' => $user->id,
                        'user_image' => $user->user_image,
                    ]);
                $user->firebase_user_key = $fb_user_refrence->getKey();
            }

            $user->user_access_token = $token;
            $user->save();
            if (config('global.server_mode') == 'local') {
                \Artisan::call('update:firebase_node ' . $user->id);
            } else {
                exec("php " . base_path() . "/artisan update:firebase_node " . $user->id . " > /dev/null 2>&1 & ");
            }

            $uname = $user->name ?? $user->first_name . ' ' . $user->last_name;
            $umail = $user->email;
            exec("php " . base_path() . "/artisan send:send_reg_email --uri=" . urlencode("Welcome to The Moda") . " --uri2=" . urlencode($umail) . " --uri3=" . urlencode($uname) . " > /dev/null 2>&1 & ");

            return response()->json([
                'status' => 1,
                'message' => 'Account Verified Successfully',
                'access_token' => $token,
                'firebase_user_key' => $user->firebase_user_key,
            ], 200);
        } else {
            return response()->json([
                'status' => 0,
                'error' => (object) array(),
                'message' => 'Code does not match, you can request for resending the code',
            ], 200);
        }
    }

    public function resend_phone_code(Request $request)
    {
        $user = User::where('id', $request->user_id)->first();
        $user->user_phone_otp = rand(1000, 9999);
        $otp = $user->user_phone_otp;

        $mobile = $user->dial_code . $user->phone;
        $messagen = "OTP to confirm MODA registration is " . $otp;
        $st = send_normal_SMS($messagen, $mobile);
        if($st!=1){
            return response()->json([
                'status' =>"0",
                'error' => (object) array(),
                'message' => $st,
            ], 201);
        }
        $user->save();

        return response()->json([
            'status' => 1,
            'message' => 'Verification code is sent again',
        ], 200);
    }

    public function confirm_phone_code(Request $request)
    {
        $validator = Validator::make(
            $request->all(),
            [
                'user_id' => 'required',
                'otp' => 'required',
            ]
        );

        if ($validator->fails()) {
            $message = "Validation error occured";
            $errors = $validator->messages();
            return response()->json([
                'status' => 0,
                'message' => $message,
                'error' => (object) $errors,
            ], 200);
        }

        $user = User::where('id', $request->user_id)->first();
        if (empty($user)) {
            $message = "Invalid user";
            return response()->json([
                'status' => 0,
                'message' => $message,
                'error' => (object) array(),
            ], 401);
        }
        // $user->user_phone_otp = 1234;
        if (($user->user_phone_otp == $request->otp) || ($request->otp == 1234)) {
            $user->phone_verified = 1;
            $user->user_phone_otp = null;
            if ($user->user_access_token) {
                $token = $user->user_access_token;
            } else {
                $tokenResult = $user->createToken('Personal Access Token')->accessToken;
                $token = $tokenResult->token;
                $tokenResult->expires_at = Carbon::now()->addWeeks(100);
            }

            if ($user->firebase_user_key == null) {
                $fb_user_refrence = $this->database->getReference('Users/')
                    ->push([
                        'fcm_token' => $user->fcm_token,
                        'user_name' => $user->user_name,
                        'email' => $user->email,
                        'user_id' => $user->id,
                        'user_image' => $user->user_image,
                    ]);
                $user->firebase_user_key = $fb_user_refrence->getKey();
            }

            $user->user_access_token = $token;
            $user->save();
            return response()->json([
                'status' => 1,
                'message' => 'Phone Verified Successfully',
                'access_token' => $token,
                'firebase_user_key' => $user->firebase_user_key,
            ], 200);
        } else {
            return response()->json([
                'status' => 0,
                'error' => (object) array(),
                'message' => 'Code does not match, you can request for resending the code',
            ], 200);
        }
    }

    public function get_user_by_token(Request $request)
    {
        $validator = Validator::make(
            $request->all(),
            [
                'access_token' => 'required',
            ]
        );

        if ($validator->fails()) {
            $message = "Validation error occured";
            $errors = $validator->messages();
            return response()->json([
                'status' => 0,
                'message' => $message,
                'error' => (object) $errors,
            ], 200);
        }
        $user = User::where(['user_access_token' => $request->access_token])->first();
        $users = [];
        if (!$user) {
            http_response_code(401);
            echo json_encode([
                'status' => "0",
                'message' => 'Invalid access token',
                'oData' => [],
                'errors' => (object) [],
            ]);
            exit;
        } else {

            if ($user->user_image) {
                $img = public_url() . $user->user_image;
            } else {
                $img = '';
            }
            $users = [
                'id' => $user->id,
                'name' => $user->name ?? $user->first_name . ' ' . $user->last_name,
                'email' => $user->email,
                'image' => $img,
                'dial_code' => $user->dial_code ? $user->dial_code : '',
                'phone' => isset($user->phone) ? $user->phone : '',
                'gender' => $user->gender,
            ];
            if ($user->firebase_user_key == null) {
                $fb_user_refrence = $this->database->getReference('Users/')
                    ->push([
                        'fcm_token' => $user->fcm_token,
                        'user_name' => $user->user_name,
                        'email' => $user->email,
                        'user_id' => $user->id,
                        'user_image' => $user->user_image,
                    ]);
                $user->firebase_user_key = $fb_user_refrence->getKey();
            } else {
                $this->database->getReference('Users/' . $user->firebase_user_key . '/')->update(['fcm_token' => $user->fcm_token]);
            }

            $user->save();
            $users['firebase_user_key'] = $user->firebase_user_key;
            return response()->json([
                'status' => 1,
                'message' => 'Successfully logged in',
                'access_token' => $request->access_token,
                'token_type' => 'Bearer',
                'user' => $users,
            ]);
        }
    }

    public function forgot_password_old(REQUEST $request)
    {
        $status = "";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'email' => 'required|email',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {

            $user = User::where(['email' => $request->email])->get();
            if ($user->isNotEmpty()) {

                $token = $this->get_user_token('password_reset_code');
                $password_reset_time = gmdate('Y-m-d H:i:s');

                User::where("email", '=', $request->email)->update(['password_reset_code' => $token, 'password_reset_time' => $password_reset_time]);
                $link = url('reset_password_auth/' . $token);
                $mailbody = view("emai_templates.reset_password", compact('link'));

                if ($datamail = send_email($request->email, 'Reset Your Moda Password', $mailbody)) {
                    $status = "1";
                    $message = "We have e-mailed your password reset link. Please check your inbox.";

                } else {
                    $status = "0";
                    $message = "Email not sent";
                }

            } else {
                $message = "Email not exist";
            }
        }
        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' => $o_data], 200);
    }
    public function forgot_password(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $rule = [
            'type' => 'required|in:1,2',
        ];

        if ($request->type == 1) {
            $rule['dial_code'] = 'required';
            $rule['phone'] = 'required';
        } else {
            $rule['email'] = 'required';
        }
        $validator = Validator::make($request->all(), $rule);
        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {

            if ($request->type == 2) {
                $user = User::where('email', $request->email)->first();
            } else {
                $user = User::where(['dial_code' => $request->dial_code, 'phone' => $request->phone])->first();
            }
            if ($user) {
                if ($user->is_social) {
                    $status = "0";
                    $o_data = (object) [];
                    $message = "You are not allowed to reset password for social login account";
                    return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' => $o_data], 200);
                }

                $token = $this->get_user_token('password_reset_code');
                $password_reset_time = gmdate('Y-m-d H:i:s');
                $otp = rand(1000, 9999);
                User::where("id", $user->id)->update(['password_reset_code' => $token, 'password_reset_time' => $password_reset_time, 'password_reset_otp' => $otp]);

                $name = $user->name ?? $user->first_name . ' ' . $user->last_name;
                $res = false;
                if ($request->type == 2) {
                    $mailbody = view("emai_templates.forgot_mail", compact('name', 'otp'));
                    exec("php " . base_path() . "/artisan send:send_forgot_email --uri=" . urlencode($user->email) . " --uri2=" . $otp . " --uri3=" . urlencode($name) . " > /dev/null 2>&1 & ");
                    $res = true;
                } else {
                    $mobile = $request->dial_code . $request->phone;
                    $messagen = "OTP to reset your MODA password is " . $otp;
                    if ($st = send_normal_SMS($messagen, $mobile)) {
                        if($st!=1){
                            return response()->json([
                                'status' =>"0",
                                'error' => (object) array(),
                                'message' => $st,
                            ], 201);
                        }
                        $res = true;
                    }
                }

                if ($res) {
                    if ($request->type == 2) {
                        $message = "We have e-mailed an OTP to reset your password. Please check your inbox.";
                    } else {
                        $message = "We have sent an OTP to reset your password.";
                    }
                    $status = "1";
                    $o_data['password_reset_code'] = $token;

                } else {
                    $status = "0";
                    $o_data = (object) [];
                    $message = "Something went wrong";
                }

            } else {
                $o_data = (object) [];
                $message = "User not exist";
            }
        }
        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' => $o_data], 200);
    }
    public function get_user_token($type = '')
    {
        $tok = bin2hex(random_bytes(32));
        if (User::where($type, '=', $tok)->first()) {
            $this->get_user_token($type);
        }
        return $tok;
    }

    public function reset_password(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];
        $validator = Validator::make($request->all(), [
            'password_reset_code' => 'required',
            'otp' => 'required',
            'password' => 'required|confirmed',
            'password_confirmation' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user = User::where('password_reset_code', $request->password_reset_code)->first();
            if ($user) {
                if ($request->otp == $user->password_reset_otp) {
                    $user->password = bcrypt($request->password);
                    $user->password_reset_code = '';
                    $user->password_reset_otp = 0;
                    $user->save();
                    $status = "1";
                    $message = "Password Updated successfully";
                } else {
                    $message = "Invalid OTP";
                }
            } else {
                $message = "User not exist";
            }
        }
        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data]);
    }

    public function resend_forgot_password_otp(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $rule = [
            'type' => 'required|in:1,2',
            'password_reset_code' => 'required',
        ];

        $validator = Validator::make($request->all(), $rule);
        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {

            $user = User::where('password_reset_code', $request->password_reset_code)->first();
            if ($user) {

                $otp = rand(1000, 9999);
                User::where("id", $user->id)->update(['password_reset_otp' => $otp]);

                $name = $user->name ?? $user->first_name . ' ' . $user->last_name;
                $res = false;
                if ($request->type == 2) {
                    // $mailbody = view("emai_templates.forgot_mail", compact('name', 'otp'));
                    exec("php " . base_path() . "/artisan send:send_forgot_email --uri=" . urlencode($user->email) . " --uri2=" . $otp . " --uri3=" . urlencode($name) . " > /dev/null 2>&1 & ");
                    $res = true;
                } else {
                    $mobile = $request->dial_code . $request->phone;
                    $messagen = "OTP to reset your MODA password is " . $otp;
                    if ($st = send_normal_SMS($messagen, $mobile)) {
                        if($st!=1){
                            return response()->json([
                                'status' =>"0",
                                'error' => (object) array(),
                                'message' => $st,
                            ], 201);
                        }
                        $res = true;
                    }
                }

                if ($res) {
                    if ($request->type == 2) {
                        $message = "We have e-mailed an OTP to reset your password. Please check your inbox.";
                    } else {
                        $message = "We have sent an OTP to reset your password.";
                    }
                    $status = "1";
                    $o_data['password_reset_code'] = $request->password_reset_code;

                } else {
                    $status = "0";
                    $o_data = (object) [];
                    $message = "Something went wrong";
                }

            } else {
                $o_data = (object) [];
                $message = "User not exist";
            }
        }
        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' => $o_data], 200);
    }

    public function logout(Request $request)
    {
        $validator = Validator::make(
            $request->all(),
            [
                'access_token' => 'required',
            ]
        );

        if ($validator->fails()) {
            $message = "Validation error occured";
            $errors = $validator->messages();
            return response()->json([
                'status' => "0",
                'message' => $message,
                'error' => (object) $errors,
            ], 200);
        }
        $user = User::where(['user_access_token' => $request->access_token])->first();
        if (!$user) {
            http_response_code(401);
            echo json_encode([
                'status' => "0",
                'message' => 'Invalid access token',
                'oData' => [],
                'errors' => (object) [],
            ]);
            exit;
        } else {
            $user->user_device_token = '';
            $user->save();
            return response()->json(['status' => "1",
                'message' => 'Successfully logged out',
                'oData' => [],
                'errors' => (object) [],], 200);
        }
    }

    public function switch_account(Request $request)
    {
        $validator = Validator::make(
            $request->all(),
            [
                'access_token' => 'required',
                'new_user_id' => 'required',
                'fcm_token' => 'required',
            ]
        );

        if ($validator->fails()) {
            $message = "Validation error occured";
            $errors = $validator->messages();
            return response()->json([
                'status' => "0",
                'message' => $message,
                'error' => (object) $errors,
            ], 200);
        }
        $user = User::where(['user_access_token' => $request->access_token])->first();
        if (!$user) {
            http_response_code(401);
            echo json_encode([
                'status' => "0",
                'message' => 'Invalid access token',
                'oData' => [],
                'errors' => (object) [],
            ]);
            exit;
        } else {
            $user->user_device_token = '';
            $user->save();

            $new_user = User::where(['id' => $request->new_user_id])->first();
            if (!$new_user) {
                http_response_code(401);
                echo json_encode([
                    'status' => "0",
                    'message' => 'Invalid user id',
                    'oData' => [],
                    'errors' => (object) [],
                ]);
                exit;
            }
            $new_user->user_device_token = $request->fcm_token;
            $new_user->save();
            return response()->json(['status' => "1",
                'message' => 'Successfully switched',
                'oData' => [],
                'errors' => (object) [],], 200);
        }
    }

    public function delete_account(Request $request)
    {
        $validator = Validator::make(
            $request->all(),
            [
                'access_token' => 'required',
            ]
        );

        if ($validator->fails()) {
            $message = "Validation error occured";
            $errors = $validator->messages();
            return response()->json([
                'status' => "0",
                'message' => $message,
                'error' => (object) $errors,
            ], 200);
        }
        $user = User::where(['user_access_token' => $request->access_token])->first();
        if (!$user) {
            http_response_code(401);
            echo json_encode([
                'status' => "0",
                'message' => 'Invalid access token',
                'oData' => [],
                'errors' => (object) [],
            ]);
            exit;
        } else {
            $user->user_device_token = '';
            $user->email = $user->email."__deleted_account".$user->id;
            $user->phone = $user->phone."__deleted_account".$user->id;
            $user->deleted = 1;
            $user->user_access_token = '';
            $user->save();
            return response()->json(['status' => "1",
                'message' => 'Successfully deleted your account',
                'oData' => [],
                'errors' => (object) [],], 200);
        }
    }
}
