<?php

namespace App\Http\Controllers\Api\v1_old;

use App\Http\Controllers\Controller;
use App\Models\Cities;
use App\Models\CountryModel;
use App\Models\States;
use App\Models\Article;
use App\Models\HelpModel;
use App\Models\Categories;
use Illuminate\Http\Request;

class CMS extends Controller
{
    //
    public function countrylist(Request $request)
    {
        $countries = CountryModel::where('active', 1)->get();
        if (!empty($countries)) {
            foreach ($countries as $key => $value) {
                $value->dial_code = (string) $value->dial_code;

                //$value->country_flag = get_uploaded_image_url($value->country_flag,config('global.flag_image_upload_dir'),'admin-assets/assets/img/placeholder.jpg');

            }
        }
        return response()->json([
            'status' => "1",
            'message' => 'Data fetched successfully',
            'errors' => [],
            'oData' => $countries,
        ], 200);
    }

    public function states(Request $request)
    {
        $where['states.deleted'] = 0;
        $where['states.active'] = 1;
        if ($request->country_id) {
            $where['states.country_id'] = $request->country_id;
        }
        $states = States::select('id', 'name')->where($where)->orderby('name', 'asc')->get();
        return response()->json([
            'status' => "1",
            'message' => 'Data fetched successfully',
            'errors' => [],
            'oData' => $states,
        ], 200);
    }
    public function cities(Request $request)
    {
        $where['cities.deleted'] = 0;
        $where['cities.active'] = 1;
        if ($request->state_id) {
            $where['cities.state_id'] = $request->state_id;
        }
        $cities = Cities::select('id', 'name')->where($where)->orderby('name', 'asc')->get();
        return response()->json([
            'status' => "1",
            'message' => 'Data fetched successfully',
            'errors' => [],
            'oData' => $cities,
        ], 200);
    }
    public function get_page(Request $request)
    {
      $status = "0";
      $message = "";
      $o_data = [];


        $page_data = Article::where(['id'=>$request->page_id])->get();
        if($page_data->count() > 0){
          $status = "1";
          $message = "data fetched successfully";
          $o_data = $page_data->first();
        }
        return response()->json([
            'status' => $status,
            'message' => $message,
            'errors' => [],
            'oData' => $o_data,
        ], 200);
    }
    public function get_faq(Request $request)
    {
      $status = "0";
      $message = "";
      $o_data = [];


        $page_data = \App\Models\FaqModel::orderBy('id','asc')->get();
        if($page_data->count() > 0){
          $status = "1";
          $message = "data fetched successfully";
          $o_data = $page_data;
        }
        return response()->json([
            'status' => $status,
            'message' => $message,
            'errors' => [],
            'oData' => $o_data,
        ], 200);
    }
    public function gethelp(Request $request)
    {
      $status = "0";
      $message = "";
      $o_data = [];


        $page_data = HelpModel::orderBy('id','asc')->get();
        if($page_data->count() > 0){
          $status = "1";
          $message = "data fetched successfully";
          $o_data = $page_data;
        }
        return response()->json([
            'status' => $status,
            'message' => $message,
            'errors' => [],
            'oData' => $o_data,
        ], 200);
    }
    public function categorylist(Request $request)
    {
        $parent_id = 0;
        if(isset($request->category_id) && $request->category_id){
            $parent_id = $request->category_id;
        }
        $categories = Categories::select('id','name')->orderBy('sort_order','asc')->where(['deleted'=>0,'active'=>1,'parent_id'=>$parent_id])->get();
        return response()->json([
            'status' => "1",
            'message' => 'Data fetched successfully',
            'errors' => [],
            'oData' => $categories,
        ], 200);
    }
}
