<?php

namespace App\Http\Controllers\Api\v1_old;

use App\Http\Controllers\Controller;
use App\Models\Cart;
use App\Models\CouponCategory;
use App\Models\CouponHistory;
use App\Models\Coupons;
use App\Models\OrderModel;
use App\Models\OrderProductsModel;
use App\Models\ProductModel;
use App\Models\SettingsModel;
use App\Models\User;
use App\Models\UserAdress;
use Illuminate\Http\Request;
use Kreait\Firebase\Contract\Database;
use Validator;

class CartController extends Controller
{
    public function __construct(Database $database)
    {
        $this->database = $database;
    }
    private function validateAccesToken($access_token)
    {

        $user = User::where(['user_access_token' => $access_token])->get();

        if ($user->count() == 0) {
            http_response_code(401);
            echo json_encode([
                'status' => "0",
                'message' => 'Invalid login',
                'oData' => [],
                'errors' => (object) [],
            ]);
            exit;

        } else {
            $user = $user->first();
            if ($user->active == 1) {
                return $user->id;
            } else {
                http_response_code(401);
                echo json_encode([
                    'status' => "0",
                    'message' => 'Invalid login',
                    'oData' => [],
                    'errors' => (object) [],
                ]);
                exit;
                return response()->json([
                    'status' => "0",
                    'message' => 'Invalid login',
                    'oData' => [],
                    'errors' => (object) [],
                ], 401);
                exit;
            }
        }
    }
    public function add_to_cart(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'product_id' => 'required|numeric|min:0|not_in:0',
            'product_variant_id' => 'required|numeric|min:0|not_in:0',
            'store_id' => 'required|numeric|min:0|not_in:0',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $product_id = $request->product_id;
            $store_id = $request->store_id;
            $product_variant_id = $request->product_variant_id;
            $influencer_id = 0;
            if (isset($request->influencer_id) && $request->influencer_id && $user_id != $request->influencer_id) {
                $influencer_id = $request->influencer_id;
            }
            list($product_status, $product_data, $message) = ProductModel::getProductVariant($product_id, $product_variant_id);
            $quantity = 1;
            if ($product_status && !empty($product_data)) {

                $cart_key = '';

                $i_data['user_id'] = $user_id;
                $i_data['product_id'] = $product_id;
                $i_data['product_attribute_id'] = (int) $product_variant_id;
                $i_data['quantity'] = $quantity;
                $i_data['store_id'] = $store_id;
                $i_data['created_at'] = gmdate("Y-m-d H:i:s");
                $i_data['influencer_id'] = $influencer_id;
                $i_data['influencer_qty'] = $quantity;

                $in_stock = $product_data->stock_quantity;

                $cart_condition = [];
                $cart_condition = [
                    "product_id" => $i_data['product_id'],
                    "product_attribute_id" => $i_data['product_attribute_id'],
                    "user_id" => $user_id,
                ];

                $product_cart_data = Cart::get_user_cart($cart_condition);
                if (count($product_cart_data)) {
                    $status = "";

                    if (count($product_cart_data) == 1) {
                        $product_cart_data = $product_cart_data[0];
                        if (($quantity <= $in_stock) || ($product_data->allow_back_order == 1)) {

                            $up['quantity'] = $quantity + $product_cart_data->quantity;
                            if ($influencer_id > 0 && $influencer_id == $product_cart_data->influencer_id) {
                                $up['influencer_qty'] = $quantity + $product_cart_data->influencer_qty;
                            }

                            Cart::update_cart($up, ["id" => $product_cart_data->id]);

                            $status = "1";
                            $message = "Product added to your cart";

                        } else {
                            $status = "3";
                            $message = "Unable to increase the product quantity beacuse you reached maximum level of stock";
                        }
                    } else {
                        $status = "3";
                        $message = 'This item has multiple customizations added. Increase the correct item from the cart';
                    }

                } else {
                    if (($quantity <= $in_stock) || ($product_data->allow_back_order == 1)) {
                        Cart::create_cart($i_data);
                        $status = "1";
                        $message = "Product added to your cart";
                    } else {
                        $status = "3";
                        $message = "Unable to add product to cart due to limited stock";
                    }
                }

                $o_data = $this->process_cart($user_id);
                $status = $status ?? "1";

            } else {
                $status = "3";
                $message = 'No product exists';
            }

        }
        return response()->json(['status' => $status, 'errors' => $errors, 'message' => $message, 'oData' => $o_data], 200);
    }
    public function get_cart(Request $request)
    {
        $status = "1";
        $message = "";
        $o_data = [];
        $errors = [];
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $o_data = $this->process_cart($user_id);
        }

        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data]);
    }
    public function checkout(Request $request)
    {
        $status = "1";
        $message = "";
        $o_data = [];
        $errors = [];
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $o_data = $this->process_cart($user_id);
            $o_data['default_address'] = UserAdress::get_user_default_address($user_id);
            $o_data['address_list'] = UserAdress::get_address_list($user_id);
        }

        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data]);
    }
    public function update_cart(Request $request)
    {
        $status = "1";
        $message = "";
        $o_data = [];
        $errors = [];
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'cart_id' => 'required',
            'type' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);

            $cart_condition = [
                "id" => $request->cart_id,
                "user_id" => $user_id,
            ];
            if ($request->type == "add") {
                if (Cart::where($cart_condition)->increment('quantity', 1)) {
                    $message = "Cart updated";
                } else {
                    $message = "Invalid data passed";
                }
            } else {
                if (Cart::where($cart_condition)->decrement('quantity', 1)) {
                    $message = "Cart updated";
                } else {
                    $message = "Invalid data passed";
                }
            }

            $o_data = $this->process_cart($user_id);
        }

        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data]);
    }
    public function process_cart($user_id)
    {
        $where['cart.user_id'] = $user_id;
        $where['product.deleted'] = 0;
        $where['product.product_status'] = 1;
        $where['stores.deleted'] = 0;
        $where['stores.active'] = 1;
        $where['stores.verified'] = 1;

        $cart = Cart::select('cart.*')->where($where)->join('stores', 'stores.id', 'cart.store_id')->join('product', 'product.id', 'cart.product_id')->orderby('cart.created_at','desc')->get();
        $product = [];

        $cart_total = 0;
        foreach ($cart as $key => $val) {
            list($status, $product, $message) = ProductModel::getProductVariant($val->product_id, $val->product_attribute_id);
            if ($status && !empty($product)) {
                $product = process_product_data_api($product);
                $amt = $product['regular_price'];
                if ($product['sale_price']) {
                    $amt = $product['sale_price'];
                }
                $product_total_amount = $amt * $val->quantity;
                $product['total_amount'] = $product_total_amount;
                $cart_total += $product_total_amount;
            }
            $cart[$key]->product_details = $product;
        }
        $settings = SettingsModel::first();
        $tax_percentage = 0;
        // if (isset($settings->tax_percentage)) {
        //     $tax_percentage = $settings->tax_percentage;
        // }
        $tax_amount = 0; //($cart_total * $tax_percentage) / 100;
        $grand_total = $tax_amount + $cart_total;
        $cart_count = count($cart);
        $cart_items = $cart;
        return ['cart_total' => round($cart_total, 2), 'tax_amount' => round($tax_amount, 2), 'discount' => 0, 'grand_total' => round($grand_total, 2), 'cart_count' => $cart_count, 'cart_items' => $cart_items];
    }
    public function apply_coupon(Request $request)
    {
        $status = "1";
        $message = "";
        $o_data = [];
        $errors = [];
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'coupon_code' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $coupon = Coupons::where(['coupon_code' => $request->coupon_code, 'coupon_status' => 1])->where('start_date', '<=', date('Y-m-d'))->where('coupon_end_date', '>=', date('Y-m-d'))->first();
            if ($coupon) {
                $o_data = $this->process_cart($user_id);
                if ($o_data['cart_count'] == 0) {
                    $status = "0";
                    $message = "No items in cart";
                    $errors = $validator->messages();
                    $o_data = [];
                } else if ($o_data['grand_total'] < $coupon->minimum_amount) {
                    $status = "0";
                    $message = "Minimum order amount should be " . $coupon->minimum_amount;
                    $errors = $validator->messages();
                    $o_data = [];
                } else {
                    $applied_to = $coupon->applied_to;
                    $amount_type = $coupon->amount_type;
                    $amount = $coupon->coupon_amount;
                    $categories = CouponCategory::where('coupon_id', $coupon->coupon_id)->get()->toArray();
                    $categories = array_column($categories, 'category_id');
                    $discount = 0;
                    foreach ($o_data['cart_items'] as $key => $val) {
                        $det = $val['product_details'];
                        if ($applied_to == 1) {
                            if (in_array($val->product_details['category_id'], $categories)) {
                                $dis = $amount;
                                if ($amount_type == 1) {
                                    $dis = ($val->product_details['total_amount'] * $amount) / 100;
                                }
                                $det['coupon_discount'] = $dis;
                                $det['grand_total'] = $val->product_details['total_amount'] - $dis;
                                $discount += $dis;
                            } else {
                                $det['coupon_discount'] = 0;
                                $det['grand_total'] = $val->product_details['total_amount'];
                            }
                        } else {
                            $dis = $amount;
                            if ($amount_type == 1) {
                                $dis = ($val->product_details['total_amount'] * $amount) / 100;
                            }
                            $det['coupon_discount'] = 0;
                            $det['grand_total'] = $val->product_details['total_amount'];
                            $discount = $dis;
                        }
                        $o_data['cart_items'][$key]['product_details'] = $det;
                    }
                    $o_data['discount'] = $discount;
                    $o_data['grand_total'] = $o_data['grand_total'] - $discount;
                }
            } else {
                $o_data = null;
                $status = "0";
                $message = "Invalid Coupon";
                $errors = $validator->messages();
            }

        }
        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data]);
    }
    public function delete_cart(Request $request)
    {
        $status = "1";
        $message = "";
        $o_data = [];
        $errors = [];
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'cart_id' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $cart_condition = [
                "id" => $request->cart_id,
                "user_id" => $user_id,
            ];
            if (Cart::where($cart_condition)->delete()) {
                $message = "Cart item removed";
            }

            $o_data = $this->process_cart($user_id);
        }

        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data]);
    }
    public function clear_cart(Request $request)
    {
        $status = "1";
        $message = "";
        $o_data = [];
        $errors = [];
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $cart_condition = [
                "user_id" => $user_id,
            ];
            if (Cart::where($cart_condition)->delete()) {
                $message = "Cart cleared";
            }
        }

        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data]);
    }
    public function payment_init(Request $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'payment_type' => 'required|integer|min:1',
            'address_id' => 'required|integer|min:1',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $cart_details = $this->process_cart($user_id);

            $discount = 0;

            $coupon = [];
            $coupon_id = 0;
            if ($request->coupon_code) {
                $coupon = Coupons::where(['coupon_code' => $request->coupon_code, 'coupon_status' => 1])->where('start_date', '<=', date('Y-m-d'))->where('coupon_end_date', '>=', date('Y-m-d'))->first();
            }
            if ($coupon) {
                if ($cart_details['grand_total'] < $coupon->minimum_amount) {
                } else {
                    $applied_to = $coupon->applied_to;
                    $amount_type = $coupon->amount_type;
                    $amount = $coupon->coupon_amount;
                    $categories = CouponCategory::where('coupon_id', $coupon->coupon_id)->get()->toArray();
                    $categories = array_column($categories, 'category_id');
                    $coupon_id = $coupon->coupon_id;
                    foreach ($cart_details['cart_items'] as $key => $val) {
                        $det = $val['product_details'];
                        if ($applied_to == 1) {
                            if (in_array($val->product_details['category_id'], $categories)) {
                                $dis = $amount;
                                if ($amount_type == 1) {
                                    $dis = ($val->product_details['total_amount'] * $amount) / 100;
                                }
                                $det['coupon_discount'] = $dis;
                                $det['grand_total'] = $val->product_details['total_amount'] - $dis;
                                $discount += $dis;
                            } else {
                                $det['coupon_discount'] = 0;
                                $det['grand_total'] = $val->product_details['total_amount'];
                            }
                        } else {
                            $dis = $amount;
                            if ($amount_type == 1) {
                                $dis = ($val->product_details['total_amount'] * $amount) / 100;
                            }
                            $det['coupon_discount'] = 0;
                            $det['grand_total'] = $val->product_details['total_amount'];
                            $discount = $dis;
                        }
                        $cart_details['cart_items'][$key]['product_details'] = $det;
                    }
                    $cart_details['discount'] = $discount;
                    $cart_details['grand_total'] = $cart_details['grand_total'] - $discount;
                }
            }

            $amount_to_pay = $cart_details['grand_total'];

            if ((int) $amount_to_pay == 0) {
                $message = "Your cart is empty";
            } else {
                $check = \App\Models\TempOrderModel::where(['user_id' => $user_id])->first();
                if ($check) {
                    \App\Models\TempOrderModel::where(['user_id' => $user_id])->delete();
                    \App\Models\TempOrderProductsModel::where(['order_id' => $check->id])->delete();
                }
                $temp_id = $user_id . uniqid() . time();

                $temp_order = new \App\Models\TempOrderModel();
                $temp_order->user_id = $user_id;
                $temp_order->address_id = $request->address_id;
                $temp_order->total = $cart_details['cart_total'];
                $temp_order->vat = $cart_details['tax_amount'];
                $temp_order->discount = $discount;
                $temp_order->grand_total = $cart_details['grand_total'];
                $temp_order->payment_mode = $request->payment_type;
                $temp_order->temp_id = $temp_id;
                if ($coupon && $discount) {
                    $temp_order->coupon_code = $request->coupon_code;
                    $temp_order->coupon_id = $coupon_id;
                }
                $temp_order->save();

                $temp_order_id = $temp_order->id;
                foreach ($cart_details['cart_items'] as $val) {
                    $temp_order_prds = new \App\Models\TempOrderProductsModel();
                    $temp_order_prds->order_id = $temp_order_id;

                    $temp_order_prds->product_id = $val->product_id;
                    $temp_order_prds->product_attribute_id = $val->product_attribute_id;
                    $temp_order_prds->product_type = isset($val['product_details']['product_type']) ? $val['product_details']['product_type'] : 1;
                    $temp_order_prds->quantity = $val->quantity;
                    $temp_order_prds->price = $val['product_details']['sale_price'];
                    $temp_order_prds->discount = isset($val->coupon_discount) ? $val->coupon_discount : 0;
                    $temp_order_prds->total = $val['product_details']['total_amount'];
                    $temp_order_prds->vendor_id = $val['product_details']['product_vendor_id'];
                    $temp_order_prds->admin_commission = 0;
                    $temp_order_prds->vendor_commission = 0;
                    $temp_order_prds->shipping_charge = 0;
                    $temp_order_prds->influencer_id = $val->influencer_id;
                    $temp_order_prds->influencer_qty = $val->influencer_qty;
                    $temp_order_prds->save();
                }
                $wallet_amount_used = 0;
                if ($request->payment_type == 2 || $request->payment_type == 3) {
                    $o_data = $this->payment_init_stripe($payment_token = $temp_id, $invoice_id = $temp_id, $amount_to_pay, $wallet_amount_used, $user_id, $request->address_id, $cart_details['tax_amount']);
                    $status = "1";
                    $message = "";
                } else {
                    $user = User::where(['id' => $user_id])->get()->first();
                    if ($user->wallet_amount < $amount_to_pay) {
                        $status = "0";
                        $message = "Insufficient wallet balance";
                    } else {
                        $wallet_amount_used = $amount_to_pay;
                        $paymentreport = [
                            'transaction_id' => $temp_id,
                            'payment_status' => 'P',
                            'user_id' => $user->id,
                            'ref_id' => $temp_id,
                            'amount' => $amount_to_pay,
                            'created_at' => gmdate('Y-m-d H:i:s'),
                            'wallet_amount_used' => $wallet_amount_used,
                        ];
                        $subTotal = $amount_to_pay;
                        $paymentreport['vat'] = $cart_details['tax_amount'];
                        \App\Models\PaymentReport::insert($paymentreport);

                        $res_status = $this->payment_success($temp_id);
                        if ($res_status === 1) {
                            $status = "1";
                            $message = "Order Placed Successfully";
                        } else {
                            $status = "0";
                            $message = "Soemthing went wrong";
                        }
                    }
                }
            }

        }
        return response()->json(['status' => $status, 'message' => $message, 'errors' => (object) $errors, 'oData' => (object) $o_data]);
    }
    public function payment_init_stripe($payment_token, $invoice_id, $amount_to_pay, $payment_by_wallet, $user_id, $address_id, $tax_amount = 0)
    {
        $user = User::where(['id' => $user_id])->get()->first();
        $response = array();
        $data['client_reference_id'] = $invoice_id;
        $data['product'] = "MODA";
        $data['description'] = "Product Purchase";
        $data['quantity'] = 1;
        $data['image'] = asset('/web_assets/images/logo-talents.png');
        $data['success_url'] = url('/') . '/payment_response/?sessio_id={CHECKOUT_SESSION_ID}&token=' . $payment_token;
        $data['cancel_url'] = url('/') . '/payment_cancel?sessio_id={CHECKOUT_SESSION_ID}&token={$payment_token}';
        $data['amount'] = $amount_to_pay * 100;
        $data['email'] = $user->email ?? 'modauk2022@gmail.com';
        $address = UserAdress::get_address_details($address_id);

        \Stripe\Stripe::setApiKey(env('STRIPE_SECRET'));
        $checkout_session = \Stripe\PaymentIntent::create([
            'amount' => $amount_to_pay * 100,
            'currency' => 'GBP',
            'description' => "product purchase",
            'shipping' => [
                'name' => $user->name ?? $user->first_name . ' ' . $user->last_name,
                'address' => [
                    'line1' => $address->address,
                    'city' => $address->city_name,
                    'state' => $address->state_name,
                    'country' => $address->country_name,
                ],
            ],
        ]);

        $data['session_id'] = $checkout_session->id;
        $ref = $checkout_session->id;
        $paymentreport = [
            'transaction_id' => $invoice_id,
            'payment_status' => 'P',
            'user_id' => $user->id,
            'ref_id' => $ref,
            'amount' => $amount_to_pay,
            'created_at' => gmdate('Y-m-d H:i:s'),
            'wallet_amount_used' => $payment_by_wallet,
        ];
        $subTotal = $amount_to_pay;
        $paymentreport['vat'] = $tax_amount;
        \App\Models\PaymentReport::insert($paymentreport);

        $payment_ref = $checkout_session->client_secret;

        return compact('invoice_id', 'payment_ref');
    }
    public function payment_response()
    {

    }
    public function payment_cancel()
    {

    }
    public function place_order(Request $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'payment_type' => 'invoice_id',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $res_status = $this->payment_success($request->invoice_id);
            if ($res_status === 1) {
                $status = "1";
                $message = "Order Placed Successfully";
            } else {
                $status = "0";
                $message = "Soemthing went wrong";
            }
        }
        return response()->json(['status' => $status, 'message' => $message, 'errors' => (object) $errors, 'oData' => (object) $o_data]);
    }
    private function payment_success($invoice_id)
    {
        try {

            $data = \App\Models\TempOrderModel::where(['temp_id' => $invoice_id])->first();
            if ($data) {

                $order = new OrderModel();
                $order->invoice_id = $invoice_id;
                $order->user_id = $data->user_id;
                $order->address_id = $data->address_id;
                $order->total = $data->total;
                $order->vat = $data->vat;
                $order->discount = $data->discount;
                $order->grand_total = $data->grand_total;
                $order->payment_mode = $data->payment_mode;
                $order->status = 1;
                $order->booking_date = gmdate('Y-m-d H:i:s');

                $order->admin_commission = $data->admin_commission;
                $order->vendor_commission = $data->vendor_commission;
                $order->shipping_charge = $data->shipping_charge;
                $order->created_at = gmdate('Y-m-d H:i:s');
                $order->user_id = $data->user_id;
                $order->coupon_code = $data->coupon_code;
                $order->coupon_id = $data->coupon_id;

                $order->save();
                // dd('q');
                $order_id = $order->order_id;

                if ($data->coupon_code) {
                    $chist = new CouponHistory();
                    $chist->order_id = $order_id;
                    $chist->coupon_id = $data->coupon_id;
                    $chist->user_id = $data->user_id;
                    $chist->coupon_code = $data->coupon_code;
                    $chist->discount = $data->discount;
                    $chist->save();
                }

                // dd($order_id);
                $order_prds_data = \App\Models\TempOrderProductsModel::where('order_id', $data->id)->get();
                $total_qty = 0;
                $total_items_qty = 0;
                $influnecers = [];
                foreach ($order_prds_data as $key=>$val) {
                    $total_qty += 1;
                    $total_items_qty += $val->quantity;
                    $order_prds = new OrderProductsModel();
                    $order_prds->order_id = $order_id;
                    $order_prds->product_id = $val->product_id;
                    $order_prds->product_attribute_id = $val->product_attribute_id;
                    $order_prds->product_type = $val->product_type;
                    $order_prds->quantity = $val->quantity;
                    $order_prds->price = $val->price;
                    $order_prds->discount = $val->discount;
                    $order_prds->total = $val->total;
                    $order_prds->vendor_id = $val->vendor_id;
                    $order_prds->order_status = 1;
                    $order_prds->admin_commission = $val->admin_commission;
                    $order_prds->vendor_commission = $val->vendor_commission;
                    $order_prds->shipping_charge = $val->shipping_charge;
                    $order_prds->influencer_id = $val->influencer_id;
                    $order_prds->influencer_qty = $val->influencer_qty;
                    if($val->influencer_id){
                        $influnecers[$key]['inf_id']=$val->influencer_id;
                        $influnecers[$key]['product_id']=$val->product_id;
                        $influnecers[$key]['product_attribute_id']=$val->product_attribute_id;
                    }
                    $order_prds->save();
                }
                $order->total_qty = $total_qty;
                $order->total_items_qty = $total_items_qty;
                $order->save();

                \App\Models\TempOrderModel::where(['temp_id' => $invoice_id])->delete();
                \App\Models\TempOrderProductsModel::where(['id' => $data->id])->delete();

                $payObj = \App\Models\PaymentReport::where('transaction_id', $invoice_id)->get()->first();
                $payObj->payment_status = 'A';
                $payObj->save();
                $users = User::find($payObj->user_id);
                $wallet_amount_used = $payObj->wallet_amount_used;
                if ($wallet_amount_used > 0) {
                    $users = User::find($payObj->user_id);
                    if ($users) {
                        $w_data = [
                            'user_id' => $users->id,
                            'wallet_amount' => $wallet_amount_used,
                            'pay_type' => 'debited',
                            'description' => 'Used for cart checkout',
                        ];
                        if (wallet_history($w_data)) {
                            $users->wallet_amount = $users->wallet_amount - $wallet_amount_used;
                            $users->save();
                        }
                    }
                }
                Cart::where(['user_id' => $users->id])->delete();
                Cart::where(['user_id' => $users->id])->delete();

                $title = 'Order Placed Successfully';
                $description = 'Your order has been placed successfully';
                $notification_id = time();
                $ntype = 'order_placed';
                if (!empty($users->firebase_user_key)) {
                    $notification_data["Nottifications/" . $users->firebase_user_key . "/" . $notification_id] = [
                        "title" => $title,
                        "description" => $description,
                        "notificationType" => $ntype,
                        'createdDate'     => $order->created_at,
                        "orderId" => (string) $order_id,
                        "url" => "",
                        "imageURL" => '',
                        "read" => "0",
                        "seen" => "0",
                    ];
                    $this->database->getReference()->update($notification_data);
                }

                if (!empty($users->user_device_token)) {
                    send_single_notification($users->user_device_token, [
                        "title" => $title,
                        "body" => $description,
                        "icon" => 'myicon',
                        "sound" => 'default',
                        "click_action" => "EcomNotification"],
                        ["type" => $ntype,
                            "notificationID" => $notification_id,
                            "orderId" => (string) $order_id,
                            "imageURL" => "",
                        ]);
                }

                if($influnecers){
                    foreach($influnecers as $inf){
                        $inf_user = User::find($inf['inf_id']);
                        $i_title = 'User bought your Moda';
                        
                        $i_description = 'Congratulations 🎉 '.$users->user_name.' bought your Moda';
                        $i_notification_id = time();
                        $i_ntype = 'moda_product_bought';
                        if (!empty($inf_user->firebase_user_key)) {
                            $notification_data["Nottifications/" . $inf_user->firebase_user_key . "/" . $i_notification_id] = [
                                "title" => $i_title,
                                "description" => $i_description,
                                "notificationType" => $i_ntype,
                                'createdDate'     => $order->created_at,
                                "orderId" => (string) $order_id,
                                "productId" => (string) $inf['product_id'],
                                "productAttributeId" => (string) $inf['product_attribute_id'],
                                "url" => "",
                                "imageURL" => '',
                                "read" => "0",
                                "seen" => "0",
                                "buyer_id" => (string) $users->id,
                                "buyer_firebase_key" => $users->firebase_user_key,
                                
                            ];
                            $this->database->getReference()->update($notification_data);
                        }

                        if (!empty($inf_user->user_device_token)) {
                            send_single_notification($inf_user->user_device_token, [
                                "title" => $i_title,
                                "body" => $i_description,
                                "icon" => 'myicon',
                                "sound" => 'default',
                                "click_action" => "EcomNotification"],
                                ["type" => $i_ntype,
                                    "notificationID" => $i_notification_id,
                                    "orderId" => (string) $order_id,
                                    "productId" => (string) $inf['product_id'],
                                    "buyer_id" => (string) $users->id,
                                    "productAttributeId" => (string) $inf['product_attribute_id'],
                                    "imageURL" => "",
                                ]);
                        }
                    }
                }

                $name = $users->name ?? $users->first_name . ' ' . $users->last_name;
                exec("php " . base_path() . "/artisan send:send_order_email --uri=" . urlencode($users->email) . " --uri2=" . $order_id . " --uri3=" . urlencode($name) . " --uri4=" . $users->id . " > /dev/null 2>&1 & ");

            }
            return 1;
        } catch (\Exception $e) {
            // printr($e->getMessage());
            return 0;
        }
    }
}
