<?php

namespace App\Http\Controllers\Api\v1_old;

use App\Http\Controllers\Controller;
use App\Models\FavouriteModa;
use App\Models\FavouriteModaItems;
use App\Models\HairColors;
use App\Models\ModaMainCategories;
use App\Models\MyModa;
use App\Models\MyModaItems;
use App\Models\ProductModel;
use App\Models\SkinColors;
use App\Models\User;
use App\Models\Stores;
use App\Models\StoreLikes;
use Illuminate\Http\Request;
use Validator;

class ModaController extends Controller
{
    private function validateAccesToken($access_token)
    {

        $user = User::where(['user_access_token' => $access_token])->get();

        if ($user->count() == 0) {
            http_response_code(401);
            echo json_encode([
                'status' => "0",
                'message' => 'Invalid login',
                'oData' => [],
                'errors' => (object) [],
            ]);
            exit;

        } else {
            $user = $user->first();
            if ($user->active == 1) {
                return $user->id;
            } else {
                http_response_code(401);
                echo json_encode([
                    'status' => "0",
                    'message' => 'Invalid login',
                    'oData' => [],
                    'errors' => (object) [],
                ]);
                exit;
                return response()->json([
                    'status' => "0",
                    'message' => 'Invalid login',
                    'oData' => [],
                    'errors' => (object) [],
                ], 401);
                exit;
            }
        }
    }

    public function moda_categories(Request $request)
    {
        $status = "1";
        $message = "";
        $o_data = [];
        $errors = [];
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
        ]);

        if ($validator->fails()) {
            $message = "Validation error occured";
            $errors = $validator->messages();
            return response()->json([
                'status' => "0",
                'message' => $message,
                'errors' => (object) $errors,
            ], 200);
        }
        $user_id = $this->validateAccesToken($request->access_token);
        $user = User::where('id', $user_id)->first();
        $gender = $user->gender;

        $opt_user_id = $request->user_id;
        if ($opt_user_id) {
            $opt_user = User::where('id', $opt_user_id)->first();
            if (isset($opt_user->gender)) {
                $gender = $opt_user->gender;
            }
        }
        if ($gender == 3) {
            $gender = 1;
        }
        $categories = ModaMainCategories::select('id', 'name')->with(
            [
                'sub_categories' => function ($qr) use ($gender) {
                    $qr->select('id', 'name', 'main_category', 'image')->where(['deleted' => 0, 'active' => 1, 'gender' => $gender])->orderby('sort_order', 'asc');
                },
            ])->get();
        return response()->json([
            'status' => "1",
            'message' => 'Data fetched successfully',
            'errors' => [],
            'oData' => $categories,
        ], 200);
    }
    public function hair_colors()
    {
        $hair_colors = HairColors::select('id', 'name', 'color')->where(['active' => 1, 'deleted' => 0])->get();
        return response()->json([
            'status' => "1",
            'message' => 'Data fetched successfully',
            'errors' => [],
            'oData' => $hair_colors,
        ], 200);
    }
    public function skin_colors()
    {
        $skin_colors = SkinColors::select('id', 'name', 'color')->where(['active' => 1, 'deleted' => 0])->get();
        return response()->json([
            'status' => "1",
            'message' => 'Data fetched successfully',
            'errors' => [],
            'oData' => $skin_colors,
        ], 200);
    }
    public function colors()
    {
        $oData['hair_colors'] = HairColors::select('id', 'name', 'color')->where(['active' => 1, 'deleted' => 0])->get();
        $oData['skin_colors'] = SkinColors::select('id', 'name', 'color')->where(['active' => 1, 'deleted' => 0])->get();
        return response()->json([
            'status' => "1",
            'message' => 'Data fetched successfully',
            'errors' => [],
            'oData' => $oData,
        ], 200);
    }

    public function add_product_to_moda(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'product_id' => 'required|numeric|min:0|not_in:0',
            'product_variant_id' => 'required|numeric|min:0|not_in:0',
            'moda_sub_category' => 'required|numeric|min:0|not_in:0',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $product_id = $request->product_id;
            $store_id = $request->store_id;
            $product_variant_id = $request->product_variant_id;
            list($product_status, $product_data, $msg) = ProductModel::getProductVariant($product_id, $product_variant_id);
            if ($product_status && !empty($product_data)) {
                $product_attribute_id = $product_variant_id;
                $date = gmdate('Y-m-d');
                $moda = MyModa::where(['user_id' => $user_id, 'date' => $date])->first();
                if ($moda) {
                    $moda_id = $moda->id;
                    $sflag = false;
                    if (isset($request->hair_color) && $request->hair_color) {
                        $moda->hair_color = $request->hair_color;
                        $sflag = true;
                    }
                    if (isset($request->hair_color) && $request->hair_color) {
                        $moda->skin_color = $request->skin_color;
                        $sflag = true;
                    }
                    if ($sflag) {
                        $moda->save();
                    }

                } else {
                    $moda = new MyModa();
                    $moda->date = $date;
                    $moda->user_id = $user_id;
                    if (isset($request->hair_color) && $request->hair_color) {
                        $moda->hair_color = $request->hair_color;
                    }
                    if (isset($request->hair_color) && $request->hair_color) {
                        $moda->skin_color = $request->skin_color;
                    }
                    $moda->save();
                    $moda_id = $moda->id;
                }
                // $is_exist = MyModaItems::where(['my_moda_id' => $moda_id, 'moda_sub_category' => $request->moda_sub_category])->first();
                // if ($is_exist) {
                //     MyModaItems::where(['my_moda_id' => $moda_id, 'moda_sub_category' => $request->moda_sub_category])->delete();
                //     // $status = "0";
                //     // $message = "You can't add multiple product under same category";
                // }

                MyModaItems::where(['my_moda_id' => $moda_id, 'moda_sub_category' => $request->moda_sub_category])->delete();

                // else {
                $i_data['my_moda_id'] = $moda_id;
                $i_data['product_id'] = $product_id;
                $i_data['product_attribute_id'] = $product_attribute_id;
                $i_data['moda_sub_category'] = $request->moda_sub_category;
                $i_data['user_id'] = $user_id;
                $i_data['created_at'] = gmdate("Y-m-d H:i:s");
                if (MyModaItems::create($i_data)) {
                    $status = "1";
                    $message = "Product added to your moda";
                } else {
                    $status = "0";
                    $message = "Something went wrong";
                }
                // }

            } else {
                $status = "0";
                $message = 'No product exists';
            }

        }
        return response()->json(['status' => $status, 'errors' => $errors, 'message' => $message, 'oData' => $o_data], 200);
    }

    public function my_moda(Request $request)
    {
        $status = "1";
        $message = "";
        $o_data = [];
        $errors = [];
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
        ]);

        if ($validator->fails()) {
            $message = "Validation error occured";
            $errors = $validator->messages();
            return response()->json([
                'status' => "0",
                'message' => $message,
                'errors' => (object) $errors,
            ], 200);
        }
        $user_id = $this->validateAccesToken($request->access_token);
        $influencer_id = $request->influencer_id;
        $user_det = [];
        $user = User::where('id', $user_id)->first();
        $gender = $user->gender;
        $date = gmdate('Y-m-d');
        if ($influencer_id) {
            $moda = MyModa::select('id', 'date', 'hair_color', 'skin_color')->where(['user_id' => $influencer_id, 'date' => $date])->first();
            if ($influencer = User::where('id', $influencer_id)->first()) {
                $gender = $influencer->gender;
                $user_det = [
                    'id' => $influencer->id,
                    'name' => $influencer->name ?? $influencer->first_name . ' ' . $influencer->last_name,
                    'email' => $influencer->email,
                    'user_name' => $influencer->user_name,
                ];
            }
        } else {
            $moda = MyModa::select('id', 'date', 'hair_color', 'skin_color')->where(['user_id' => $user_id, 'date' => $date])->first();
            $user_det = [
                'id' => $user->id,
                'name' => $user->name ?? $user->first_name . ' ' . $user->last_name,
                'email' => $user->email,
                'user_name' => $user->user_name,
            ];
        }

        if ($moda) {
            if ($gender == 3) {
                $gender = 1;
            }
            $moda->is_fav = 0;
            $is_fav = FavouriteModa::where(['moda_id' => $moda->id, 'user_id' => $user_id])->count();
            if ($is_fav) {
                $moda->is_fav = 1;
            }
            $categories = ModaMainCategories::select('id', 'name')->with(
                [
                    'sub_categories' => function ($qr) use ($gender) {
                        $qr->select('id', 'name', 'main_category', 'image')->where(['deleted' => 0, 'active' => 1, 'gender' => $gender])->orderby('sort_order', 'asc');
                    },
                ])->get();
            // ->withCount(['sub_categories.items'])
            foreach ($categories as $key => $val) {
                $sub = $val->sub_categories;
                $categories[$key]->item_count = 0;
                $category_count = 0;
                foreach ($sub as $skey => $sval) {
                    $item_count = MyModaItems::where(['my_moda_id' => $moda->id, 'moda_sub_category' => $sval->id])->count();
                    $sub[$skey]->item_count = $item_count;
                    $category_count += $item_count;
                    $categories[$key]->sub_categories = $sub;
                }
                $categories[$key]->item_count = $category_count;
            }
            $moda->categories = $categories;
            $o_data['moda'] = $moda;
            // $o_data['categories'] = $categories;
        } else {
            $status = "0";
            $message = "No moda found";
            $o_data = null;
        }
        return response()->json([
            'status' => $status,
            'message' => $message ?? 'Data fetched successfully',
            'errors' => [],
            'oData' => $o_data,
            'user_det' => (object) $user_det,
        ], 200);
    }

    public function previous_moda_list(Request $request)
    {
        $status = "1";
        $message = "";
        $o_data = [];
        $errors = [];
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
        ]);

        if ($validator->fails()) {
            $message = "Validation error occured";
            $errors = $validator->messages();
            return response()->json([
                'status' => "0",
                'message' => $message,
                'errors' => (object) $errors,
            ], 200);
        }
        $user_id = $this->validateAccesToken($request->access_token);
        $influencer_id = $request->influencer_id;
        $user_det = [];
        $req_date = $request->date;
        $user = User::where('id', $user_id)->first();
        $gender = $user->gender;
        $date = gmdate('Y-m-d');
        if ($req_date) {
            $req_date = date('Y-m-d', strtotime($request->date));
            if ($influencer_id) {
                $moda = MyModa::select('id', 'date', 'hair_color', 'skin_color')->where('user_id', $influencer_id)->where('date', $req_date)->orderby('date', 'desc')->get();
            } else {
                $moda = MyModa::select('id', 'date', 'hair_color', 'skin_color')->where('user_id', $user_id)->where('date', $req_date)->orderby('date', 'desc')->get();
            }

        } else {
            if ($influencer_id) {
                $moda = MyModa::select('id', 'date', 'hair_color', 'skin_color')->where('user_id', $influencer_id)->where('date', '<', $date)->orderby('date', 'desc')->limit(7)->get();
            } else {
                $moda = MyModa::select('id', 'date', 'hair_color', 'skin_color')->where('user_id', $user_id)->where('date', '<', $date)->orderby('date', 'desc')->limit(7)->get();
            }
        }
        if ($influencer_id) {
            if ($influencer = User::where('id', $influencer_id)->first()) {
                $gender = $influencer->gender;
                $user_det = [
                    'id' => $influencer->id,
                    'name' => $influencer->name ?? $influencer->first_name . ' ' . $influencer->last_name,
                    'email' => $influencer->email,
                    'user_name' => $influencer->user_name,
                ];
            }
        } else {
            $user_det = [
                'id' => $user->id,
                'name' => $user->name ?? $user->first_name . ' ' . $user->last_name,
                'email' => $user->email,
                'user_name' => $user->user_name,
            ];
        }
        if ($gender == 3) {
            $gender = 1;
        }
        foreach ($moda as $mkey => $mval) {
            $moda[$mkey]->is_fav = 0;
            $is_fav = FavouriteModa::where(['moda_id' => $mval->id, 'user_id' => $user_id])->count();
            if ($is_fav) {
                $moda[$mkey]->is_fav = 1;
            }
            $categories = ModaMainCategories::select('id', 'name')->with(
                [
                    'sub_categories' => function ($qr) use ($gender) {
                        $qr->select('id', 'name', 'main_category', 'image')->where(['deleted' => 0, 'active' => 1, 'gender' => $gender])->orderby('sort_order', 'asc');
                    },
                ])->get();
            foreach ($categories as $key => $val) {
                $sub = $val->sub_categories;
                $categories[$key]->item_count = 0;
                $category_count = 0;
                foreach ($sub as $skey => $sval) {
                    $item_count = MyModaItems::where(['my_moda_id' => $mval->id, 'moda_sub_category' => $sval->id])->count();
                    $sub[$skey]->item_count = $item_count;
                    $category_count += $item_count;
                    $categories[$key]->sub_categories = $sub;
                }
                $categories[$key]->item_count = $category_count;
            }
            // print_r($categories);
            $moda[$mkey]->categories = $categories;
        }

        $o_data['moda'] = $moda;

        return response()->json([
            'status' => $status,
            'message' => $message ?? 'Data fetched successfully',
            'errors' => [],
            'oData' => $o_data,
            'user_det' => (object) $user_det,
        ], 200);
    }

    public function moda_fav(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'moda_id' => 'required|numeric',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $moda_id = $request->moda_id;
            // FavouriteModaItems::where(['user_id' => $user_id])->orderby('created_at','asc')->limit(1)->delete();
            $check_exist = FavouriteModa::where(['moda_id' => $moda_id, 'user_id' => $user_id])->first();
            if ($check_exist) {
                FavouriteModa::where(['moda_id' => $moda_id, 'user_id' => $user_id])->delete();
                FavouriteModaItems::where(['fav_id' => $check_exist->id, 'user_id' => $user_id])->delete();
                $status = "1";
                $message = "Removed from fav list";
            } else {
                $fav_limit = 5;
                $fav_count = FavouriteModa::where(['user_id' => $user_id])->count();
                if ($fav_count == 5) {
                    $first_fav = $check_exist = FavouriteModa::where(['user_id' => $user_id])->orderby('created_at', 'asc')->first();
                    if ($first_fav) {
                        FavouriteModa::where(['id' => $first_fav->id, 'user_id' => $user_id])->delete();
                        FavouriteModaItems::where(['fav_id' => $first_fav->id, 'user_id' => $user_id])->delete();
                    }
                }
                $like = new FavouriteModa();
                $like->moda_id = $moda_id;
                $like->user_id = $user_id;
                $like->created_at = gmdate('Y-m-d H:i:s');
                $like->save();
                if ($like->id > 0) {

                    $moda_items = MyModaItems::select('my_moda_items.*', 'moda_sub_categories.main_category')->join('moda_sub_categories', 'moda_sub_categories.id', 'my_moda_items.moda_sub_category')->where(['my_moda_id' => $moda_id, 'user_id' => $user_id])->get();
                    foreach ($moda_items as $val) {
                        $item_count = FavouriteModaItems::where(['fav_id' => $moda_id, 'user_id' => $user_id, 'moda_category' => $val->main_category])->count();
                        if ($item_count == 5) {
                            FavouriteModaItems::where(['user_id' => $user_id])->orderby('created_at', 'asc')->limit(1)->delete();
                        }
                        FavouriteModaItems::where(['user_id' => $user_id, 'product_id' => $val->product_id, 'product_attribute_id' => $val->product_attribute_id, 'moda_sub_category' => $val->moda_sub_category, 'moda_category' => $val->main_category])->delete();

                        $i_data['fav_id'] = $like->id;
                        $i_data['product_id'] = $val->product_id;
                        $i_data['product_attribute_id'] = $val->product_attribute_id;
                        $i_data['moda_sub_category'] = $val->moda_sub_category;
                        $i_data['moda_category'] = $val->main_category;
                        $i_data['user_id'] = $user_id;
                        $i_data['created_at'] = gmdate("Y-m-d H:i:s");
                        FavouriteModaItems::insert($i_data);
                    }
                    $status = "1";
                    $message = "Added to fav list";
                } else {
                    $message = "Something went wrong";
                }
            }
        }
        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' => $o_data], 200);
    }
    public function favourite_moda(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $influencer_id = $request->influencer_id;
            $user_det = [];
            $flag = false;
            // if (FavouriteModa::where(['user_id' => $user_id])->count()) {
            $user = User::where('id', $user_id)->first();
            $gender = $user->gender;
            $moda_uid = $user_id;
            if ($influencer_id) {
                $moda_uid = $influencer_id;
                if ($influencer = User::where('id', $influencer_id)->first()) {
                    $gender = $influencer->gender;
                    $user_det = [
                        'id' => $influencer->id,
                        'name' => $influencer->name ?? $influencer->first_name . ' ' . $influencer->last_name,
                        'email' => $influencer->email,
                        'user_name' => $influencer->user_name,
                    ];
                }
            } else {
                $user_det = [
                    'id' => $user->id,
                    'name' => $user->name ?? $user->first_name . ' ' . $user->last_name,
                    'email' => $user->email,
                    'user_name' => $user->user_name,
                ];
            }
            if ($gender == 3) {
                $gender = 1;
            }
            $categories = ModaMainCategories::select('id', 'name')->with(
                [
                    'sub_categories' => function ($qr) use ($gender) {
                        $qr->select('id', 'name', 'main_category', 'image')->where(['deleted' => 0, 'active' => 1, 'gender' => $gender])->orderby('sort_order', 'asc');
                    },
                ])->get();
            // ->withCount(['sub_categories.items'])

            foreach ($categories as $key => $val) {
                $sub = $val->sub_categories;
                $categories[$key]->item_count = 0;
                $category_count = 0;
                foreach ($sub as $skey => $sval) {
                    $item_count = FavouriteModaItems::where(['moda_sub_category' => $sval->id, 'user_id' => $moda_uid])->count();
                    $sub[$skey]->item_count = $item_count;
                    $category_count += $item_count;
                    $categories[$key]->sub_categories = $sub;
                }
                if ($category_count) {
                    $flag = true;
                }
                $categories[$key]->item_count = $category_count;
            }
            $o_data = $categories;
            $status = "1";
            if ($flag) {
                $o_data = $categories;
                $status = "1";
            } else {
                $o_data = null;
                $status = "0";
            }
            // } else {
            //     $o_data = null;
            //     $status = "0";
            // }

        }
        return response()->json([
            'status' => $status,
            'message' => $message ?? 'Data fetched successfully',
            'errors' => [],
            'oData' => $o_data,
            'user_det' => (object) $user_det,
        ], 200);
    }

    public function favourite_moda_products(REQUEST $request)
    {
        $status = "1";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'moda_sub_category' => 'required|numeric|min:0|not_in:0',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $influencer_id = $request->influencer_id;
            $moda_uid = $influencer_id ?? $user_id;

            $items = FavouriteModaItems::select('product_id', 'moda_sub_category', 'product_attribute_id')->where(['moda_sub_category' => $request->moda_sub_category, 'user_id' => $moda_uid])->get();
            foreach ($items as $key => $val) {
                list($st, $product, $message) = ProductModel::getProductVariant($val->product_id, $val->product_attribute_id);
                $items[$key]->details = [];
                if ($st && !empty($product)) {
                    $items[$key]->details = process_product_data_api($product);
                }
                if (!$items[$key]->details) {
                    $items[$key]->details = null;
                }
            }
            $o_data = $items;
        }
        return response()->json([
            'status' => $status,
            'message' => $message ?? 'Data fetched successfully',
            'errors' => [],
            'oData' => count($o_data) ? $o_data : null,
        ], 200);
    }

    public function remove_fav_moda(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $moda_id = $request->moda_id;
            FavouriteModaItems::where(['user_id' => $user_id])->delete();
            FavouriteModa::where(['user_id' => $user_id])->delete();
            $status = "1";
            $message = "Removed from fav list";
        }
        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' => $o_data], 200);
    }

    public function view_moda_products(REQUEST $request)
    {
        $status = "1";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'moda_id' => 'required|numeric',
            'moda_sub_category' => 'required|numeric|min:0|not_in:0',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $influencer_id = $request->influencer_id;
            $moda_uid = $influencer_id ?? $user_id;

            $items = MyModaItems::select('product_id', 'moda_sub_category', 'product_attribute_id')->where(['moda_sub_category' => $request->moda_sub_category, 'user_id' => $moda_uid, 'my_moda_id' => $request->moda_id])->get();
            foreach ($items as $key => $val) {
                list($st, $product, $message) = ProductModel::getProductVariant($val->product_id, $val->product_attribute_id);
                $items[$key]->details = [];
                if ($st && !empty($product)) {
                    $items[$key]->details = process_product_data_api($product);
                }
            }
            $o_data = $items;
        }
        return response()->json([
            'status' => $status,
            'message' => $message ?? 'Data fetched successfully',
            'errors' => $errors,
            'oData' => $o_data,
        ], 200);
    }

    public function moda_product_fav(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'moda_sub_category' => 'required|numeric|min:0|not_in:0',
            "product_ids" => "required|array|max:5",
            "product_ids.*" => "required|distinct|max:5",
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $moda_id = 0;
            $product_ids = $request->product_ids;

            $new_ids = [];
            foreach ($product_ids as $val) {
                if (FavouriteModaItems::where(['user_id' => $user_id, 'product_id' => $val])->first()) {
                    FavouriteModaItems::where(['user_id' => $user_id, 'product_id' => $val])->delete();
                } else {
                    array_push($new_ids, $val);
                }
            }

            foreach ($new_ids as $pid) {
                $product_attribute_id = 0;
                $moda_category = 0;
                list($st, $variant, $msg) = ProductModel::getProductVariant($pid, 0);
                if ($variant) {
                    if (isset($variant['product_attribute_id'])) {
                        $product_attribute_id = (string) $variant['product_attribute_id'];
                    }
                    $moda_category = $variant['moda_main_category'];
                }
                $i_data['fav_id'] = 0;
                $i_data['product_id'] = $pid;
                $i_data['product_attribute_id'] = $product_attribute_id;
                $i_data['moda_sub_category'] = $request->moda_sub_category;
                $i_data['moda_category'] = $moda_category;
                $i_data['user_id'] = $user_id;
                $i_data['created_at'] = gmdate("Y-m-d H:i:s");
                FavouriteModaItems::insert($i_data);

            }
            $status = "1";
            $message = "Successfully saved";
        }
        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' => $o_data], 200);
    }
    public function save_moda_color(REQUEST $request)
    {
        $status = "1";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'moda_id' => 'required|numeric',
            'hair_color' => 'required',
            'skin_color' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $moda = MyModa::where(['user_id' => $user_id, 'id' => $request->moda_id])->first();
            if ($moda) {
                $moda->hair_color = $request->hair_color;
                $moda->skin_color = $request->skin_color;
                $moda->save();
                $message = "Successfully updated";
            } else {
                $status = "0";
                $message = "No moda found";
            }
        }
        return response()->json([
            'status' => $status,
            'message' => $message,
            'errors' => $errors,
            'oData' => $o_data,
        ], 200);
    }

    public function get_store_by_category(REQUEST $request)
    {
        $status = "1";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'moda_sub_category' => 'required|numeric|min:0|not_in:0',
            'latitude' => 'required',
            'longitude' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $limit = isset($request->limit) ? $request->limit : 10;
            $offset = isset($request->page) ? ($request->page - 1) * $request->limit : 0;   
            $where['stores.deleted'] = 0;
            $where['stores.active'] = 1;
            $where['stores.verified'] = 1;
            $filter['search_text'] = $request->search_text;
            $filter['lat'] = $request->latitude;
            $filter['long'] = $request->longitude;
            $filter['distance'] = $request->distance;
            // $datastore = Stores::get();
            
            $stores = Stores::get_store_by_moda_category($request->moda_sub_category,$where, $filter, $limit, $offset)->get();
            $cords = [];
            foreach ($stores as $key => $val) {
                $stores[$key]->logo = asset($val->logo);
                $stores[$key]->cover_image = asset($val->cover_image);
                $stores[$key]->is_liked = 0;
                $cords[$key] = $val->latitude.','.$val->longitude;
                // $dmr = GetDrivingDistance($request->latitude,$val->latitude,$request->longitude,$val->longitude);
                // $stores[$key]->drive_distance = $dmr['distance'];
                // $stores[$key]->drive_time = $dmr['time'];
                $is_liked = StoreLikes::where(['store_id' => $val->id, 'user_id' => $user_id])->count();
                if ($is_liked) {
                    $stores[$key]->is_liked = 1;
                }
            }
            $destinations = implode("|", $cords);
            $from_latlong = $request->latitude.','.$request->longitude;
            $distance_data = GetDrivingDistanceToMultipleLocations($from_latlong,$destinations);
            foreach ($stores as $key => $val) {
                $dist = '-';
                $time = '-';
                if(isset($distance_data['rows'][0]['elements'][$key]['distance']['text'])){
                    $dist = $distance_data['rows'][0]['elements'][$key]['distance']['text'];
                    $time = $distance_data['rows'][0]['elements'][$key]['duration']['text'];
                }
                $stores[$key]->drive_distance = $dist;
                $stores[$key]->drive_time = $time;
            }
            $o_data['list'] = $stores;
            
        }
        return response()->json(['status' => $status, 'message' => $message, 'errors' => (object) $errors, 'oData' => $o_data], 200);
    }

    public function get_moda_store_categories(REQUEST $request)
    {
        $status = "1";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'moda_sub_category' => 'required|numeric|min:0|not_in:0',
            'store_id' => 'required|numeric|min:0|not_in:0',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $limit = isset($request->limit) ? $request->limit : 10;
            $offset = isset($request->page) ? ($request->page - 1) * $request->limit : 0;   
            $where['category.deleted'] = 0;
            $where['category.active'] = 1;
            $filter['search_text'] = $request->search_text;
            $caegories = MyModa::get_moda_store_categories($request->store_id,$request->moda_sub_category,$where, $filter, $limit, $offset)->get();
            foreach ($caegories as $key => $val) {
                if($val->image){
                   $caegories[$key]->image = asset($val->image); 
                }
                if($val->banner_image){
                    $caegories[$key]->banner_image = asset($val->banner_image);
                }
            }
            $o_data['list'] = $caegories;
            
        }
        return response()->json(['status' => $status, 'message' => $message, 'errors' => (object) $errors, 'oData' => $o_data], 200);
    }
    
}
