<?php

namespace App\Http\Controllers\Api\v1_old;

use App\Http\Controllers\Controller;
use App\Models\User;
use App\Models\UserAdress;
use App\Models\UserFollow;
use App\Models\BlockUser;
use App\Models\WalletPaymentReport;
use App\Models\ProfileBio;
use App\Models\UserReport;
use App\Models\UserLocations;
use App\Models\PublicBusinessInfos;
use App\Models\UserFavorite;
use App\Models\UserProfileViewInsight;
use App\Models\PostLikes;
use App\Models\PostComment;
use App\Models\Post;
use DB;
use Hash;
use Illuminate\Http\Request;
use Kreait\Firebase\Contract\Database;
use PDO;
use Validator;

class UsersController extends Controller
{
    //
    public function __construct(Database $database)
    {
        $this->database = $database;
    }
    public function get_loged_users(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];
        $access_tokens = $request->access_token_list;
        $user_list = User::whereIn('user_access_token', $access_tokens)->get();
        if ($user_list->count() > 0) {
            $status = "1";
            $message = "success";
            $o_data = convert_all_elements_to_string($user_list->toArray());
        } else {
            $message = "not a valid token list";
        }
        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' => $o_data], 200);
    }
    private function validateAccesToken($access_token)
    {

        $user = User::where(['user_access_token' => $access_token])->get();

        if ($user->count() == 0) {
            http_response_code(401);
            echo json_encode([
                'status' => "0",
                'message' => 'Invalid login',
                'oData' => [],
                'errors' => (object) [],
            ]);
            exit;

        } else {
            $user = $user->first();
            if ($user->active == 1) {
                return $user->id;
            } else {
                http_response_code(401);
                echo json_encode([
                    'status' => "0",
                    'message' => 'Invalid login',
                    'oData' => [],
                    'errors' => (object) [],
                ]);
                exit;
                return response()->json([
                    'status' => "0",
                    'message' => 'Invalid login',
                    'oData' => [],
                    'errors' => (object) [],
                ], 401);
                exit;
            }
        }
    }
    public function accept_follow_request(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'follow_request_id' => 'required|numeric',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $follow_request_id = $request->follow_request_id;
            $check_exist = UserFollow::where(['id' => $follow_request_id,'follow_user_id'=>$user_id])->get();
            if ($check_exist->count() > 0) {
                UserFollow::where(['id' => $follow_request_id])->update(['request_accept_status'=>1]);
                $status = "1";
                $message = "Request accepted";
            } else {
                $message = "No request found";
            }
        }
        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' => $o_data], 200);
    }
    public function follow_unfollow_user(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'follow_user_id' => 'required|numeric',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $follow_user_id = $request->follow_user_id;
            $check_follow_user_profile = User::find($follow_user_id);
            $check_exist = UserFollow::where(['follow_user_id' => $follow_user_id, 'user_id' => $user_id])->get();
            if ($check_exist->count() > 0) {
                $request_accept_status = 1;
                if( $check_follow_user_profile->is_private_profile == 1){
                    $request_accept_status = 0;
                }
                UserFollow::where(['follow_user_id' => $follow_user_id, 'user_id' => $user_id])->delete();
                $status = "1";
                $message = ($request_accept_status==0)?"Request Removed":"Un followed";
                if (config('global.server_mode') == 'local') {
                    \Artisan::call('remove_nottification:follow ' . $user_id.' '.$follow_user_id);
                } else {
                    exec("php " . base_path() . "/artisan remove_nottification:follow " . $user_id.' '.$follow_user_id . " > /dev/null 2>&1 & ");
                }
            } else {
                $request_accept_status = 1;
                if( $check_follow_user_profile->is_private_profile == 1){
                    $request_accept_status = 0;
                }
                $follow = new UserFollow();
                $follow->follow_user_id = $follow_user_id;
                $follow->user_id = $user_id;
                $follow->request_accept_status = $request_accept_status;
                $follow->created_at = gmdate('Y-m-d H:i:s');
                $follow->save();
                if ($follow->id > 0) {
                    $status = "1";
                    $message = ($request_accept_status==0)?"Request Sent":"Followed";
                    if (config('global.server_mode') == 'local') {
                        \Artisan::call('send_nottification:follow ' . $follow->id);
                    } else {
                        exec("php " . base_path() . "/artisan send_nottification:follow " . $follow->id . " > /dev/null 2>&1 & ");
                    }
                } else {
                    $message = "faild to follow";
                }
            }
        }
        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' => $o_data], 200);
    }

    public function search_user(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            //'search_key' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $search_text = $request->search_key;
            $page = (int) $request->page ?? 1;
            $limit = 20;
            $offset = ($page - 1) * $limit;
            $user_id = $this->validateAccesToken($request->access_token);

            $search_result = User::where(['active' => 1, 'deleted' => 0])->whereRaw("(email_verified=1 OR phone_verified=1)")->where('user_image', '!=', null)->where('id', '!=', $user_id);
            if($search_text != ''){
                $search_result->where(function ($query) use ($search_text) {
                    $query->where('users.name', 'ILIKE', '%'.$search_text . '%');
                    $query->orWhere('users.user_name', 'ILIKE', '%'.$search_text . '%');
                });
            }
            $search_result=$search_result->whereNotIn('id',BlockUser::where(['blocked_user_id'=>$user_id])->select('user_id'));
            $search_result = $search_result->orderBy('name', 'asc')->orderBy('id', 'desc');
            $search_result = $search_result->skip($offset)->take($limit)->get();
            if ($search_result->count() > 0) {
                $status = "1";
                $message = "Data fetched Successfully";
                $o_data = $search_result->toArray();
                $o_data = convert_all_elements_to_string($o_data);
            } else {
                $message = "no data to show";
            }
        }

        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' => $o_data], 200);
    }

    public function my_profile(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {

            $user_id = $this->validateAccesToken($request->access_token);

            $data = User::withCount(['posts', 'follower', 'followed', 'cart'])->where(['users.id' => $user_id])->get();
            if ($data->count() > 0) {
                $o_data = $data->first();
                $o_data->posts_count = (string) thousandsCurrencyFormat($o_data->posts_count);
                $o_data->follower_count = (string) thousandsCurrencyFormat($o_data->follower_count);
                $o_data->followed_count = (string) thousandsCurrencyFormat($o_data->followed_count);
                $o_data = convert_all_elements_to_string($o_data);
                $status = "1";
                $message = "data fetched Successfully";
            } else {
                $message = "no data to show";
            }
        }

        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' => $o_data], 200);
    }
    public function view_profile(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'user_id' => 'required',
        ]);

        if ($validator->fails()) {
            $o_data = null;
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {

            $user_id = $this->validateAccesToken($request->access_token);
            $profile_id = $request->user_id;

            $data = User::withCount(['posts', 'follower', 'followed'])->where(['users.id' => $profile_id])

                ->selectRaw(DB::raw(
                    "
          CASE
            WHEN
                users.is_private_profile = 0 and
                (select count(id) from user_follows where user_id='" . $user_id . "' and follow_user_id='" . $profile_id . "') >= 1
            THEN '1'
            WHEN
              (select count(id) from user_follows where user_id='" . $user_id . "' and follow_user_id='" . $profile_id . "') >= 1 and
              (select count(id) from user_follows where user_id='" . $profile_id . "' and follow_user_id='" . $user_id . "') >= 1
            THEN '1'
            WHEN
              (select count(id) from user_follows where user_id='" . $user_id . "' and follow_user_id='" . $profile_id . "') = 0 and
              (select count(id) from user_follows where user_id='" . $profile_id . "' and follow_user_id='" . $user_id . "') >= 1
            THEN '3'
            WHEN
              (select count(id) from user_follows where user_id='" . $user_id . "' and follow_user_id='" . $profile_id . "') >= 1 and
              (select count(id) from user_follows where user_id='" . $profile_id . "' and follow_user_id='" . $user_id . "') = 0
            THEN '2'
            WHEN
              (select count(id) from user_follows where user_id='" . $user_id . "' and follow_user_id='" . $profile_id . "') = 0 and
              (select count(id) from user_follows where user_id='" . $profile_id . "' and follow_user_id='" . $user_id . "') = 0
            THEN '0'
          END as is_followed


          "
                ))
                ->selectRaw(DB::raw("(select id from user_follows where user_id='".$user_id."' and follow_user_id='".$profile_id."') as follow_request_id"))
                ->selectRaw(DB::raw("(select count(id) from block_users where user_id='".$user_id."' and blocked_user_id='".$profile_id."') as is_blocked_by_me"))
                ->selectRaw(DB::raw("(select count(id) from hide_stories where user_id='".$user_id."' and hidden_user_id='".$profile_id."') as is_story_hidden_by_me"))
                ->selectRaw(DB::raw("(select count(id) from mute_stories where user_id='".$user_id."' and mute_user_id='".$profile_id."') as is_story_muted"))
                ->selectRaw(DB::raw("(select count(id) from user_favorites where user_id='".$user_id."' and fav_user_id='".$profile_id."') as is_fav"))

                ->get();
            if ($data->count() > 0) {
                $o_data = $data->first();
                $o_data->posts_count = (string) thousandsCurrencyFormat($o_data->posts_count);
                $o_data->follower_count = (string) thousandsCurrencyFormat($o_data->follower_count);
                $o_data->followed_count = (string) thousandsCurrencyFormat($o_data->followed_count);
                $o_data = convert_all_elements_to_string($o_data);

                //mark insight
                $insight = new UserProfileViewInsight();
                $insight->viewed_user_id = $user_id;
                $insight->viewed_profile_user_id = $profile_id;
                $insight->created_at = gmdate('Y-m-d H:i:s');
                $insight->updated_at = gmdate('Y-m-d H:i:s');
                $insight->save();
                $status = "1";
                $message = "data fetched Successfully";
            } else {
                $o_data = null;
                $message = "User not found";
            }
        }

        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' => $o_data], 200);
    }
    public function add_address(Request $request)
    {

        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];
        $validator = Validator::make($request->all(), [
            'full_name' => 'required',
            'dial_code' => 'required',
            'phone' => 'required',
            'address' => 'required',
            'flat_no' => 'required',
            'building_name' => 'required',
            'postcode' => 'required',
            'country_id' => 'required',
            'access_token' => 'required',
            'is_default' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);

            if ($request->is_default == 1) {
                $removedefault = UserAdress::where('user_id', $user_id)->update(['is_default' => 0]);
            }
            $address = new UserAdress();
            $address->user_id = $user_id;
            $address->full_name = $request->full_name;
            $address->dial_code = $request->dial_code;
            $address->phone = $request->phone;
            $address->flat_no = $request->flat_no;
            $address->building_name = $request->building_name;
            $address->address = $request->address;
            $address->country_id = $request->country_id;
            $address->latitude = $request->latitude;
            $address->longitude = $request->longitude;
            $address->address_type = '';
            $address->postcode = $request->postcode;
            $address->is_default = $request->is_default;
            $address->status = 1;
            $address->save();
            $status = "1";
            $message = "Address added successfully";
            $o_data = UserAdress::get_address_list($user_id);
        }
        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data]);

    }
    public function edit_address(Request $request)
    {

        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];
        $validator = Validator::make($request->all(), [
            'address_id' => 'required',
            'full_name' => 'required',
            'dial_code' => 'required',
            'phone' => 'required',
            'address' => 'required',
            'flat_no' => 'required',
            'building_name' => 'required',
            'postcode' => 'required',
            'country_id' => 'required',
            'access_token' => 'required',
            'is_default' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $address = UserAdress::find($request->address_id);
            if (!$address) {
                $status = "0";
                $message = "No data found";
            } else {
                if ($request->is_default == 1) {
                    $removedefault = UserAdress::where('user_id', $user_id)->update(['is_default' => 0]);
                }
                $address->user_id = $user_id;
                $address->full_name = $request->full_name;
                $address->dial_code = $request->dial_code;
                $address->phone = $request->phone;
                $address->flat_no = $request->flat_no;
                $address->building_name = $request->building_name;
                $address->address = $request->address;
                $address->country_id = $request->country_id;
                $address->latitude = $request->latitude;
                $address->longitude = $request->longitude;
                $address->address_type = '';
                $address->postcode = $request->postcode;
                $address->is_default = $request->is_default;
                $address->status = 1;
                $address->save();
                $status = "1";
                $message = "Address updated successfully";
                $o_data = UserAdress::get_address_list($user_id);
            }

        }
        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data]);

    }
    public function setdefault(Request $request)
    {

        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];
        $validator = Validator::make($request->all(), [
            'address_id' => 'required',
            'access_token' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $address = UserAdress::find($request->address_id);
            if (!$address) {
                $status = "0";
                $message = "No data found";
            } else {
                $removedefault = UserAdress::where('user_id', $user_id)->update(['is_default' => 0]);
                $address->is_default = 1;
                $address->save();
                $status = "1";
                $message = "Address set as default";
                $o_data = UserAdress::get_address_list($user_id);
            }

        }
        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data]);

    }
    public function delete_address(Request $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];
        $validator = Validator::make($request->all(), [
            'address_id' => 'required',
            'access_token' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $address = UserAdress::find($request->address_id);
            if (!$address) {
                $status = "0";
                $message = "No data found";
            } else {
                $address->status = 0;
                $address->save();
                $status = "1";
                $message = "Address deleted successfully";
                $o_data = UserAdress::get_address_list($user_id);
            }
        }
        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data]);

    }
    public function list_address(Request $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $status = "1";
            $message = "Address fetched successfully";
            $o_data = UserAdress::get_address_list($user_id);
        }
        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data]);

    }
    public function update_user_profile(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];
        $user_id = $this->validateAccesToken($request->access_token);
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'name' => 'required',
            'user_name' => 'required|min:4|max:10|unique:users,user_name,' . $user_id,
            'gender' => 'required|in:1,2,3',
            'about_me' => 'required',
            'website' => 'max:2500',
            'user_image' => 'mimes:jpeg,png,jpg',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {

            if(!preg_match("/^[a-zA-Z0-9._]+$/", $request->user_name)){
                return response()->json([
                    'status' =>"0",
                    'error' => (object) array(),
                    'message' => 'Username should contain only letters, numbers, dot(.) and underscore',
                ], 200);
            }

            $user = User::find($user_id);

            if ($file = $request->file("user_image")) {
                $dir = config('global.upload_path') . "/" . config('global.user_image_upload_dir');
                $file_name = time() . uniqid() . "." . $file->getClientOriginalExtension();
                $file->storeAs(config('global.user_image_upload_dir'), $file_name, config('global.upload_bucket'));
                $user->user_image = $file_name;
            }

            $user->user_name = $request->user_name;
            $user->website = $request->website;
            $user->about_me = $request->about_me;
            $user->gender = $request->gender;
            $user->is_private_profile = $request->is_private_profile ?? 0;
            $user->name = $request->name;
            $user->public_business_info = isset($request->public_business_info) ? $request->public_business_info : 0;
            if(!$user->public_business_info){
                $user->public_business_info = 0;
            }
            $user->facebook_url = isset($request->facebook_url) ? $request->facebook_url : '';
            $user->instagram_url = isset($request->instagram_url) ? $request->instagram_url : '';
            $user->linkedin_url = isset($request->linkedin_url) ? $request->linkedin_url : '';
            $user->twitter_url = isset($request->twitter_url) ? $request->twitter_url : '';
            $user->tiktok_url = isset($request->tiktok_url) ? $request->tiktok_url : '';
            $user->save();

            $data = User::where(['users.id' => $user_id])->get();
            $o_data = $data->first();
            $o_data = convert_all_elements_to_string($o_data);
            $status = "1";
            $message = "Profile updated Successfully";

            //enable exec on server
            if (config('global.server_mode') == 'local') {
                \Artisan::call('update:firebase_node ' . $user_id);
            } else {
                exec("php " . base_path() . "/artisan update:firebase_node " . $user_id . " > /dev/null 2>&1 & ");
            }

        }
        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data]);
    }

    public function change_phone_number(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];
        $user_id = $this->validateAccesToken($request->access_token);
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'dial_code' => 'required',
            'phone' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user = User::find($user_id);
            if ($user->dial_code != $request->dial_code || $user->phone != $request->phone) {

                if (User::where('phone', $request->phone)->where('dial_code', $request->dial_code)->first() != null) {
                    return response()->json([
                        'status' => "0",
                        'error' => (object) array(),
                        'message' => 'This number already in use',
                    ], 201);
                }

                $mobile = $request->dial_code . $request->phone;
                $otp = generate_otp();
                $messagen = "OTP to confirm your mobile number at " . config('global.site_name') . " is " . $otp;
                $st = send_normal_SMS($messagen, $mobile);
                if($st!=1){
                    return response()->json([
                        'status' =>"0",
                        'error' => (object) array(),
                        'message' => $st,
                    ], 201);
                }
                $status = "1";
                $message = "Please verify the otp ";
                $o_data = [
                    'dial_code' => $request->dial_code,
                    'phone' => $request->phone,
                ];
                $user->user_phone_otp = $otp;
                $user->phone_verified = 0;
                $user->save();
            } else {
                $message = "There is no change in your phone number";
            }

        }
        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data]);
    }
    public function validate_otp_phone_email_update(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];
        $user_id = $this->validateAccesToken($request->access_token);
        $rule = [
            'access_token' => 'required',
            'type' => 'required|in:1,2',
            'otp' => 'required',
        ];

        if ($request->type == 1) {
            $rule['dial_code'] = 'required';
            $rule['phone'] = 'required';
        } else {
            $rule['email'] = 'required';
        }
        $validator = Validator::make($request->all(), $rule);
        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user = User::find($user_id);
            $sent_opt = $user->user_phone_otp;
            if ($request->type == 2) {
                $sent_opt = $user->user_email_otp;
            }
            if ($sent_opt == $request->otp) {

                if ($request->type == 1) {
                    $user->dial_code = $request->dial_code;
                    $user->phone = $request->phone;
                    $user->phone_verified = 1;
                    $user->user_phone_otp = '';
                    $user->save();
                    $status = "1";
                    $message = "Phone number updated successfully";
                } else {
                    $user->email = $request->email;
                    $user->user_email_otp = '';
                    $user->save();
                    $status = "1";
                    $message = "email id updated successfully";
                }
                if (config('global.server_mode') == 'local') {
                    \Artisan::call('update:firebase_node ' . $user_id);
                } else {
                    exec("php " . base_path() . "/artisan update:firebase_node " . $user_id . " > /dev/null 2>&1 & ");
                }

            } else {
                $message = "Invalid otp sent";
            }

        }
        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data]);
    }

    public function change_email(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];
        $user_id = $this->validateAccesToken($request->access_token);
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'email' => 'required|unique:users,email,' . $user_id,
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user = User::find($user_id);
            if ($user->email != $request->email) {
                $lemail = strtolower($request->email);
                if (User::whereRaw("LOWER(email) = '$lemail'")->first() != null) {
                    return response()->json([
                        'status' => "0",
                        'error' => (object) array(),
                        'message' => 'This email already in use',
                    ], 201);
                }

                $otp = generate_otp();
                $name = $user->name;
                $mailbody = view('emai_templates.change_email_otp', compact('otp', 'name'));
                $ret = send_email($request->email, config('global.site_name') . " email change request", $mailbody);
                if ($ret) {
                    $status = "1";
                    $message = "Please verify the otp ";
                    $o_data = [
                        'email' => $request->email,
                    ];
                    $user->user_email_otp = $otp;
                    $user->save();
                } else {
                    $message = "Faild to sent mail. please try again after some times";
                }
            } else {
                $message = "There is no change in your phone number";
            }

        }
        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data]);
    }
    public function change_password(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];
        $user_id = $this->validateAccesToken($request->access_token);
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'old_password' => 'required',
            'new_password' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user = User::find($user_id);
            if (Hash::check($request->old_password, $user->password)) {
                $user->password = bcrypt($request->new_password);
                $user->save();
                $status = "1";
                $message = "Password Updated successfully";
            } else {
                $message = "Old password not match";
            }

        }
        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data]);
    }

    public function wallet_payment_init(Request $request)
    {
        $status = "0";
        $o_data = [];
        $errors = [];
        $message = "Unable to initialize the payment";

        $user_id = $this->validateAccesToken($request->access_token);
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'amount' => 'required|integer|min:1',
            'payment_type' => 'required|integer|min:1',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {

            $amount = $request->amount;
            // $max_wallet_amount = 50000 - $User->wallet_amount;
            // if ($amount > $max_wallet_amount || $max_wallet_amount < 0) {
            //     if ($max_wallet_amount <= 0) {
            //         $message = 'you have reached maximum amount limit in your wallet';
            //     } else {
            //         $message = "Maximum rechargable amount is AED " . $max_wallet_amount;
            //     }

            // } else {
            $user = User::find($user_id);
            $address = UserAdress::get_user_default_address($user_id);
            \Stripe\Stripe::setApiKey(env('STRIPE_SECRET'));
            $checkout_session = \Stripe\PaymentIntent::create([
                'amount' => $amount * 100,
                'currency' => 'GBP',
                'description' => 'Wallet Recharge (via App)',
                'shipping' => [
                    'name' => $user->name ?? $user->first_name . ' ' . $user->last_name,
                    'address' => [
                        'line1' => $address->address,
                        'city' => $address->city_name,
                        'state' => $address->state_name,
                        'country' => $address->country_name,
                    ],
                ],
            ]);

            $ref = $checkout_session->id;
            $invoice_id = $user_id . uniqid() . time();
            $paymentreport = [
                'transaction_id' => $invoice_id,
                'payment_status' => 'P',
                'user_id' => $user->id,
                'ref_id' => $ref,
                'amount' => $amount,
                'method_type' => $request->payment_type,
                'created_at' => gmdate('Y-m-d H:i:s'),
            ];

            WalletPaymentReport::insert($paymentreport);
            $o_data['payment_ref'] = $checkout_session->client_secret;
            $o_data['invoice_id'] = $invoice_id;
            $status = 1;
            $message = "";
            // }
        }
        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data]);
    }

    public function wallet_recharge(Request $request)
    {
        $status = "0";
        $o_data = [];
        $errors = [];
        $message = "Failed to recharge the wallet";

        $user_id = $this->validateAccesToken($request->access_token);
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'invoice_id' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $payment_det = WalletPaymentReport::where(['transaction_id' => $request->invoice_id, 'user_id' => $user_id, 'payment_status' => 'P'])->first();
            if ($payment_det) {
                $payamount = $payment_det->amount;
                $user = User::find($user_id);
                if ($user !== null) {
                    $user->wallet_amount = $user->wallet_amount + $payamount;
                    if ($user->save()) {
                        $data = [
                            'user_id' => $user_id,
                            'wallet_amount' => $payamount,
                            'pay_type' => 'credited',
                            'pay_method' => $payment_det->method_type,
                            'description' => 'Wallet Top up (via App)',
                        ];

                        if (wallet_history($data)) {
                            WalletPaymentReport::where(['transaction_id' => $request->invoice_id, 'user_id' => $user_id])->update(['payment_status' => 'A']);
                            $status = "1";
                            $message = "Wallet recharged successfully";
                        }
                    }
                }
            }
        }
        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data]);
    }

    public function wallet_details(Request $request)
    {
        $status = "1";
        $o_data = [];
        $errors = [];
        $message = "";

        $user_id = $this->validateAccesToken($request->access_token);
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $last_payment_det = WalletPaymentReport::where(['user_id'=>$user_id,'payment_status'=>'A'])->orderBy('id','desc')->first();
            $last_history_det = \App\Models\WalletHistory::where(['user_id'=>$user_id])->orderBy('id','desc')->first();
            $user = User::find($user_id);
            $o_data['balance'] = $user->wallet_amount;
            $o_data['last_recharged'] = '';
            if($last_payment_det){
              $o_data['last_recharged'] =$last_payment_det->created_at;// date('d F Y h:i A',strtotime($last_payment_det->created_at));
            }
            $o_data['transaction']['last_updated'] = '';
            if($last_history_det){
              $o_data['transaction']['last_updated'] = $last_history_det->created_at;//date('d F Y h:i A',strtotime($last_history_det->created_at));
            }

            $wallet_history = \App\Models\WalletHistory::where(['user_id'=>$user_id])->orderBy('id','desc')->get();
            foreach($wallet_history as $key=>$val){
              $wallet_history[$key]->transaction_id = 'WR'.date(date('Ymd', strtotime($val->created_at))).$val->id;
              $pay_method = '';
              if($val->pay_method==1){
                $pay_method = 'Credit Card';
              }
              if($val->pay_method==2){
                $pay_method = 'Apple Pay';
              }
              $wallet_history[$key]->pay_method = $pay_method;
            }
            $o_data['transaction']['list'] = $wallet_history;
        }
        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data]);
    }
    public function bio_list(Request $request)
    {

        $bios = ProfileBio::get()->toArray();
        $bios = array_column($bios,'value');
        return response()->json([
            'status' => "1",
            'message' => 'Data fetched successfully',
            'errors' => [],
            'oData' => $bios,
        ], 200);
    }
    public function my_following_list(REQUEST $request){
        $status = "1";
        $o_data = [];
        $errors = [];
        $message = "";
        $extra_data = [];

        $user_id = $this->validateAccesToken($request->access_token);
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $search_text = $request->search_key;
            $page  = $request->page??1;
            $limit = $request->limit??20;
            $offset= ($page - 1) * $limit;
            $list = UserFollow::my_following_list($user_id,$search_text);
            $total_count = $list->get()->count();
            $paginate  = $list->take($limit)->skip($offset)->get();
            if($paginate->count() > 0){
                $list = $paginate->toArray();
                foreach($list as $key=>$value){
                    $list[$key]['user_image'] = get_uploaded_image_url($value['user_image'],'user_image_upload_dir');
                }
                $o_data = convert_all_elements_to_string($list);
                $extra_data['current_page'] = (string)$page;
                $extra_data['total_count']  = (string)$total_count;
                $extra_data['per_page']     = (string)$limit;
                $status = "1";
                $message = "data fetched successfully";

            }else{
                $message = "no data to list";
            }
        }
        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data, 'extra_data'=>(object)$extra_data]);
    }
    public function my_followers_list(REQUEST $request){
        $status = "1";
        $o_data = [];
        $errors = [];
        $message = "";
        $extra_data = [];

        $user_id = $this->validateAccesToken($request->access_token);
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $search_text = $request->search_key;
            $page  = $request->page??1;
            $limit = $request->limit??20;
            $offset= ($page - 1) * $limit;
            $list = UserFollow::get_my_followers($user_id,$search_text);
            $total_count = $list->get()->count();
            $paginate  = $list->take($limit)->skip($offset)->get();
            if($paginate->count() > 0){
                $list = $paginate->toArray();
                foreach($list as $key=>$value){
                    $list[$key]['user_image'] = get_uploaded_image_url($value['user_image'],'user_image_upload_dir');
                }
                $o_data = convert_all_elements_to_string($list);
                $extra_data['current_page'] = (string)$page;
                $extra_data['total_count']  = (string)$total_count;
                $extra_data['per_page']     = (string)$limit;
                $status = "1";
                $message = "data fetched successfully";

            }else{
                $message = "no data to list";
            }
        }
        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data, 'extra_data'=>(object)$extra_data]);
    }
    public function remove_follower(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'follow_id' => 'required|numeric',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $follow_id = $request->follow_id;
            $check_exist = UserFollow::where(['id' => $follow_id,'follow_user_id'=>$user_id])->get();
            if ($check_exist->count() > 0) {
                UserFollow::where(['id' => $follow_id])->delete();
                $status = "1";
                $message = "Removed";
            } else {
                $message = "Invalid request";
            }
        }
        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' => $o_data], 200);
    }

    public function others_following_list(REQUEST $request){
        $status = "1";
        $o_data = [];
        $errors = [];
        $message = "";
        $extra_data = [];

        $loged_user_id = $this->validateAccesToken($request->access_token);
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $search_text = $request->search_key;
            $user_id = $request->user_id;
            $page  = $request->page??1;
            $limit = $request->limit??20;
            $offset= ($page - 1) * $limit;
            $list = UserFollow::others_following_list($user_id,$loged_user_id,$search_text);
            $total_count = $list->get()->count();
            $paginate  = $list->take($limit)->skip($offset)->get();
            if($paginate->count() > 0){
                $list = $paginate->toArray();
                foreach($list as $key=>$value){
                    $list[$key]['user_image'] = get_uploaded_image_url($value['user_image'],'user_image_upload_dir');
                }
                $o_data = convert_all_elements_to_string($list);
                $extra_data['current_page'] = (string)$page;
                $extra_data['total_count']  = (string)$total_count;
                $extra_data['per_page']     = (string)$limit;
                $status = "1";
                $message = "data fetched successfully";

            }else{
                $message = "no data to list";
            }
        }
        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data, 'extra_data'=>(object)$extra_data]);
    }
    public function others_followers_list(REQUEST $request){
        $status = "1";
        $o_data = [];
        $errors = [];
        $message = "";
        $extra_data = [];

        $loged_user_id = $this->validateAccesToken($request->access_token);
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $search_text = $request->search_key;
            $user_id = $request->user_id;
            $page  = $request->page??1;
            $limit = $request->limit??20;
            $offset= ($page - 1) * $limit;
            $list = UserFollow::get_others_followers($user_id,$loged_user_id,$search_text);
            $total_count = $list->get()->count();
            $paginate  = $list->take($limit)->skip($offset)->get();
            if($paginate->count() > 0){
                $list = $paginate->toArray();
                foreach($list as $key=>$value){
                    $list[$key]['user_image'] = get_uploaded_image_url($value['user_image'],'user_image_upload_dir');
                }
                $o_data = convert_all_elements_to_string($list);
                $extra_data['current_page'] = (string)$page;
                $extra_data['total_count']  = (string)$total_count;
                $extra_data['per_page']     = (string)$limit;
                $status = "1";
                $message = "data fetched successfully";

            }else{
                $message = "no data to list";
            }
        }
        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data, 'extra_data'=>(object)$extra_data]);
    }

    public function report_user(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'user_id' => 'required',
            'reason'  => 'required',
            'problem_id'  => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {

            $user_id = $this->validateAccesToken($request->access_token);
            $profile_id = $request->user_id;
            $data = new UserReport();
            $data->user_id = $user_id;
            $data->reported_user_id = $profile_id;
            $data->reason = $request->reason;
            $data->problem_id = $request->problem_id;
            $data->save();

            if ($data->id > 0) {
                $status = "1";
                $message = "Profile Reported Successfully. Our team will look into it shortly";
            } else {
                $message = "Faild to report";
            }
        }

        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' => $o_data], 200);
    }
    public function get_message_privacy(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required'
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {

            $user_id = $this->validateAccesToken($request->access_token);
            $o_data = config('global.message_privacy');

            $status = "1";
        }

        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' => $o_data], 200);
    }
    public function update_message_settings(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'privacy_id' => 'required',
            'nottification'=> 'required',
            'mute_message' => 'required'
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {

            $user_id = $this->validateAccesToken($request->access_token);
            $user = User::find($user_id);
            $user->privacy_id       =  $request->privacy_id;
            $user->send_notification=  $request->nottification;
            $user->mute_message     =  $request->mute_message;
            $user->save();
            $status = "1";
            $message = "Settings updated successfully";
            if (config('global.server_mode') == 'local') {
                \Artisan::call('update:firebase_node ' . $user_id);
            } else {
                exec("php " . base_path() . "/artisan update:firebase_node " . $user_id . " > /dev/null 2>&1 & ");
            }
        }

        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' => $o_data], 200);
    }
    public function get_report_user_problems(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required'
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $o_data = config('global.report_user_problems');

            $status = "1";
        }

        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' => $o_data], 200);
    }
    public function get_public_business_infos()
    {
        $message = "";
        $o_data = [];
        $errors = [];
        $o_data = PublicBusinessInfos::select('id','title')->where(['deleted' => 0,'active' => 1])->get();;
        $status = "1";
        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' => $o_data], 200);
    }

    public function get_nearest_users(REQUEST $request){
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'lattitude'    => 'required',
            'longitude'    => 'required'
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $lattitude = $request->lattitude;
            $longitude = $request->longitude;

            $list = UserLocations::fetch_nearest_users($lattitude,$longitude,$user_id);
            if($list->count() > 0){
                $status = "1";
                $message = "users fetched successfully";
                $o_data = convert_all_elements_to_string($list);
            }else{
                $message = "no data to list";
            }
        }

        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' => $o_data], 200);
    }
    public function get_cross_by_users(REQUEST $request){
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'lattitude'    => 'required',
            'longitude'    => 'required'
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $lattitude = $request->lattitude;
            $longitude = $request->longitude;
            $page = (int)$request->page??1;
            $limit= 20;
            $offset = ($page - 1) * $limit;
            $filter['distance'] = $request->distance;
            $filter['search_key'] = $request->search_key;

            $list = UserLocations::get_cross_by_users($lattitude,$longitude,$user_id,$offset,$limit,$filter);
            if($list->count() > 0){
                $status = "1";
                $message = "users fetched successfully";
                $o_data = convert_all_elements_to_string($list);
            }else{
                $message = "no data to list";
            }
        }

        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' => $o_data], 200);
    }

    public function fav_unfav_user(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'fav_user_id' => 'required|numeric',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $fav_user_id = $request->fav_user_id;
            $check_exist = UserFavorite::where(['fav_user_id' => $fav_user_id, 'user_id' => $user_id])->get();
            if ($check_exist->count() > 0) {
                UserFavorite::where(['fav_user_id' => $fav_user_id, 'user_id' => $user_id])->delete();
                $status = "1";
                $message ="Removed from favorite";
            } else {
                $fav = new UserFavorite();
                $fav->fav_user_id = $fav_user_id;
                $fav->user_id = $user_id;
                $fav->created_at = gmdate('Y-m-d H:i:s');
                $fav->save();
                if ($fav->id > 0) {
                    $status = "1";
                    $message = "Added to favorite list";
                } else {
                    $message = "faild to favorite";
                }
            }
        }
        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' => $o_data], 200);
    }

    public function get_fav_users(REQUEST $request)
    {
        $status = "1";
        $o_data = [];
        $errors = [];
        $message = "";
        $extra_data = [];

        $user_id = $this->validateAccesToken($request->access_token);
        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $page  = $request->page??1;
            $limit = $request->limit??20;
            $offset= ($page - 1) * $limit;
            $sort_user = isset($request->user_id)?$request->user_id : '';
            $list = UserFavorite::my_fav_list($user_id,$sort_user);
            $total_count = $list->get()->count();
            $paginate  = $list->take($limit)->skip($offset)->get();
            if($paginate->count() > 0){
                $list = $paginate->toArray();
                foreach($list as $key=>$value){
                    $list[$key]['user_image'] = get_uploaded_image_url($value['user_image'],'user_image_upload_dir');
                }
                $o_data = convert_all_elements_to_string($list);
                $extra_data['current_page'] = (string)$page;
                $extra_data['total_count']  = (string)$total_count;
                $extra_data['per_page']     = (string)$limit;
                $status = "1";
                $message = "data fetched successfully";

            }else{
                $message = "no data to list";
            }
        }
        return response()->json(['status' => $status, 'message' => $message, 'errors' => $errors, 'oData' => $o_data, 'extra_data'=>(object)$extra_data]);
    }
    public function get_user_connection_details(REQUEST $request){
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required'
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $login_user_id = $this->validateAccesToken($request->access_token);
            $user_id       = $request->user_id;

            $follow_details = UserFollow::where(['user_id'=>$login_user_id,'follow_user_id'=>$user_id])->select(['id','user_id'])->get();
            if($follow_details->count() > 0){
                $user_details  = User::where(['id'=>$user_id])->select(['id','name','user_image','email','dial_code','phone','firebase_user_key','user_device_token'])->get()->first();
                $my_post_like_count = PostLikes::where('user_id','>=',$login_user_id)
                ->whereIn('post_id',function($query) use($user_id){
                    $query->select('id')->from('posts')->where('user_id','=',$user_id);
                })
                ->count();
                $my_comment_count = PostComment::where('user_id','>=',$login_user_id)
                ->whereIn('post_id',function($query) use($user_id){
                    $query->select('id')->from('posts')->where('user_id','=',$user_id);
                })->count();
                $data['user_details'] = $user_details;
                $data['post_like_count'] = $my_post_like_count;
                $data['comment_like_count'] = $my_comment_count;
                $data['follow_details'] = $follow_details->first();

                $o_data = convert_all_elements_to_string($data);
                $status = "1";
                $message = "success";
            }else{
                $message = "You are not following this person";
            }


        }
        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' =>(object)$o_data], 200);
    }
    public function my_insight(REQUEST $request){
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required'
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {
            $user_id = $this->validateAccesToken($request->access_token);
            $days = $request->days??30;
            $prev_day = $days * 2;
            $today = gmdate('Y-m-d');
            $last_date = date('Y-m-d', strtotime('-'.$days.' day'));
            $prev_month_start_date = date('Y-m-d', strtotime('-'.$prev_day.' day'));
            $from_date_to_date_text = "Overview of $last_date to $today";
            $prev_month_date_text   = "Overview of $prev_month_start_date to $last_date";
            $my_followers_count = UserFollow::where(['follow_user_id'=>$user_id,'request_accept_status'=>1])->whereDate('created_at','>=',$last_date)->whereDate('created_at','<=',$today)->count();
            $my_prev_followers_count = UserFollow::where(['follow_user_id'=>$user_id,'request_accept_status'=>1])->whereDate('created_at','>=',$prev_month_start_date)->whereDate('created_at','<=',$last_date)->count();

            //profile view insight
            $my_profile_view_count = UserProfileViewInsight::where(['viewed_profile_user_id'=>$user_id])->whereDate('created_at','>=',$last_date)->whereDate('created_at','<=',$today)->count();
            $my_prev_profile_view_count = UserProfileViewInsight::where(['viewed_profile_user_id'=>$user_id])->whereDate('created_at','>=',$prev_month_start_date)->whereDate('created_at','<=',$last_date)->count();

            $data['current_month_data']['overview_text'] = $from_date_to_date_text;
            $data['current_month_data']['your_audience']['my_followers_count'] = $my_followers_count;
            $data['current_month_data']['your_audience']['profile_intraction'] = $my_profile_view_count;


            $data['prevous_month_data']['overview_text'] = $prev_month_date_text;
            $data['prevous_month_data']['your_audience']['my_followers_count'] = $my_prev_followers_count;
            $data['prevous_month_data']['your_audience']['profile_intraction'] = $my_prev_profile_view_count;
            //my posts intractions
            $my_post_like_count = PostLikes::whereDate('created_at','>=',$last_date)->whereDate('created_at','<=',$today)
            ->whereIn('post_id',function($query) use($user_id){
                $query->select('id')->from('posts')->where('user_id','=',$user_id);
            })
            ->count();
            $my_prev_post_like_count = PostLikes::whereDate('created_at','>=',$prev_month_start_date)->whereDate('created_at','<=',$last_date)
            ->whereIn('post_id',function($query) use($user_id){
                $query->select('id')->from('posts')->where('user_id','=',$user_id);
            })->count();
            $my_comment_count = PostComment::whereDate('created_at','>=',$last_date)->whereDate('created_at','<=',$today)
            ->whereIn('post_id',function($query) use($user_id){
                $query->select('id')->from('posts')->where('user_id','=',$user_id);
            })->count();
            $my_prev_comment_count = PostComment::whereDate('created_at','>=',$prev_month_start_date)->whereDate('created_at','<=',$last_date)
            ->whereIn('post_id',function($query) use($user_id){
                $query->select('id')->from('posts')->where('user_id','=',$user_id);
            })->count();
            $data['current_month_data']['your_audience']['content_intraction'] = $current_content_intraction = ($my_post_like_count + $my_comment_count);
            $data['prevous_month_data']['your_audience']['content_intraction'] = $prev_content_intraction    = ($my_prev_post_like_count + $my_prev_comment_count);
            if($current_content_intraction == $prev_content_intraction){
                $highlight_text = "You received same content intractions in last 30 days compared to ".date('M-Y',strtotime($last_date))." to ".date('M-Y',strtotime($prev_month_start_date));
            }else if($current_content_intraction > $prev_content_intraction){
                $diffrence_in_intraction = ($current_content_intraction - $prev_content_intraction);
                $highlight_text = "You received $diffrence_in_intraction more content intractions in last 30 days compared to ".date('M-Y',strtotime($last_date))." to ".date('M-Y',strtotime($prev_month_start_date));
            }else{
                $diffrence_in_intraction = ($prev_content_intraction - $current_content_intraction);
                $highlight_text = "You received $diffrence_in_intraction less content intractions in last 30 days compared to ".date('M-Y',strtotime($last_date))." to ".date('M-Y',strtotime($prev_month_start_date));
            }



            //ovrview
            $profile_view_count = UserProfileViewInsight::where(['viewed_user_id'=>$user_id])->whereDate('created_at','>=',$last_date)->whereDate('created_at','<=',$today)->count();
            $prev_profile_view_count = UserProfileViewInsight::where(['viewed_user_id'=>$user_id])->whereDate('created_at','>=',$prev_month_start_date)->whereDate('created_at','<=',$last_date)->count();
            $data['current_month_data']['over_view']['account_reached'] = $profile_view_count;
            $data['prevous_month_data']['over_view']['account_reached'] = $prev_profile_view_count;

            //content intraction
            $post_like_count = PostLikes::where(['user_id'=>$user_id])->whereDate('created_at','>=',$last_date)->whereDate('created_at','<=',$today)->count();
            $prev_post_like_count = PostLikes::where(['user_id'=>$user_id])->whereDate('created_at','>=',$prev_month_start_date)->whereDate('created_at','<=',$last_date)->count();
            $comment_count = PostComment::where(['user_id'=>$user_id])->whereDate('created_at','>=',$last_date)->whereDate('created_at','<=',$today)->count();
            $prev_comment_count = PostComment::where(['user_id'=>$user_id])->whereDate('created_at','>=',$prev_month_start_date)->whereDate('created_at','<=',$last_date)->count();
            $data['current_month_data']['over_view']['content_intraction'] = ($post_like_count + $comment_count);
            $data['prevous_month_data']['over_view']['content_intraction'] = ($prev_post_like_count + $prev_comment_count);

            $status = "1";
            $o_data['highlight_text'] = $highlight_text;
            $o_data['intractions'] = convert_all_elements_to_string($data);
            $post_count = Post::where(['user_id'=>$user_id])->whereDate('created_at','>=',$last_date)->whereDate('created_at','<=',$today)->count();
            $posts = Post::select(['id','caption','file_type','file','created_at'])->where(['user_id'=>$user_id])->whereDate('created_at','>=',$last_date)->whereDate('created_at','<=',$today)->get();
            $post_list = [];
            if($posts->count() > 0){
                $post_list = convert_all_elements_to_string($posts);
            }
            $o_data['posts'] = $post_list;
            $o_data['total_posts'] = (string)$post_count;
        }
        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' =>$o_data], 200);
    }
    public function view_profile_by_username(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'username' => 'required',
        ]);

        if ($validator->fails()) {
            $o_data = null;
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {

            $user_id = $this->validateAccesToken($request->access_token);
            $usr_det = User::where('user_name', $request->username)->first();
            $profile_id = $usr_det->id;
            if($profile_id){
                $data = User::withCount(['posts', 'follower', 'followed'])->where(['users.id' => $profile_id])

                ->selectRaw(DB::raw(
                    "
            CASE
                WHEN
                    users.is_private_profile = 0 and
                    (select count(id) from user_follows where user_id='" . $user_id . "' and follow_user_id='" . $profile_id . "') >= 1
                THEN '1'
                WHEN
                (select count(id) from user_follows where user_id='" . $user_id . "' and follow_user_id='" . $profile_id . "') >= 1 and
                (select count(id) from user_follows where user_id='" . $profile_id . "' and follow_user_id='" . $user_id . "') >= 1
                THEN '1'
                WHEN
                (select count(id) from user_follows where user_id='" . $user_id . "' and follow_user_id='" . $profile_id . "') = 0 and
                (select count(id) from user_follows where user_id='" . $profile_id . "' and follow_user_id='" . $user_id . "') >= 1
                THEN '3'
                WHEN
                (select count(id) from user_follows where user_id='" . $user_id . "' and follow_user_id='" . $profile_id . "') >= 1 and
                (select count(id) from user_follows where user_id='" . $profile_id . "' and follow_user_id='" . $user_id . "') = 0
                THEN '2'
                WHEN
                (select count(id) from user_follows where user_id='" . $user_id . "' and follow_user_id='" . $profile_id . "') = 0 and
                (select count(id) from user_follows where user_id='" . $profile_id . "' and follow_user_id='" . $user_id . "') = 0
                THEN '0'
            END as is_followed


            "
                    ))
                    ->selectRaw(DB::raw("(select id from user_follows where user_id='".$user_id."' and follow_user_id='".$profile_id."') as follow_request_id"))
                    ->selectRaw(DB::raw("(select count(id) from block_users where user_id='".$user_id."' and blocked_user_id='".$profile_id."') as is_blocked_by_me"))
                    ->selectRaw(DB::raw("(select count(id) from hide_stories where user_id='".$user_id."' and hidden_user_id='".$profile_id."') as is_story_hidden_by_me"))
                    ->selectRaw(DB::raw("(select count(id) from mute_stories where user_id='".$user_id."' and mute_user_id='".$profile_id."') as is_story_muted"))
                    ->selectRaw(DB::raw("(select count(id) from user_favorites where user_id='".$user_id."' and fav_user_id='".$profile_id."') as is_fav"))

                    ->get();
                if ($data->count() > 0) {
                    $o_data = $data->first();
                    $o_data->posts_count = (string) thousandsCurrencyFormat($o_data->posts_count);
                    $o_data->follower_count = (string) thousandsCurrencyFormat($o_data->follower_count);
                    $o_data->followed_count = (string) thousandsCurrencyFormat($o_data->followed_count);
                    $o_data = convert_all_elements_to_string($o_data);

                    //mark insight
                    $insight = new UserProfileViewInsight();
                    $insight->viewed_user_id = $user_id;
                    $insight->viewed_profile_user_id = $profile_id;
                    $insight->created_at = gmdate('Y-m-d H:i:s');
                    $insight->updated_at = gmdate('Y-m-d H:i:s');
                    $insight->save();
                    $status = "1";
                    $message = "data fetched Successfully";
                } else {
                    $o_data = null;
                    $message = "User not found";
                }
            }else{
                $o_data = null;
                $message = "User not found";
            }   
        }
        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' => $o_data], 200);
    }
    public function toggle_private_profile(REQUEST $request)
    {
        $status = "0";
        $message = "";
        $o_data = [];
        $errors = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'is_private_profile' => 'required',
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        } else {

            $user_id = $this->validateAccesToken($request->access_token);
            $user = User::find($user_id);
            $user->is_private_profile = $request->is_private_profile;
            $user->save();
            $message = "Successfully updated";
            $status = "1";
        }

        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' => $o_data], 200);
    }
}
