<?php

namespace App\Http\Controllers\Api\v1_old;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\User;
use App\Models\Stories;
use Validator;
use GuzzleHttp\Client as GuzzleClient;
use Kreait\Firebase\Contract\Database;
class Wowza_Controller extends Controller
{
    //
    public function __construct(Database $database)
    {
        $this->database = $database;
    }
    private $video_url  = "https://moda.uksouth.cloudapp.azure.com:8088/mrecord/";
    private $hostUrl    = "http://moda.uksouth.cloudapp.azure.com:8087/v2/";
    private $user_name  = "moda";
    private $password   = 'moda@wowza@2022';
    private $wowza_live_app = "moda-ll-stream";
    private $default_server_name = "_defaultServer_";
    private $v_hots = "_defaultVHost_";
    private $instance = "_definst_";


    private function validateAccesToken($access_token){

      $user = User::where(['user_access_token'=>$access_token])->get();

      if($user->count() == 0){
         http_response_code(401);
              echo json_encode([
                    'status' => "0",
                    'message' => 'Invalid login',
                    'oData' => [],
                    'errors' => (object)[]
                ]);
                exit;

      }else{
          $user=$user->first();
          if($user->active == 1){
            return $user->id;
          }else{
              http_response_code(401);
              echo json_encode([
                    'status' => "0",
                    'message' => 'Invalid login',
                    'oData' => [],
                    'errors' => (object)[]
                ]);
                exit;
              return response()->json([
                    'status' => "0",
                    'message' => 'Invalid login',
                    'oData' => [],
                    'errors' => (object)[]
                ], 401);
                exit;
          }
      }
    }

    private function sendRequestToWowza($data=[]){
      $url = $this->hostUrl."servers/".$this->default_server_name."/vhosts/".$this->v_hots."/applications/".$this->wowza_live_app."/instances/".$this->instance."/streamrecorders/".$data['recorderName'];

      $ch = curl_init($url);
      // Setup request to send json via POST
      $input = $data;
      $payload = json_encode($input);
      // Attach encoded JSON string to the POST fields
      //curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);
      curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);

      // Set the content type to application/json
      curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'));

      // Return response instead of outputting
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

      // Execute the POST request
      $result = curl_exec($ch);

       //printr($result);

      $response = namespacedXMLToArray($result);
      curl_close($ch);
      return $response;

      // Close cURL resource

    }
    public function start_live(REQUEST $request){
        $status   = "0";
        $message  = "";
        $o_data   = [];
        $errors   = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'channel_id' => 'required',
            'broadcast_key'=>'required',
            'thumb_image'  => 'required|mimes:png,jpeg,jpg'
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        }else{
          $user_id = $this->validateAccesToken($request->access_token);
          $user_row = User::where(['id'=>$user_id])->get()->first();


          $channel_id = $request->channel_id;
          $channel_key = $request->broadcast_key;
          $zoom       = (int) $request->zoom;
          $br_width   = (string) $request->br_width;
          $br_height  = (string) $request->br_height;
          if(!empty($channel_id) && !empty($user_row) && !empty($channel_key) ) {
                $recordName                 = $channel_id;
                $instanceName               = "_definst_";
                $recorderState              = "Waiting for stream";
                $defaultRecorder            = true;
                $segmentationType           = "None";
                $outputPath                 = "/var/www/html/mrecordings";
                $baseFile                   = $channel_id.".mp4";
                $fileFormat                 = "MP4"; // or FLV
                $fileVersionDelegateName    = "com.wowza.wms.livestreamrecord.manager.StreamRecorderFileVersionDelegate";
                $fileTemplate               = "";//"${BaseFileName}_${RecordingStartTime}_${SegmentNumber}";
                $segmentDuration            = "900000";
                $segmentSize                = "10485760";
                $segmentSchedule            = "";
                $recordData                 = true;
                $startOnKeyFrame            = true;
                $splitOnTcDiscontinuity     = false;
                $option                     = "Version existing file";

                $moveFirstVideoFrameToZero  = true;
                $currentSize                = 0;
                $currentDuration            = 0;
                $recordingStartTime         = "";
                $w_input = [
                    'recorderName'      => $channel_id,
                    'instanceName'      => '_definst_',
                    'recorderState'     => 'Waiting for stream',
                    'defaultRecorder'   => true,
                    'segmentationType'  => 'None',
                    'outputPath'        => '/var/www/html/mrecordings',
                    'baseFile'          => $channel_id.'.mp4',
                    'fileFormat'        => 'MP4',
                    'fileVersionDelegateName'=>'com.wowza.wms.livestreamrecord.manager.StreamRecorderFileVersionDelegate',
                    'fileTemplate'      => "",
                    'segmentDuration'   => 900000,
                    'segmentSize'       => 10485760,
                    'segmentSchedule'   => "0 * * * * *",
                    'recordData'        => true,
                    'startOnKeyFrame'   => true,
                    'splitOnTcDiscontinuity'=> false,
                    'backBufferTime'    => 0,
                    'option'            => 'Version existing file',
                    'moveFirstVideoFrameToZero'=>false,
                    'currentSize'       => 0,
                    'currentDuration'   => 0,
                    'recordingStartTime'=> ""
                ];



                $obj_response = $this->sendRequestToWowza($w_input);
                //$obj_response=['success'=>"true"];
                if($obj_response){
                    if($obj_response['success']=="true"){
                        $post = new Stories();
                        $post->caption = '';
                        $post->user_id = $user_id;
                        $post->status  = 1;
                        $post->created_at =  gmdate('Y-m-d H:i:s');
                        $post->is_live = 1;
                        $post->live_url = '';
                        $post->channel_id = $channel_id;
                        $post->width    = $br_width;
                        $post->height   = $br_height;
                        $post->channel_key = $channel_key;

                        if($file = $request->file("thumb_image")){
                          $dir = config('global.upload_path')."/".config('global.post_image_upload_dir');
                          $file_name = time().uniqid().".".$file->getClientOriginalExtension();
                          $file->storeAs(config('global.post_image_upload_dir'),$file_name,config('global.upload_bucket'));
                          $post->path = $file_name;
                        }
                        $post->save();
                        if($post->id > 0){
                            $status = "1";
                            $message = "live started";
                            if( config('global.server_mode') == 'local'){
                              \Artisan::call('send_nottification:live_story '.$post->id);
                              \Artisan::call('firebase:save_live_story '.$post->id);
                            }else{
                              exec("php ".base_path()."/artisan send_nottification:live_story ".$post->id." > /dev/null 2>&1 & ");
                              exec("php ".base_path()."/artisan firebase:save_live_story ".$post->id." > /dev/null 2>&1 & ");
                              exec("php ".base_path()."/artisan wowza:download ".$post->id." > /dev/null 2>&1 & ");
                            }
                        }else{

                        }
                    }else{
                        $message = "Response faild from streeming engine";
                    }
                }else{
                    $message = "Unable to start recording";
                }

          }
          else{
              $message = "Sometheing went wrong in basic fetch data";
          }
        }
        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' => $o_data], 200);

    }
    public function stop_recording(REQUEST $request){
        $status   = "0";
        $message  = "";
        $o_data   = [];
        $errors   = [];

        $validator = Validator::make($request->all(), [
            'access_token' => 'required',
            'channel_id' => 'required'
        ]);

        if ($validator->fails()) {
            $status = "0";
            $message = "Validation error occured";
            $errors = $validator->messages();
        }else{
          $user_id = $this->validateAccesToken($request->access_token);
          $channel_id = $request->channel_id;
          $post = Stories::where(['channel_id'=>$channel_id])->get()->first();

           $url = $this->hostUrl."servers/".$this->default_server_name."/vhosts/".$this->v_hots."/applications/".$this->wowza_live_app."/instances/".$this->instance."/streamrecorders/".$channel_id."/actions/stopRecording";

           $ch = curl_init($url);

           curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
           curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PUT");
           //curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));

           $result = curl_exec($ch);
           $response = namespacedXMLToArray($result);
          curl_close($ch);
          $response=['success'=>"true"];
          if($response['success'] == "true"){
              $status = "1";
              $message = "Recording stoped for ".$channel_id;

              //for removing the item from story
              $story = Stories::find($post->id);
              $story->status = 0;
              $story->is_live = 2;
                $url = "http://moda.uksouth.cloudapp.azure.com/mrecordings/".$channel_id.".mp4";
                $contents = file_get_contents($url);
                $name = substr($url, strrpos($url, '/') + 1);
                if( \Storage::disk(config('global.upload_bucket'))->put(config('global.post_image_upload_dir').$name, $contents) ){
                    $story->live_url = $name;
                }
              $story->save();

              $story_data = Stories::where(['id'=>$post->id])->get()->first();
              $o_data = convert_all_elements_to_string($story_data);

              $fb_user_refrence = $this->database->getReference('StopLiveList/'.$channel_id.'/')->push(['stoped'=>gmdate('Y-m-d H:i:s')]);

              //printr($fb_user_refrence);

              if( config('global.server_mode') == 'local'){
                //\Artisan::call('wowza:download '.$post->id);
              }else{
                //exec("php ".base_path()."/artisan wowza:download ".$post->id." > /dev/null 2>&1 & ");
              }
          }else{
              $message = "Faild to stop recording";
          }
        }
        return response()->json(['status' => $status, 'error' => $errors, 'message' => $message, 'oData' => $o_data], 200);
    }
    public function start_live_test(REQUEST $request){
       $channel_id = $this->input->post('channel_id');
       $user_id    = (int) $this->input->post('user_id');

       $zoom       = (int) $this->input->post('zoom');
       $br_width   = (string) $this->input->post('br_width');
       $br_height  = (string) $this->input->post('br_height');
         $wowza_live_app = "moda-ll-stream";//"teyaar_live";
     $recordingServerUrl = "https://moda.uksouth.cloudapp.azure.com/";
        $settings = new \Com\Wowza\Entities\Application\Helpers\Settings();
            $settings->setHost("https://moda.uksouth.cloudapp.azure.com/");
            $settings->setUsername('moda');
            $settings->setPassword('moda@wowza@2022');

            // Connect to the server or deal with statistics NOTICE THE CAPS IN COM AND WOWZA
            // $server = new Com\Wowza\Server($setup);
            // $sf = new Com\Wowza\Statistics($setup);
            // $response = $sf->getServerStatistics($server);



            $sf = new \Com\Wowza\Recording($settings, $wowza_live_app);
            printr($sf);
    }
}
