<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class PrescribeMedicines extends Model
{
    use HasFactory;
    protected $table = 'prescribe_medicines';
    use SoftDeletes;
    protected $dates = ['deleted_at'];
    protected $fillable = ['doctor_id', 'user_id', 'title', 'detail', 'status', 'created_at', 'updated_at'];

    public function doctor()
    {
        return $this->belongsTo(VendorModel::class, 'doctor_id', 'id');
    }

    public function user()
    {
        return $this->belongsTo(VendorModel::class, 'user_id', 'id');
    }
}
