<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class ServiceRequest extends Model
{
    use HasFactory;

    protected $guarded = [];

    const WAITING_FOR_CONFIRMATION = '__WAITING_FOR_CONFIRMATION__';
    const CONFIRMED = '__CONFIRMED__';
    const ACCEPTED = '__ACCEPTED__';
    const REJECTED = '__REJECTED__';
    const WAIT_FOR_SERVICE_PROVIDER= '__WAIT_FOR_SERVICE_PROVIDER__';
    const ON_THE_WAY_TO_SITE = '__ON_THE_WAY_TO_SITE__';
    const WORK_IN_PROGRESS = '__WORK_IN_PROGRESS__';
    const FINISHED = '__FINISHED__';

    const Statuses = [
        self::WAITING_FOR_CONFIRMATION => 'Waiting for confirmation',
        self::CONFIRMED => 'Request Confirmed',
        self::REJECTED => 'Request Rejected',
        self::ACCEPTED => 'Offer Accepted',
        self::WAIT_FOR_SERVICE_PROVIDER => 'Wait for service provider',
        self::ON_THE_WAY_TO_SITE => 'On the way to site',
        self::WORK_IN_PROGRESS => 'Work in progress',
        self::FINISHED => 'Finished',
    ];

    public function user(){
        return $this->belongsTo('App\Models\User', 'user_id');
    }

    public function serviceRequestImages(){
        return $this->hasMany('App\Models\ServiceRequestImage', 'service_request_id');
    }

    function vendor(){
        return $this->belongsTo('App\Models\User', 'vendor_id');
    }
}
