<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Laravel\Sanctum\HasApiTokens;
use DB;

class VendorModel extends Model
{
    use HasFactory, HasApiTokens;
    protected $table = "users";
    public $timestamps = false;

    // protected $fillable = ['name', 'email', 'dial_code','phone','role','first_name','user_name','last_name','user_image',
    // 'password','country_id','state_id','city_id','area','vendor','store','previllege','created_at','updated_at','designation_id','active','dob'];

    protected $guarded = [];

    public function getLogoAttribute($value)
    {
        if($value)
        {
            return asset('storage/users/'.$value);
        }
        else
        {
            return asset('uploads/users/640167ef9ae74_1677813743.png');
        }
    }

    public function getUserImageAttribute($value)
    {
        if($value)
        {
            return asset('storage/users/'.$value);
        }
        else
        {
            return asset('uploads/users/640167ef9ae74_1677813743.png');
        }
    }

    public function getEducationalCertificatesAttribute($value)
    {
        $images = [];
        if($value)
        {
            $value = json_decode($value, 1);

            if ( is_array($value) ) {
                foreach ( $value as $in => $link) {
                    $images[$in] = asset('storage/dr_doc/'.$in);
                }
                return $images;
            }
        }

        return $images;
    }

    public function getMedicalLicenseAttribute($value)
    {
        if($value)
        {
            return asset('storage/dr_doc/'.$value);
        }
        else
        {
            return asset('uploads/users/640167ef9ae74_1677813743.png');
        }
    }

    public function getEmiratesIdAttribute($value)
    {
        if($value)
        {
            return asset('storage/dr_doc/'.$value);
        }
        else
        {
            return asset('uploads/users/640167ef9ae74_1677813743.png');
        }
    }

    public function vendordata() {
       return $this->hasMany(VendorDetailsModel::class,'user_id');
    }
    public function stores() {
        return $this->hasMany('App\Models\Stores', 'vendor_id', 'id'); 
    }

    public function total_rating(){
        return $this->hasMany(OrderModel::class, 'store_id', 'id');
    }

    public function is_favourite(){
        return $this->hasMany( StoreLikes::class, 'store_id', 'id');
    }

    /*public function getIsFavouriteAttribute($data){
        if ( !empty($data) )
            return "1";

        return "0";
    }*/

    public function getRatingAvgAttribute( $store_id ){
        $count_select = OrderModel::where(['store_id'=>$store_id])->where('store_rating','!=',null)->count('order_id');
        $sum_store_rating = OrderModel::where(['store_id'=>$store_id])->where('store_rating','!=',null)->sum('store_rating');

        $store_avg = 0;
        if ($count_select){
            $store_avg = ($count_select/$sum_store_rating);
            return $store_avg;
        }

        return 0;
    }

    function menu(){
        $this->hasOne(Menu::class, 'vendor_id', 'id');
    }
    public function user_location(){
        return $this->hasOne('App\Models\UserLocations', 'user_id', 'id');
    }
    public static function LevelOfEducation( $iLevel = 0 ){
        $aLevelEducation = array(
                    1 => "MBBS (MD)",
                    2 => "Bachelor",
                    3 => "Master",
                    4 => "PhD"
        );
        if ( isset ($aLevelEducation[$iLevel]) && $aLevelEducation[$iLevel] != "" ) {
            return $aLevelEducation[$iLevel];
        }
        return $aLevelEducation;
    }

    public function user_prescribe()
    {
        return $this->hasMany(PrescribeMedicines::class, 'user_id', 'id');
    }

    public function doctor_prescribe()
    {
        return $this->hasMany(PrescribeMedicines::class, 'doctor_id', 'id');
    }

}
