<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateTempUsersTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('temp_users', function (Blueprint $table) {
            $table->id();
            $table->string('name')->index('user_name')->nullable();
            $table->string('first_name')->index('first_name')->nullable();
            $table->string('last_name')->index('last_name')->nullable();
            $table->string('email')->index('user_email')->unique();
            $table->string('dial_code')->index('dial_code');
            $table->string('phone_number')->index('phone_number');
            $table->integer('phone_verified')->index('phone_verified')->default(0);
            $table->string('user_type')->default('user')->nullable();
            $table->string('device_type')->index('device_type')->nullable();
            $table->string('fcm_token')->index('fcm_token')->nullable();
            $table->string('device_token')->index('device_token')->nullable();
            $table->string('password')->index('user_password')->nullable();
            $table->integer('phone_otp')->index('phone_otp')->nullable();
            $table->integer('role')->default(2)->nullable();
            $table->integer('user_type_id')->default(0)->nullable();
            $table->integer('user_device_type')->nullable();
            $table->integer('user_device_token')->nullable();
            $table->string('access_token')->nullable();
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('temp_users');
    }
}
