@extends("admin.template.layout")

@section('header')
    <link href="https://cdn.jsdelivr.net/npm/select2@4.1.0-rc.0/dist/css/select2.min.css" rel="stylesheet" />
@stop


@section('content')
    <div class="card mb-5">
      
        <div class="card-body">
            <form method="post" action="{{ url('/admin/banner/update') }}" id="admin-form" enctype="multipart/form-data">
                @csrf
                <input type="hidden" name="id" value="{{$banner->id}}">
                <div class="row  d-flex justify-content-between align-items-center">
                    <div class="col-md-6 form-group">
                        <label>Title</label>
                        <input type="text" name="banner_title" class="form-control jqv-input" data-jqv-required="true" value="{{$banner->banner_title}}">
                    </div>

                    <div class="col-md-6 form-group">
                        <label>Description</label>
                        <input type="text" name="description" class="form-control jqv-input" value="{{$banner->description ?? ''}}"
                               data-parsley-required-message="description is required">
                    </div>

                    <div class="col-md-6 form-group">
                        <label>Any discount Flag</label>
                        <input type="text" name="discount_flag" class="form-control jqv-input" value="{{$banner->discount_flag ?? ''}}"
                               data-parsley-required-message="discount flag is required">
                    </div>

                    <div class="col-md-6 form-group">
                        <label>Banner Type</label>
                        <select name="banner_type" class="form-control">
                            <option <?= $banner->banner_type == 1 ? 'selected' : '' ?> value="1">App Banner</option>
                            <option <?= $banner->banner_type == 2 ? 'selected' : '' ?> value="2">App Slider</option>
                        </select>
                    </div>

                    <div class="col-md-6 form-group">
                        <label>Status</label>
                        <select name="active" class="form-control">
                            <option <?= $banner->active == 1 ? 'selected' : '' ?> value="1">Active</option>
                            <option <?= $banner->active == 0 ? 'selected' : '' ?> value="0">Inactive</option>
                        </select>
                    </div>
                    <div class="col-md-12 form-group" >
                        <img id="image-preview" style="width:192px; height:108px;" class="img-responsive mb-1"  data-image="<?php echo url(config('global.upload_path').config('global.banner_image_upload_dir').$banner->banner_image);?>" src="<?php echo url(config('global.upload_path').config('global.banner_image_upload_dir').$banner->banner_image);?>">
                    </div>
                    <div class="col-md-6 form-group">
                        <label>Upload Banner</label>
                        <div class="custom-file">
                            <input type="file" class="custom-file-input jqv-input" name="banner"
                                data-role="file-image" {{--data-width="1920" data-height="1079"--}} data-preview="image-preview" data-jqv-required="true" name="upload_image" id="banner">
                            <label class="custom-file-label" for="customFile">Choose file</label>
                        </div>
                        <small class="text-muted">
                            Upload Image With Dimension 1920X1079
                        </small>
                    </div>
                    
                 
                    <div class="col-md-12 text-center mt-3">
                        <button type="submit" class="btn btn-primary">Submit</button>
                    </div>
                </div>
            </form>
        </div>
    </div>
@stop

@section('script')
    <script>
        App.initFormView();
        $('body').off('submit', '#admin-form');
        $('body').on('submit', '#admin-form', function(e) {
            e.preventDefault();
            var $form = $(this);
            var formData = new FormData(this);
            $(".invalid-feedback").remove();

            App.loading(true);
            $form.find('button[type="submit"]')
                .text('Saving')
                .attr('disabled', true);

            $.ajax({
                type: "POST",
                enctype: 'multipart/form-data',
                url: $form.attr('action'),
                data: formData,
                processData: false,
                contentType: false,
                cache: false,
                dataType: 'json',
                timeout: 600000,
                success: function(res) {
                    App.loading(false);

                    if (res['status'] == 0) {
                        if (typeof res['errors'] !== 'undefined') {
                            var error_def = $.Deferred();
                            var error_index = 0;
                            jQuery.each(res['errors'], function(e_field, e_message) {
                                if (e_message != '') {
                                    $('[name="' + e_field + '"]').eq(0).addClass('is-invalid');
                                    $('<div class="invalid-feedback">' + e_message + '</div>')
                                        .insertAfter($('[name="' + e_field + '"]').eq(0));
                                    if (error_index == 0) {
                                        error_def.resolve();
                                    }
                                    error_index++;
                                }
                            });
                            error_def.done(function() {
                                var error = $form.find('.is-invalid').eq(0);
                                $('html, body').animate({
                                    scrollTop: (error.offset().top - 100),
                                }, 500);
                            });
                        } else {
                            var m = res['message'];
                            App.alert(m, 'Oops!');
                        }
                    } else {
                        App.alert(res['message']);
                        setTimeout(function() {
                            window.location.href = App.siteUrl('/admin/banners');
                        }, 1500);
                    }

                    $form.find('button[type="submit"]')
                        .text('Save')
                        .attr('disabled', false);
                },
                error: function(e) {
                    App.loading(false);
                    $form.find('button[type="submit"]')
                        .text('Save')
                        .attr('disabled', false);
                    App.alert(e.responseText, 'Oops!');
                }
            });
        });


    </script>
@stop
