@extends("admin.template.layout")

@section("header")
    <link rel="stylesheet" type="text/css" href="{{asset('')}}admin-assets/plugins/table/datatable/datatables.css">
    <link rel="stylesheet" type="text/css" href="{{asset('')}}admin-assets/plugins/table/datatable/custom_dt_customer.css">
@stop


@section("content")

<style>
    #example2_info{
        display: none
    }
</style>
<div class="card mb-5">
    @if(check_permission('prescribe_medicines','Create'))
    <div class="card-header"><a href="{{url('admin/prescribe_medicines/create?dr='.$dr_id.'&ur='.$user_id)}}" class="btn-custom btn mr-2 mt-2 mb-2"><i class="fa-solid fa-plus"></i> Create Prescription</a></div>
    @endif
    <div class="card-body">
        <div class="table-responsive">
        <table class="table table-condensed table-striped" id="example2">
            <thead>
                <tr>
                <th>#</th>
                <th>Patient Details</th>
                <th>Doctor Details</th>
                <th>Prescription Title</th>
                <th>Updated</th>
                <th>Action</th>
                </tr>
            </thead>
            <tbody>
                <?php $i=0; ?>
                @foreach($datamain as $datarow) 
                    <?php $i++ ?>
                    <tr>
                        <td>{{$i}}</td>
                        <td>
                            <div class="d-flex align-items-center">
                                <span>
                                    @if(!empty($datarow->user->user_image))
                                    <img src="{{asset($datarow->user->user_image)}}" style="width:60px;height:60px;object-fit:cover;" class="rounded-circle" alt="User">
                                    @endif
                                </span>
                                <span class="ml-3">
                                    <a href="#" class="yellow-color">{{$datarow->user->name}}</a>
                                    <div>{{$datarow->user->email}}</div>
                                    <div>{{'+'.str_replace("+","",$datarow->user->dial_code.' '.$datarow->user->phone)}}</div>
                                </span>
                            </div>
                        </td>
                        <td>
                            <div class="d-flex align-items-center">
                                <span>
                                    @if(!empty($datarow->doctor->user_image))
                                        <img src="{{asset($datarow->doctor->user_image)}}" style="width:60px;height:60px;object-fit:cover;" class="rounded-circle" alt="doctor">
                                    @endif
                                </span>
                                <span class="ml-3">
                                    <a href="#" class="yellow-color">{{$datarow->doctor->name}}</a>
                                    <div>{{$datarow->doctor->email}}</div>
                                    <div>{{'+'.str_replace("+","",$datarow->doctor->dial_code.' '.$datarow->doctor->phone)}}</div>
                                </span>
                            </div>
                        </td>
                        <!-- <td><img src="{{asset($datarow->logo)}}" style="width:60px;height:60px;object-fit:cover;" class="rounded-circle" alt="User"></td>
                        <td>{{$datarow->first_name}} {{$datarow->last_name}}</td>
                        <td>{{$datarow->email}}</td>
                        <td>+{{$datarow->dial_code}} {{$datarow->phone}}</td> -->
                       <!--  <td>
                            <label class="switch s-icons s-outline  s-outline-warning  mb-2 mt-2 mr-2">
                                        <input type="checkbox" class="change_status" data-id="{{ $datarow->id }}"
                                            data-url="{{ url('admin/doctors/verify') }}"
                                            @if ($datarow->verified) checked @endif>
                                        <span class="slider round"></span>
                            </label>
                        </td> -->
                        {{--<td>
                            <label class="switch s-icons s-outline  s-outline-warning mb-2 mt-2 mr-2">
                                        <input type="checkbox" class="change_status" data-id="{{ $datarow->id }}"
                                            data-url="{{ url('admin/customers/change_status') }}"
                                            @if ($datarow->active) checked @endif>
                                        <span class="slider round"></span>
                            </label>
                        </td>--}}
                        <td>{{ $datarow->title }}</td>
                        <td>{{web_date_in_timezone($datarow->updated_at,'d-M-Y h:i A')}}</td>
                        <td class="text-center">
                            <div class="dropdown custom-dropdown">
                                <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink7" data-toggle="dropdown" aria-haspopup="true" aria-expanded="true">
                                    <i class="flaticon-dot-three"></i>
                                </a>

                                <div class="dropdown-menu" aria-labelledby="dropdownMenuLink7">
                                    @if(check_permission('prescribe_medicines','Edit'))
                                    <a class="dropdown-item" href="{{url('admin/prescribe_medicines/'.$datarow->id.'/edit')}}"><i class="flaticon-pencil-1"></i> Edit</a>
                                    @endif

                                    @if(check_permission('prescribe_medicines','View'))
                                        <a class="dropdown-item" href="{{url('admin/prescribe_medicines/'.$datarow->id)}}"><i class="flaticon-view"></i> View </a>
                                    @endif

                                    @if(check_permission('doctors','ChangePassword'))
                                    {{--<a class="dropdown-item" userid="{{$datarow->id}}" data-role="change_password" ><i class="flaticon-plus"></i> Change Password</a>--}}
                                    @endif

                                    @if(check_permission('prescribe_medicines','View'))
                                            <a class="dropdown-item" href="{{url('admin/prescribe-pdf/'.$datarow->id)}}"><i class="flaticon-pencil-1"></i> Downlaod </a>
                                    @endif

                                    @if(check_permission('prescribe_medicines','Delete'))
                                    <a class="dropdown-item" data-role="unlink"
                                    data-message="Do you want to remove this Vendor?"
                                    href="{{ url('admin/prescribe_medicines/' . $datarow->id) }}"><i
                                        class="flaticon-delete-1"></i> Delete</a>
                                    @endif

                                    @if(check_permission('customers','BlockedUsers'))
                                    {{--<a class="dropdown-item" href="{{url('admin/customers/blocked_users?customer='.$datarow->id)}}"><i class="flaticon-close"></i> Blocked Users</a> --}}
                                    @endif 

                                    @if(check_permission('customers','ReportedUsers'))
                                    {{--<a class="dropdown-item" href="{{url('admin/customers/reported_users?customer='.$datarow->id)}}"><i class="flaticon-close"></i> Reported Users</a>--}}
                                    @endif

                                    @if(check_permission('orders','View'))
                                    {{--<a class="dropdown-item" href="{{url('admin/orders?customer='.$datarow->id)}}"><i class="flaticon-view"></i> Orders</a>  --}}
                                    @endif
                                    
                                </div>
                            </div>
                        </td>
                        
                    </tr>
                @endforeach
            </tbody>
        </table>
        </div>
    </div>
</div>
@stop

@section("script")
<script src="{{asset('')}}admin-assets/plugins/table/datatable/datatables.js"></script>
<script>
$('#example2').DataTable({
      "paging": true,
      "searching": true,
      "ordering": true,
      "info": true,
      "autoWidth": true,
      "responsive": true,
    });
    </script>
    <script>
        App.initFormView();
        $('body').off('submit', '#admin-form');
        $('body').on('submit', '#admin-form', function(e) {
            e.preventDefault();
            var $form = $(this);
            var formData = new FormData(this);
            $(".invalid-feedback").remove();

            App.loading(true);
            $form.find('button[type="submit"]')
                .text('Saving')
                .attr('disabled', true);

            $.ajax({
                type: "POST",
                enctype: 'multipart/form-data',
                url: $form.attr('action'),
                data: formData,
                processData: false,
                contentType: false,
                cache: false,
                dataType: 'json',
                timeout: 600000,
                success: function(res) {
                    App.loading(false);

                    if (res['status'] == 0) {
                        if (typeof res['errors'] !== 'undefined') {
                            var error_def = $.Deferred();
                            var error_index = 0;
                            jQuery.each(res['errors'], function(e_field, e_message) {
                                if (e_message != '') {
                                    $('[name="' + e_field + '"]').eq(0).addClass('is-invalid');
                                    $('<div class="invalid-feedback">' + e_message + '</div>')
                                        .insertAfter($('[name="' + e_field + '"]').eq(0));
                                    if (error_index == 0) {
                                        error_def.resolve();
                                    }
                                    error_index++;
                                }
                            });
                            error_def.done(function() {
                                var error = $form.find('.is-invalid').eq(0);
                                $('html, body').animate({
                                    scrollTop: (error.offset().top - 100),
                                }, 500);
                            });
                        } else {
                            var m = res['message'];
                            App.alert(m, 'Oops!');
                        }
                    } else {
                        App.alert(res['message']);
                        setTimeout(function() {
                            window.location.href = App.siteUrl('/admin/prescribe_medicines');
                        }, 1500);
                    }

                    $form.find('button[type="submit"]')
                        .text('Save')
                        .attr('disabled', false);
                },
                error: function(e) {
                    App.loading(false);
                    $form.find('button[type="submit"]')
                        .text('Save')
                        .attr('disabled', false);
                    App.alert(e.responseText, 'Oops!');
                }
            });
        });


    </script>
@stop