@extends('doctor.template.layout')

@section('content')
@if(!empty($datamain->vendordatils))
@php
// $vendor = $datamain->vendordatils;
$bankdata = $datamain->bankdetails;
@endphp
@endif
<div class="mb-5">
    <style>
    #parsley-id-15,
    #parsley-id-23 {
        bottom: auto;
    }

    #parsley-id-33 {
        bottom: -10px
    }

    .parsley-errors-list>.parsley-pattern {
        margin-top: 10px;
    }
    </style>

    <meta name="csrf-token" content="{{ csrf_token() }}" />

    <form method="post" id="admin-form" action="{{ url('doctor/doctors') }}" enctype="multipart/form-data"
        data-parsley-validate="true">
        <input type="hidden" name="id" value="{{ $id }}">
        @csrf()
        <div class="">
            <div class="card mb-2">
                <div class="card-body">
                    <div class="row">
                        <div class="col-sm-4 col-xs-12">
                            <div class="form-group">
                                <label>Full Name <span style="color:red;">*<span></span></span></label>
                                <input type="text" class="form-control" data-jqv-maxlength="100" name="name"
                                    value="{{empty($datamain->name) ? '': $datamain->name}}" required
                                    data-parsley-required-message="Enter Full Name">
                            </div>
                        </div>
                        <div class="col-sm-4 col-xs-12">
                            <div class="form-group">
                                <label>Email <span style="color:red;">*<span></span></span></label>
                                <input type="email" class="form-control" name="email" data-jqv-maxlength="50"
                                    value="{{empty($datamain->email) ? '': $datamain->email}}" required
                                    data-parsley-required-message="Enter Email" autocomplete="off"
                                    autocomplete="new-password">

                            </div>
                        </div>
                        <div class="col-sm-4 col-xs-12">
                            <div class="form-group">
                                <label>Mobile<b class="text-danger">*</b></label>
                                <div class="input-group">
                                    <div class="input-group-prepend">
                                        <select class="form-control" name="dial_code" required
                                            data-parsley-required-message="">
                                            <option value="">code</option>
                                            @foreach ($countries as $cnt)
                                            <option @if($id) @if($datamain->dial_code==$cnt->dial_code) selected @endif
                                                @endif value="{{ $cnt->dial_code }}">+{{ $cnt->dial_code }}</option>
                                            @endforeach;
                                        </select>
                                    </div>
                                    <input type="number" class="form-control" name="phone"
                                        value="{{empty($datamain->phone) ? '': $datamain->phone}}"
                                        data-jqv-required="true" required
                                        data-parsley-required-message="Enter Phone number" data-parsley-type="digits"
                                        data-parsley-minlength="5" data-parsley-maxlength="12"
                                        data-parsley-trigger="keyup">
                                </div>
                                <span id="mob_err"></span>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="card mb-2">
                <div class="card-body">
                    <div class="row">

                        <div class="col-sm-4 col-xs-12">
                            <div class="form-group">
                                <label>Password </label>
                                <div class="input-group mb-3">
                                    <input type="password" class="form-control" id="password" name="password"
                                        data-jqv-maxlength="50" value="" data-parsley-minlength="8" autocomplete="off"
                                        data-parsley-errors-container="#p1_err" autocomplete="new-password">
                                    <div class="input-group-append" style="cursor: pointer">
                                        <span class="input-group-text" onclick="password_show_hide();">
                                            <i class="fas fa-eye" id="show_eye"></i>
                                            <i class="fas fa-eye-slash d-none" id="hide_eye"></i>
                                        </span>
                                    </div>
                                </div>
                                <span id="p1_err"></span>
                            </div>
                        </div>

                        <div class="col-sm-4 col-xs-12">
                            <div class="form-group">
                                <label>Confirm Password </label>
                                <div class="input-group mb-3">
                                    <input type="password" class="form-control" name="confirm_password"
                                        data-jqv-maxlength="50" value="" data-parsley-minlength="8"
                                        data-parsley-equalto="#password" autocomplete="off"
                                        data-parsley-required-message="Please re-enter your new password."
                                        data-parsley-required-if="#password" id="password2"
                                        data-parsley-errors-container="#p2_err" autocomplete="new-password">
                                    <div class="input-group-append" style="cursor: pointer">
                                        <span class="input-group-text" onclick="password_show_hide2();">
                                            <i class="fas fa-eye" id="show_eye2"></i>
                                            <i class="fas fa-eye-slash d-none" id="hide_eye2"></i>
                                        </span>
                                    </div>
                                </div>
                                <span id="p2_err"></span>
                            </div>
                        </div>

                        <div class="col-sm-4 col-xs-12">
                            <div class="form-group">
                                <label>Gender </label>
                                <div class="input-group mb-3">
                                    <select name="gender" class="form-control">
                                        <option value="1" @if (isset ( $datamain->gender ) && $datamain->gender == 1 ) selected @endif> Male </option>
                                        <option value="2" @if (isset ( $datamain->gender ) && $datamain->gender == 2 ) selected @endif> Female </option>
                                        <option value="3" @if (isset ( $datamain->gender ) && $datamain->gender == 3 ) selected @endif> Other </option>
                                    </select>
                                </div>
                                <span id="p2_err"></span>
                            </div>
                        </div>

                        <div class="col-sm-4 col-xs-12">
                            <div class="form-group">
                                <label>Date of Birth </label>
                                <div class="input-group mb-3">
                                    <input type="date" class="form-control" id="dob" name="dob" required
                                           data-parsley-required-message="add date of birth"
                                           value="{{empty($datamain->dob) ? '': $datamain->dob}}" autocomplete="off"
                                           data-parsley-errors-container="#p1_err" autocomplete="dob">
                                </div>
                                <span id="p2_err"></span>
                            </div>
                        </div>

                        <div class="col-sm-4 col-xs-12">
                            <div class="form-group">
                                <label>Education</label>
                                <div class="input-group mb-3">
                                    <select name="level_education_id" class="form-control select2" required
                                            data-parsley-required-message="Select education" data-role="level_education_id" id="level_education_id" data-input-state="level_education_id">
                                        <option value="">Select</option>
                                        @foreach ($level_education as $key => $edu)
                                            <option <?php if(!empty($datamain->level_education_id)) { ?> {{$datamain->level_education_id == $key ? 'selected' : '' }} <?php } ?> value="{{ $key }}">
                                                {{ $edu }}</option>
                                        @endforeach;
                                    </select>
                                </div>
                                <span id="p2_err"></span>
                            </div>
                        </div>

                        {{--<div class="col-sm-4 col-xs-12">
                            <div class="form-group">
                                <label>Education</label>
                                <div class="input-group mb-3">
                                    <input type="text" class="form-control" id="education" name="education" required
                                           data-parsley-required-message="add education"
                                           value="{{empty($datamain->education) ? '': $datamain->education}}" autocomplete="off"
                                           data-parsley-errors-container="#p1_err" autocomplete="education">
                                </div>
                                <span id="p2_err"></span>
                            </div>
                        </div>--}}

                        <div class="col-sm-4 col-xs-12">
                            <div class="form-group">
                                <label>Licensed Speciality</label>
                                <div class="input-group mb-3">
                                    <input type="text" class="form-control" id="licensed_specialty" name="licensed_specialty" required
                                           data-parsley-required-message="licensed speciality"
                                           value="{{empty($datamain->licensed_speciality) ? '': $datamain->licensed_speciality}}" autocomplete="off"
                                           data-parsley-errors-container="#p1_err" autocomplete="licensed_specialty">
                                </div>
                                <span id="p2_err"></span>
                            </div>
                        </div>

                        <div class="col-sm-4 col-xs-12">
                            <div class="form-group">
                                <label>Medical License Number</label>
                                <div class="input-group mb-3">
                                    <input type="text" class="form-control" id="medical_license_number" name="medical_license_number" required
                                           data-parsley-required-message="medical license number"
                                           value="{{empty($datamain->medical_license_number) ? '': $datamain->medical_license_number}}" autocomplete="off"
                                           data-parsley-errors-container="#p1_err" autocomplete="medical_license_number">
                                </div>
                                <span id="p2_err"></span>
                            </div>
                        </div>

                        <div class="col-sm-4 col-xs-12">
                            <div class="form-group">
                                <label>Nationality</label>
                                <div class="input-group mb-3">
                                    <select name="nationality_id" class="form-control select2" required
                                            data-parsley-required-message="Select Nationality" data-role="nationality_id" id="nationality_id" data-input-state="nationality_id">
                                        <option value="">Select</option>
                                        @foreach ($countries as $cnt)
                                            <option <?php if(!empty($datamain->nationality)) { ?> {{$datamain->nationality == $cnt->id ? 'selected' : '' }} <?php } ?> value="{{ $cnt->id }}">
                                                {{ $cnt->name }}</option>
                                        @endforeach;
                                    </select>
                                </div>
                                <span id="p2_err"></span>
                            </div>
                        </div>

                    </div>
                </div>
            </div>

            <div class="card mb-2" style="display: none;">
                <div class="card-body">
                    <div class="row">
                        <div class="col-sm-4 col-xs-12">
                            <div class="form-group">
                                <label>Account No <span style="color:red;">*<span></span></span></label>
                                <input type="text" class="form-control" data-jqv-maxlength="100" name="account_no"
                                    value="{{empty($datamain->bankdetails->account_no) ? '': $datamain->bankdetails->account_no}}">
                            </div>
                        </div>
                        <div class="col-sm-4 col-xs-12">
                            <div class="form-group">
                                <label>Bank Name <span style="color:red;">*<span></span></span></label>
                                <input type="text" class="form-control" data-jqv-maxlength="100" name="bank_name"
                                    value="{{empty($datamain->bankdetails->bank_name) ? '': $datamain->bankdetails->bank_name}}">
                            </div>
                        </div>
                        <div class="col-sm-4 col-xs-12">
                            <div class="form-group">
                                <label>IBAN Code <span style="color:red;">*<span></span></span></label>
                                <input type="text" class="form-control" data-jqv-maxlength="100" name="iban_code"
                                    value="{{empty($datamain->bankdetails->iban_code) ? '': $datamain->bankdetails->iban_code}}">
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="card mb-2">
                <div class="row card-body">

                    <div class="col-sm-4 col-xs-4">
                        <div class="form-group d-flex align-items-center">
                            <div>
                                <label>Upload Profile Picture (gif,jpg,png,jpeg) <span
                                            style="color:red;">*<span></span></span></label>
                                <input type="file" class="form-control jqv-input" name="logo" data-role="file-image"
                                       data-preview="logo-preview" value="" @if(empty($id)) required
                                       data-parsley-required-message="image is required" @endif
                                       data-parsley-imagedimensions="200x200" data-parsley-trigger="change">
                                <p class="text-muted mt-2">Allowed Dim 200x200(px)</p>
                            </div>
                            <img id="logo-preview" class="img-thumbnail w-50"
                                 style="margin-left: 5px; height:75px; width:75px !important;"
                                 src="{{empty($datamain->user_image) ? asset('admin-assets/assets/img/logo.png'): $datamain->user_image}}">
                        </div>
                    </div>

                    <div class="col-sm-4 col-xs-4">
                        <div class="form-group d-flex align-items-center">
                            <div>
                                <label>Upload Professional/Educational Certificates (gif,jpg,png,jpeg)<span
                                        style="color:red;">*<span></span></span></label>
                                <input type="file" multiple class="form-control jqv-input" name="professional_educational_cert[]" data-role="file-image"
                                    data-preview="logo-preview1" value="" @if(empty($id)) required
                                    data-parsley-required-message="Certificates are required" @endif>
                            </div>
                        </div>
                    </div>

                    <div class="col-sm-4 col-xs-4">
                        <div class="form-group d-flex align-items-center">
                            <div>
                                <label>Upload Medical License (gif,jpg,png,jpeg) <span
                                            style="color:red;">*<span></span></span></label>
                                <input type="file" class="form-control jqv-input" name="upload_medical_license" data-role="file-image"
                                       data-preview="logo-preview2" value="" @if(empty($id)) required
                                       data-parsley-required-message="medical license is required" @endif
                                       data-parsley-trigger="change">
                            </div>
                            <img id="logo-preview2" class="img-thumbnail w-50"
                                 style="margin-left: 5px; height:75px; width:75px !important;"
                                 src="{{$datamain->medical_license ?? asset('admin-assets/assets/img/logo.png') }}">
                        </div>
                    </div>

                    <div class="col-sm-4 col-xs-4">
                        <div class="form-group d-flex align-items-center">
                            <div>
                                <label>Upload Emirates ID (gif,jpg,png,jpeg) <span
                                            style="color:red;">*<span></span></span></label>
                                <input type="file" class="form-control jqv-input" name="emirates_id" data-role="file-image"
                                       data-preview="logo-preview3" value="" @if(empty($id)) required
                                       data-parsley-required-message="Emirates ID is required" @endif
                                       data-parsley-trigger="change">
                            </div>
                            <img id="logo-preview3" class="img-thumbnail w-50"
                                 style="margin-left: 5px; height:75px; width:75px !important;"
                                 src="{{$datamain->emirates_id ?? asset('admin-assets/assets/img/logo.png') }}">
                        </div>
                    </div>

                </div>

                <div class="col-sm-12 col-xs-12">
                    <div class="form-group align-items-center">
                        <div class="col-sm-12 row">
                            <label>Professional/Educational Certificates</label>
                        </div>
                        <div class="col-sm-12 row">
                        @if( isset ( $datamain->educational_certificates ) && count ( $datamain->educational_certificates ) > 0 )

                            @foreach($datamain->educational_certificates as $key_name => $link)
                                    <div class="uploaded-prev-imd">
                                        <img src="{{$link}}" alt="" width="100" height="100" />
                                        <div style="cursor:pointer;" class="del-product-img" data-role="product-img-trash"  data-image-file="{{$key_name}}"><i class="far fa-trash-alt"></i> Delete</div>
                                    </div>

                                    {{--<img id="logo-preview1" class="img-thumbnail w-50"
                                     style="margin-left: 5px; height:75px; width:75px !important;"
                                     src="{{$link}}">
                                    <a href="">Delete</a>--}}
                            @endforeach
                        @else
                            <img id="logo-preview1" class="img-thumbnail w-50"
                                 style="margin-left: 5px; height:75px; width:75px !important;"
                                 src="{{asset('admin-assets/assets/img/logo.png') }}">
                        @endif
                        </div>
                    </div>
                </div>

                <div class="row ">
                    <div class="col-sm-4 col-xs-12 other_docs m-3" id="certificate_product_registration_div">
                        <div class="form-group">
                            <button type="submit" class="btn btn-primary">Submit</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
</div>
</form>
</div>
@stop

@section('script')
<script>
App.initFormView();
$('body').off('submit', '#admin-form');
$('body').on('submit', '#admin-form', function(e) {
    e.preventDefault();
    $(".invalid-feedback").remove();
    var $form = $(this);
    var formData = new FormData(this);

    App.loading(true);
    $form.find('button[type="submit"]')
        .text('Saving')
        .attr('disabled', true);

    $.ajax({
        type: "POST",
        enctype: 'multipart/form-data',
        url: $form.attr('action'),
        data: formData,
        processData: false,
        contentType: false,
        cache: false,
        dataType: 'json',
        timeout: 600000,
        success: function(res) {
            App.loading(false);

            if (res['status'] == 0) {
                if (typeof res['errors'] !== 'undefined') {
                    var error_def = $.Deferred();
                    var error_index = 0;
                    jQuery.each(res['errors'], function(e_field, e_message) {
                        if (e_message != '') {
                            $('[name="' + e_field + '"]').eq(0).addClass('is-invalid');
                            $('<div class="invalid-feedback">' + e_message + '</div>')
                                .insertAfter($('[name="' + e_field + '"]').eq(0));
                            if (error_index == 0) {
                                error_def.resolve();
                            }
                            error_index++;
                        }
                    });
                    error_def.done(function() {
                        var error = $form.find('.is-invalid').eq(0);
                        $('html, body').animate({
                            scrollTop: (error.offset().top - 100),
                        }, 500);
                    });
                } else {
                    var m = res['message'];
                    App.alert(m, 'Oops!');
                }
            } else {
                App.alert(res['message']);
                setTimeout(function() {
                    window.location.href = App.siteUrl('/doctor/dashboard');
                }, 1500);
            }

            $form.find('button[type="submit"]')
                .text('Save')
                .attr('disabled', false);
        },
        error: function(e) {
            App.loading(false);
            $form.find('button[type="submit"]')
                .text('Save')
                .attr('disabled', false);
            App.alert(e.responseText, 'Oops!');
        }
    });
});

function password_show_hide() {
    var x = document.getElementById("password");
    var show_eye = document.getElementById("show_eye");
    var hide_eye = document.getElementById("hide_eye");
    hide_eye.classList.remove("d-none");
    if (x.type === "password") {
        x.type = "text";
        show_eye.style.display = "none";
        hide_eye.style.display = "block";
    } else {
        x.type = "password";
        show_eye.style.display = "block";
        hide_eye.style.display = "none";
    }
}

function password_show_hide2() {
    var x2 = document.getElementById("password2");
    var show_eye2 = document.getElementById("show_eye2");
    var hide_eye2 = document.getElementById("hide_eye2");
    hide_eye2.classList.remove("d-none");
    if (x2.type === "password") {
        x2.type = "text";
        show_eye2.style.display = "none";
        hide_eye2.style.display = "block";
    } else {
        x2.type = "password";
        show_eye2.style.display = "block";
        hide_eye2.style.display = "none";
    }
}

$(document).on('click','.del-product-img',function(){
    var image = $(this).attr('data-image-file');
    var $imgList = $(this).closest('div.upload-img-product-items');
    var $target = $(this).closest('div.uploaded-prev-imd');
    var dr_id = $('[name="id"]').val();

    if(image!="") {
        $.ajax({
            type: "POST",
            headers: {
                'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
            },
            enctype: 'multipart/form-data',
            url: '{{ url("doctor/doctors/removeEducationalCertificate")}}',
            data: { 'image': image, 'dr_id':dr_id},
            dataType: 'json',
            success: function(data) {
                if ( data['status'] == 0 ) {
                    var msg = data['message']||'Unable to remove attribute. Please try again later.';
                    App.alert([msg, 'warning']);
                } else {
                    App.alert(['Done! Image removed successfully.']);

                    $(this).parent().find('.uploaded-prev-imd').remove();
                    $target.remove();

                }
            }
        })
    }else {

        $target.remove();
        $(this).parent().find('.uploaded-prev-imd').remove();
    }
})

</script>

@stop