@extends('doctor.template.layout')

@section('content')

<div class="mb-5">
    <style>
    #parsley-id-15,
    #parsley-id-23 {
        bottom: auto;
    }

    #parsley-id-33 {
        bottom: -10px
    }

    .parsley-errors-list>.parsley-pattern {
        margin-top: 10px;
    }
    </style>

    <meta name="csrf-token" content="{{ csrf_token() }}" />

    <form method="post" id="admin-form" action="{{ url('doctor/prescribe_medicines') }}" enctype="multipart/form-data"
        data-parsley-validate="true">
        <input type="hidden" name="id" value="{{ $id ?? '' }}">
        @csrf()
        <div class="">
            <div class="card mb-2">
                <div class="card-body">
                    <div class="row">

                        <div class="col-sm-6 col-xs-12">
                            <div class="form-group">
                                <label>Doctor</label>
                                <div class="input-group mb-3">

                                    @if ( ! isset ( $dr_id ) || $dr_id <= 0 )
                                        <select name="doctor" class="form-control select2" required
                                                data-parsley-required-message="Select doctor" data-role="doctor" id="doctor" data-input-state="doctor">
                                            <option value="">Select</option>
                                            @foreach ($doctor as $key => $dr)
                                                <option <?php if(!empty($datamain->doctor_id)) { ?> {{$datamain->doctor_id == $dr->id ? 'selected' : '' }} <?php } ?> value="{{ $dr->id }}">
                                                    {{ $dr->name }}</option>
                                            @endforeach;
                                        </select>
                                    @else
                                        <span>{{$dr_name ?? ''}}</span>
                                        <input type="hidden" name="doctor" value="{{$dr_id ?? 0}}">
                                    @endif

                                </div>
                                <span id="p2_err"></span>
                            </div>
                        </div>

                        <div class="col-sm-6 col-xs-12">
                            <div class="form-group">
                                <label>Patient</label>
                                <div class="input-group mb-3">
                                    @if ( ! isset ( $user_id ) || $user_id <= 0 )
                                    <select name="user" class="form-control select2" required
                                            data-parsley-required-message="Select user" data-role="user" id="user" data-input-state="user">
                                        <option value="">Select</option>
                                        @foreach ($user as $key => $u)
                                            <option <?php if(!empty($datamain->user_id)) { ?> {{$datamain->user_id == $u->id ? 'selected' : '' }} <?php } ?> value="{{ $u->id }}">
                                                {{ $u->name }}</option>
                                        @endforeach;
                                    </select>
                                        @else
                                        <span>{{$user_name ?? ''}}</span>
                                        <input type="hidden" name="user" value="{{$user_id ?? 0}}">
                                    @endif
                                </div>
                                <span id="p2_err"></span>
                            </div>
                        </div>

                    </div>
                </div>
            </div>

            <div class="card mb-2">
                <div class="card-body">
                    <div class="row">

                        <div class="col-sm-12 col-xs-12">
                            <div class="form-group">
                                <label>Prescription Title <span style="color:red;">*<span></span></span></label>
                                <input type="text" class="form-control" data-jqv-maxlength="100" name="title"
                                       value="{{empty($datamain->title) ? '': $datamain->title}}" required
                                       data-parsley-required-message="Enter Prescribe Medicines">
                            </div>
                        </div>

                        <div class="col-sm-12 col-xs-12">
                            <div class="form-group">
                                <label>Prescription Detail <span style="color:red;">*<span></span></span></label>

                                <textarea rows="5" name="detail" class="form-control" required data-parsley-required-message="Enter Prescribe Detail">{{empty($datamain->detail) ? '': $datamain->detail}}</textarea>

                            </div>
                        </div>

                    </div>
                </div>
            </div>

            <div class="card mb-2">
                <div class="row ">
                    <div class="col-sm-4 col-xs-12 other_docs m-3" id="certificate_product_registration_div">
                        <div class="form-group">
                            <button type="submit" class="btn btn-primary">Submit</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
</div>
</form>
</div>
@stop

@section('script')
<script>
App.initFormView();
$('body').off('submit', '#admin-form');
$('body').on('submit', '#admin-form', function(e) {
    e.preventDefault();
    $(".invalid-feedback").remove();
    var $form = $(this);
    var formData = new FormData(this);

    App.loading(true);
    $form.find('button[type="submit"]')
        .text('Saving')
        .attr('disabled', true);

    $.ajax({
        type: "POST",
        enctype: 'multipart/form-data',
        url: $form.attr('action'),
        data: formData,
        processData: false,
        contentType: false,
        cache: false,
        dataType: 'json',
        timeout: 600000,
        success: function(res) {
            App.loading(false);

            if (res['status'] == 0) {
                if (typeof res['errors'] !== 'undefined') {
                    var error_def = $.Deferred();
                    var error_index = 0;
                    jQuery.each(res['errors'], function(e_field, e_message) {
                        if (e_message != '') {
                            $('[name="' + e_field + '"]').eq(0).addClass('is-invalid');
                            $('<div class="invalid-feedback">' + e_message + '</div>')
                                .insertAfter($('[name="' + e_field + '"]').eq(0));
                            if (error_index == 0) {
                                error_def.resolve();
                            }
                            error_index++;
                        }
                    });
                    error_def.done(function() {
                        var error = $form.find('.is-invalid').eq(0);
                        $('html, body').animate({
                            scrollTop: (error.offset().top - 100),
                        }, 500);
                    });
                } else {
                    var m = res['message'];
                    App.alert(m, 'Oops!');
                }
            } else {
                App.alert(res['message']);
                setTimeout(function() {
                    window.location.href = App.siteUrl('/doctor/prescribe_medicines');
                }, 1500);
            }

            $form.find('button[type="submit"]')
                .text('Save')
                .attr('disabled', false);
        },
        error: function(e) {
            App.loading(false);
            $form.find('button[type="submit"]')
                .text('Save')
                .attr('disabled', false);
            App.alert(e.responseText, 'Oops!');
        }
    });
});

function password_show_hide() {
    var x = document.getElementById("password");
    var show_eye = document.getElementById("show_eye");
    var hide_eye = document.getElementById("hide_eye");
    hide_eye.classList.remove("d-none");
    if (x.type === "password") {
        x.type = "text";
        show_eye.style.display = "none";
        hide_eye.style.display = "block";
    } else {
        x.type = "password";
        show_eye.style.display = "block";
        hide_eye.style.display = "none";
    }
}

function password_show_hide2() {
    var x2 = document.getElementById("password2");
    var show_eye2 = document.getElementById("show_eye2");
    var hide_eye2 = document.getElementById("hide_eye2");
    hide_eye2.classList.remove("d-none");
    if (x2.type === "password") {
        x2.type = "text";
        show_eye2.style.display = "none";
        hide_eye2.style.display = "block";
    } else {
        x2.type = "password";
        show_eye2.style.display = "block";
        hide_eye2.style.display = "none";
    }
}

$(document).on('click','.del-product-img',function(){
    var image = $(this).attr('data-image-file');
    var $imgList = $(this).closest('div.upload-img-product-items');
    var $target = $(this).closest('div.uploaded-prev-imd');
    var dr_id = $('[name="id"]').val();

    if(image!="") {
        $.ajax({
            type: "POST",
            headers: {
                'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
            },
            enctype: 'multipart/form-data',
            url: '{{ url("doctor/doctors/removeEducationalCertificate")}}',
            data: { 'image': image, 'dr_id':dr_id},
            dataType: 'json',
            success: function(data) {
                if ( data['status'] == 0 ) {
                    var msg = data['message']||'Unable to remove attribute. Please try again later.';
                    App.alert([msg, 'warning']);
                } else {
                    App.alert(['Done! Image removed successfully.']);

                    $(this).parent().find('.uploaded-prev-imd').remove();
                    $target.remove();

                }
            }
        })
    }else {

        $target.remove();
        $(this).parent().find('.uploaded-prev-imd').remove();
    }
})

</script>

@stop