<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, shrink-to-fit=no">
    <title><?php echo e(config('app.name')); ?> | Vendor Login </title>
    <link rel="apple-touch-icon" sizes="76x76" href="<?php echo e(asset('')); ?>admin-assets/assets/img/favicon/apple-touch-icon.png">
    <link rel="icon" type="image/png" sizes="32x32" href="<?php echo e(asset('')); ?>admin-assets/assets/img/favicon/favicon-32x32.png">
    <link rel="icon" type="image/png" sizes="16x16" href="<?php echo e(asset('')); ?>admin-assets/assets/img/favicon/favicon-16x16.png">
    <link rel="manifest" href="<?php echo e(asset('')); ?>admin-assets/assets/img/favicon/site.webmanifest">
    <link rel="mask-icon" href="<?php echo e(asset('')); ?>admin-assets/assets/img/favicon/safari-pinned-tab.svg" color="#ac772b">
    <meta name="msapplication-TileColor" content="#da532c">
    <meta name="theme-color" content="#ffffff">

    <link href='https://fonts.googleapis.com/css?family=Open+Sans:400,600,700' rel='stylesheet' type='text/css'>
    <link href="<?php echo e(asset('admin-assets/bootstrap/css/bootstrap.min.css')); ?>" rel="stylesheet" type="text/css" />
    <link href="<?php echo e(asset('admin-assets/assets/css/plugins.css')); ?>" rel="stylesheet" type="text/css" />
    <link href="<?php echo e(asset('admin-assets/assets/css/users/login-3.css')); ?>" rel="stylesheet" type="text/css" />
    <link rel="stylesheet" type="text/css" href="<?php echo e(asset('admin-assets/plugins/jqvalidation/custom-jqBootstrapValidation.css')); ?>">
    <link href="<?php echo e(asset('admin-assets/plugins/notification/toastr/toastr.min.css')); ?>" rel="stylesheet" type="text/css" />

    <style type="text/css">
        .invalid-feedback{
            color: red;
            display: block;
        }
        .form-login{
            width: 100%;
            max-width: 100%;
        }
        .create-account-section{
            width: 100%;
            margin: auto;
            background: rgba( 0, 0, 0, 0.25 );
            /* box-shadow: 0 8px 32px 0 rgb(31 38 135 / 37%); */
            backdrop-filter: blur( 20px );
            -webkit-backdrop-filter: blur( 20px );
            border-radius: 10px;
            border: 1px solid #B27E30;
            min-height: 402px;
            padding: 30px
        }
        .create-account-section span{
            padding: 8px 12px;
            margin-bottom: 20px !important;
            color: #fff !important;
            background: linear-gradient(to right top, #af7a2d, #b58032, #ba8738, #c08d3d, #c59443, #cc9c48, #d2a34e, #d9ab53, #e3b65a, #ecc160, #f6cc67, #ffd76e);
            background-image: linear-gradient(to right top, #af7a2d, #b58032, #ba8738, #c08d3d, #c59443, #cc9c48, #d2a34e, #d9ab53, #e3b65a, #ecc160, #f6cc67, #ffd76e);
            box-shadow: none;
            border-radius: 50rem;
        }
        .create-account-section h3 {
            font-size: 32px;
            color: #fff;
            font-weight: 800;
        }
        .create-account-section p{
            color: #fff;
            line-height: 1.8;
        }
        .create-account-section a{

        }
    </style>

</head>
<body class="login" style="background: url('<?php echo e(asset('')); ?>admin-assets/assets/img/bg-1920x1080.jpg'); background-size: cover; background-position: center; background-repeat: no-repeat;">

    <div class="container">
        <div class="row">
            <div class="col-lg-7 mb-4">
                <form method="POST" class="form-login" action="<?php echo e(route('vendor.check_login')); ?>" >
                    <?php echo csrf_field(); ?>
                    <input type="hidden" name="admin" value="1">
                    <div class="row">
                        <div class="col-md-12 text-center mb-4">
                            <img alt="logo" src="<?php echo e(asset('')); ?>admin-assets/assets/img/logo.png" style="height: 60px;" class="theme-logo">
                        </div>
                        <div class="col-md-12">

                            <div class="mb-4">
                                <label for="inputEmail" style="color:#000 !important;" class="">Email address</label>
                                <input id="email" type="email" class="form-control <?php $__errorArgs = ['email'];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?> is-invalid <?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?>" name="email" value="<?php echo e(old('email')); ?>" required autocomplete="email" autofocus>
                                <?php $__errorArgs = ['email'];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?>
                                    <span class="invalid-feedback" role="alert">
                                        <strong><?php echo e($message); ?></strong>
                                    </span>
                                <?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?>
                            </div>

                        <div class="mb-4">
                            <label for="inputPassword" style="color:#000 !important;" class="">Password</label>
                                <input id="password" type="password" class="form-control <?php $__errorArgs = ['password'];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?> is-invalid <?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?>" name="password" required autocomplete="current-password">
                                <?php $__errorArgs = ['password'];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?>
                                    <span class="invalid-feedback" role="alert">
                                        <strong><?php echo e($message); ?></strong>
                                    </span>
                                <?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?>
                        </div>

                            <button type="submit" class="btn btn-gradient-dark btn-rounded btn-block ml-0">Login</button>

                            <!-- <div style="margin-top: 30px; text-align: center;">
                                <p class="text-muted"> Don't have an account? <b> <a href="<?php echo e(url('/register')); ?>" class="text-white"> SignUp </a> </b> </p>
                            </div> -->

                            <div style="margin-top: 30px; text-align: right;">
                                <p class="text-muted"> <a href="<?php echo e(url('/forgot-password')); ?>" class="text-white"> Forgot Password </a> </b> </p>
                            </div>

                        </div>
                    </div>
                </form>
            </div>

            <div class="col-lg-5 mb-4">
                    <div class="create-account-section">
                        <span>New Vendor</span>
                        <h3  class="mt-3 mb-2">Create an Account</h3>
                        <p class="mb-4">Whether you are a vendor or products supplier, LiveMarket's registration process is more easier than you think. Simply fill out the registration details to register with LiveMarket. Vendors can then provide their company name, products and services to be sold, and other important business details through the vendor panel.The biggest selling point?</p>
                        <a href="<?php echo e(url('/register')); ?>" class="btn btn-gradient-dark btn-rounded btn-block ml-0">Create an Accoount</a>
                    </div>
            </div>
        </div>
    </div>

    <!-- BEGIN GLOBAL MANDATORY SCRIPTS -->
    <script src="<?php echo e(asset('admin-assets/assets/js/libs/jquery-3.1.1.min.js')); ?>"></script>
    <script src="<?php echo e(asset('admin-assets/bootstrap/js/popper.min.js')); ?>"></script>
    <script src="<?php echo e(asset('admin-assets/bootstrap/js/bootstrap.min.js')); ?>"></script>
    <script src="<?php echo e(asset('admin-assets/plugins/jqvalidation/jqBootstrapValidation-1.3.7.min.js')); ?>"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.19.3/jquery.validate.js"></script>
    <script src="<?php echo e(asset('admin-assets/plugins/notification/toastr/toastr.min.js')); ?>"></script>
    <script>
        // Toaster options
        toastr.options = {
            "closeButton": false,
            "debug": false,
            "newestOnTop": false,
            "progressBar": false,
            "rtl": false,
            "positionClass": "toast-top-right",
            "preventDuplicates": false,
            "onclick": null,
            "showDuration": 300,
            "hideDuration": 1000,
            "timeOut": 2000,
            "extendedTimeOut": 1000,
            "showEasing": "swing",
            "hideEasing": "linear",
            "showMethod": "fadeIn",
            "hideMethod": "fadeOut"
        }

        $(document).ready(function() {
        <?php if(\Session::has('error') && \Session::get('error') != null): ?>
            toastr["error"]("<?php echo e(\Session::get('error')); ?>");
        <?php endif; ?>

        })
        $(".form-login").submit(function(e) {
            e.preventDefault();
        }).validate({
            rules: {
                username: {
                    required: true,
                    email: true
                },
                password: "required"
            },
            messages: {
                username: {
                    required: "Password field is required",
                    email: "Please enter valid email address"
                },
                password: "User name field is required"
            },
            submitHandler: function(form) {
                $.ajax({
                    type:'POST',
                    url: "<?php echo e(route("vendor.check_login")); ?>",
                    data:{
                        '_token': $('input[name=_token]').val(),
                        'email': $("#email").val(),
                        'password': $("#password").val(),
                        'timezone': Intl.DateTimeFormat().resolvedOptions().timeZone
                    },
                    success: function(response) {
                        if(response.success){
                            toastr["success"](response.message);
                            setTimeout(function(){
                                window.location.href = "<?php echo e(route("vendor.dashboard")); ?>";
                            }, 1000);

                        } else {
                            toastr["error"](response.message);
                        }
                    }
                });
            }
        });
    </script>

    <!-- END GLOBAL MANDATORY SCRIPTS -->
</body>
</html>
<?php /**PATH /home/a2itworld/public_html/medeeze_web/resources/views/vendor/login.blade.php ENDPATH**/ ?>